import{S as Mo,i as Fo,s as qo,e as a,k as u,w as T,t as i,M as Ao,c as r,d as s,m as g,a as n,x as w,h as l,b as d,G as t,g as f,y as $,q as y,o as j,B as x,v as Po,L as Us}from"../../chunks/vendor-hf-doc-builder.js";import{T as Co}from"../../chunks/Tip-hf-doc-builder.js";import{D as nt}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Ws}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ue}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Rs}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function So(E){let m,b,_,p,v;return p=new Ws({props:{code:`from transformers import TimesformerConfig, TimesformerModel

# Initializing a TimeSformer timesformer-base style configuration
configuration = TimesformerConfig()

# Initializing a model from the configuration
model = TimesformerModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TimesformerConfig, TimesformerModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a TimeSformer timesformer-base style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = TimesformerConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model from the configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TimesformerModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){m=a("p"),b=i("Example:"),_=u(),T(p.$$.fragment)},l(o){m=r(o,"P",{});var h=n(m);b=l(h,"Example:"),h.forEach(s),_=g(o),w(p.$$.fragment,o)},m(o,h){f(o,m,h),t(m,b),f(o,_,h),$(p,o,h),v=!0},p:Us,i(o){v||(y(p.$$.fragment,o),v=!0)},o(o){j(p.$$.fragment,o),v=!1},d(o){o&&s(m),o&&s(_),x(p,o)}}}function zo(E){let m,b,_,p,v;return{c(){m=a("p"),b=i("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=a("code"),p=i("Module"),v=i(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(o){m=r(o,"P",{});var h=n(m);b=l(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(h,"CODE",{});var F=n(_);p=l(F,"Module"),F.forEach(s),v=l(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(s)},m(o,h){f(o,m,h),t(m,b),t(m,_),t(_,p),t(m,v)},d(o){o&&s(m)}}}function Vo(E){let m,b,_,p,v;return p=new Ws({props:{code:`from decord import VideoReader, cpu
import numpy as np

from transformers import AutoFeatureExtractor, TimesformerModel
from huggingface_hub import hf_hub_download


def sample_frame_indices(clip_len, frame_sample_rate, seg_len):
    converted_len = int(clip_len * frame_sample_rate)
    end_idx = np.random.randint(converted_len, seg_len)
    start_idx = end_idx - converted_len
    indices = np.linspace(start_idx, end_idx, num=clip_len)
    indices = np.clip(indices, start_idx, end_idx - 1).astype(np.int64)
    return indices


# video clip consists of 300 frames (10 seconds at 30 FPS)
file_path = hf_hub_download(
    repo_id="nielsr/video-demo", filename="eating_spaghetti.mp4", repo_type="dataset"
)
videoreader = VideoReader(file_path, num_threads=1, ctx=cpu(0))

# sample 8 frames
videoreader.seek(0)
indices = sample_frame_indices(clip_len=8, frame_sample_rate=4, seg_len=len(videoreader))
video = videoreader.get_batch(indices).asnumpy()

feature_extractor = AutoFeatureExtractor.from_pretrained("MCG-NJU/videomae-base")
model = TimesformerModel.from_pretrained("facebook/timesformer-base-finetuned-k400")

# prepare video for the model
inputs = feature_extractor(list(video), return_tensors="pt")

# forward pass
outputs = model(**inputs)
last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> decord <span class="hljs-keyword">import</span> VideoReader, cpu
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoFeatureExtractor, TimesformerModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> hf_hub_download


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">sample_frame_indices</span>(<span class="hljs-params">clip_len, frame_sample_rate, seg_len</span>):
<span class="hljs-meta">... </span>    converted_len = <span class="hljs-built_in">int</span>(clip_len * frame_sample_rate)
<span class="hljs-meta">... </span>    end_idx = np.random.randint(converted_len, seg_len)
<span class="hljs-meta">... </span>    start_idx = end_idx - converted_len
<span class="hljs-meta">... </span>    indices = np.linspace(start_idx, end_idx, num=clip_len)
<span class="hljs-meta">... </span>    indices = np.clip(indices, start_idx, end_idx - <span class="hljs-number">1</span>).astype(np.int64)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> indices


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># video clip consists of 300 frames (10 seconds at 30 FPS)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>file_path = hf_hub_download(
<span class="hljs-meta">... </span>    repo_id=<span class="hljs-string">&quot;nielsr/video-demo&quot;</span>, filename=<span class="hljs-string">&quot;eating_spaghetti.mp4&quot;</span>, repo_type=<span class="hljs-string">&quot;dataset&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>videoreader = VideoReader(file_path, num_threads=<span class="hljs-number">1</span>, ctx=cpu(<span class="hljs-number">0</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># sample 8 frames</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>videoreader.seek(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>indices = sample_frame_indices(clip_len=<span class="hljs-number">8</span>, frame_sample_rate=<span class="hljs-number">4</span>, seg_len=<span class="hljs-built_in">len</span>(videoreader))
<span class="hljs-meta">&gt;&gt;&gt; </span>video = videoreader.get_batch(indices).asnumpy()

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;MCG-NJU/videomae-base&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TimesformerModel.from_pretrained(<span class="hljs-string">&quot;facebook/timesformer-base-finetuned-k400&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prepare video for the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = feature_extractor(<span class="hljs-built_in">list</span>(video), return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">1568</span>, <span class="hljs-number">768</span>]`}}),{c(){m=a("p"),b=i("Examples:"),_=u(),T(p.$$.fragment)},l(o){m=r(o,"P",{});var h=n(m);b=l(h,"Examples:"),h.forEach(s),_=g(o),w(p.$$.fragment,o)},m(o,h){f(o,m,h),t(m,b),f(o,_,h),$(p,o,h),v=!0},p:Us,i(o){v||(y(p.$$.fragment,o),v=!0)},o(o){j(p.$$.fragment,o),v=!1},d(o){o&&s(m),o&&s(_),x(p,o)}}}function Io(E){let m,b,_,p,v;return{c(){m=a("p"),b=i("Although the recipe for forward pass needs to be defined within this function, one should call the "),_=a("code"),p=i("Module"),v=i(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(o){m=r(o,"P",{});var h=n(m);b=l(h,"Although the recipe for forward pass needs to be defined within this function, one should call the "),_=r(h,"CODE",{});var F=n(_);p=l(F,"Module"),F.forEach(s),v=l(h,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),h.forEach(s)},m(o,h){f(o,m,h),t(m,b),t(m,_),t(_,p),t(m,v)},d(o){o&&s(m)}}}function No(E){let m,b,_,p,v;return p=new Ws({props:{code:`from decord import VideoReader, cpu
import torch
import numpy as np

from transformers import AutoFeatureExtractor, TimesformerForVideoClassification
from huggingface_hub import hf_hub_download

np.random.seed(0)


def sample_frame_indices(clip_len, frame_sample_rate, seg_len):
    converted_len = int(clip_len * frame_sample_rate)
    end_idx = np.random.randint(converted_len, seg_len)
    start_idx = end_idx - converted_len
    indices = np.linspace(start_idx, end_idx, num=clip_len)
    indices = np.clip(indices, start_idx, end_idx - 1).astype(np.int64)
    return indices


# video clip consists of 300 frames (10 seconds at 30 FPS)
file_path = hf_hub_download(
    repo_id="nielsr/video-demo", filename="eating_spaghetti.mp4", repo_type="dataset"
)
videoreader = VideoReader(file_path, num_threads=1, ctx=cpu(0))

# sample 8 frames
videoreader.seek(0)
indices = sample_frame_indices(clip_len=8, frame_sample_rate=4, seg_len=len(videoreader))
video = videoreader.get_batch(indices).asnumpy()

feature_extractor = AutoFeatureExtractor.from_pretrained("MCG-NJU/videomae-base-finetuned-kinetics")
model = TimesformerForVideoClassification.from_pretrained("facebook/timesformer-base-finetuned-k400")

inputs = feature_extractor(list(video), return_tensors="pt")

with torch.no_grad():
    outputs = model(**inputs)
    logits = outputs.logits

# model predicts one of the 400 Kinetics-400 classes
predicted_label = logits.argmax(-1).item()
print(model.config.id2label[predicted_label])`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> decord <span class="hljs-keyword">import</span> VideoReader, cpu
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoFeatureExtractor, TimesformerForVideoClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> hf_hub_download

<span class="hljs-meta">&gt;&gt;&gt; </span>np.random.seed(<span class="hljs-number">0</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">sample_frame_indices</span>(<span class="hljs-params">clip_len, frame_sample_rate, seg_len</span>):
<span class="hljs-meta">... </span>    converted_len = <span class="hljs-built_in">int</span>(clip_len * frame_sample_rate)
<span class="hljs-meta">... </span>    end_idx = np.random.randint(converted_len, seg_len)
<span class="hljs-meta">... </span>    start_idx = end_idx - converted_len
<span class="hljs-meta">... </span>    indices = np.linspace(start_idx, end_idx, num=clip_len)
<span class="hljs-meta">... </span>    indices = np.clip(indices, start_idx, end_idx - <span class="hljs-number">1</span>).astype(np.int64)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> indices


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># video clip consists of 300 frames (10 seconds at 30 FPS)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>file_path = hf_hub_download(
<span class="hljs-meta">... </span>    repo_id=<span class="hljs-string">&quot;nielsr/video-demo&quot;</span>, filename=<span class="hljs-string">&quot;eating_spaghetti.mp4&quot;</span>, repo_type=<span class="hljs-string">&quot;dataset&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>videoreader = VideoReader(file_path, num_threads=<span class="hljs-number">1</span>, ctx=cpu(<span class="hljs-number">0</span>))

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># sample 8 frames</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>videoreader.seek(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>indices = sample_frame_indices(clip_len=<span class="hljs-number">8</span>, frame_sample_rate=<span class="hljs-number">4</span>, seg_len=<span class="hljs-built_in">len</span>(videoreader))
<span class="hljs-meta">&gt;&gt;&gt; </span>video = videoreader.get_batch(indices).asnumpy()

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoFeatureExtractor.from_pretrained(<span class="hljs-string">&quot;MCG-NJU/videomae-base-finetuned-kinetics&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TimesformerForVideoClassification.from_pretrained(<span class="hljs-string">&quot;facebook/timesformer-base-finetuned-k400&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = feature_extractor(<span class="hljs-built_in">list</span>(video), return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)
<span class="hljs-meta">... </span>    logits = outputs.logits

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># model predicts one of the 400 Kinetics-400 classes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_label = logits.argmax(-<span class="hljs-number">1</span>).item()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.config.id2label[predicted_label])
eating spaghetti`}}),{c(){m=a("p"),b=i("Examples:"),_=u(),T(p.$$.fragment)},l(o){m=r(o,"P",{});var h=n(m);b=l(h,"Examples:"),h.forEach(s),_=g(o),w(p.$$.fragment,o)},m(o,h){f(o,m,h),t(m,b),f(o,_,h),$(p,o,h),v=!0},p:Us,i(o){v||(y(p.$$.fragment,o),v=!0)},o(o){j(p.$$.fragment,o),v=!1},d(o){o&&s(m),o&&s(_),x(p,o)}}}function Oo(E){let m,b,_,p,v,o,h,F,qt,it,S,U,We,oe,At,He,Pt,lt,W,St,ae,zt,Vt,dt,xe,It,mt,ke,re,Nt,ne,Ot,Dt,ct,Ee,Lt,pt,Ce,Rt,ft,P,Ut,ie,Wt,Ht,le,Bt,Kt,ht,z,H,Be,de,Gt,Ke,Jt,ut,Me,Ge,Fe,Yt,gt,V,B,Je,me,Qt,Ye,Xt,_t,k,ce,Zt,I,es,qe,ts,ss,pe,os,as,rs,N,ns,Ae,is,ls,Pe,ds,ms,cs,K,vt,O,G,Qe,fe,ps,Xe,fs,bt,q,he,hs,ue,us,ge,gs,_s,vs,C,_e,bs,D,Ts,Se,ws,$s,Ze,ys,js,xs,J,ks,Y,Tt,L,Q,et,ve,Es,tt,Cs,wt,A,be,Ms,Te,Fs,we,qs,As,Ps,M,$e,Ss,R,zs,ze,Vs,Is,st,Ns,Os,Ds,X,Ls,Z,$t;return o=new Ue({}),oe=new Ue({}),de=new Ue({}),me=new Ue({}),ce=new nt({props:{name:"class transformers.TimesformerConfig",anchor:"transformers.TimesformerConfig",parameters:[{name:"image_size",val:" = 224"},{name:"patch_size",val:" = 16"},{name:"num_channels",val:" = 3"},{name:"num_frames",val:" = 8"},{name:"hidden_size",val:" = 768"},{name:"num_hidden_layers",val:" = 12"},{name:"num_attention_heads",val:" = 12"},{name:"intermediate_size",val:" = 3072"},{name:"hidden_act",val:" = 'gelu'"},{name:"hidden_dropout_prob",val:" = 0.0"},{name:"attention_probs_dropout_prob",val:" = 0.0"},{name:"initializer_range",val:" = 0.02"},{name:"layer_norm_eps",val:" = 1e-06"},{name:"qkv_bias",val:" = True"},{name:"attention_type",val:" = 'divided_space_time'"},{name:"drop_path_rate",val:" = 0"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TimesformerConfig.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 224) &#x2014;
The size (resolution) of each image.`,name:"image_size"},{anchor:"transformers.TimesformerConfig.patch_size",description:`<strong>patch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
The size (resolution) of each patch.`,name:"patch_size"},{anchor:"transformers.TimesformerConfig.num_channels",description:`<strong>num_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of input channels.`,name:"num_channels"},{anchor:"transformers.TimesformerConfig.num_frames",description:`<strong>num_frames</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
The number of frames in each video.`,name:"num_frames"},{anchor:"transformers.TimesformerConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 768) &#x2014;
Dimensionality of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.TimesformerConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.TimesformerConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 12) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.TimesformerConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 3072) &#x2014;
Dimensionality of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.TimesformerConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;gelu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.TimesformerConfig.hidden_dropout_prob",description:`<strong>hidden_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout probabilitiy for all fully connected layers in the embeddings, encoder, and pooler.`,name:"hidden_dropout_prob"},{anchor:"transformers.TimesformerConfig.attention_probs_dropout_prob",description:`<strong>attention_probs_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_probs_dropout_prob"},{anchor:"transformers.TimesformerConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.TimesformerConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-6) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.TimesformerConfig.qkv_bias",description:`<strong>qkv_bias</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to add a bias to the queries, keys and values.`,name:"qkv_bias"},{anchor:"transformers.TimesformerConfig.attention_type",description:`<strong>attention_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;divided_space_time&quot;</code>) &#x2014;
The attention type to use. Must be one of <code>&quot;divided_space_time&quot;</code>, <code>&quot;space_only&quot;</code>, <code>&quot;joint_space_time&quot;</code>.`,name:"attention_type"},{anchor:"transformers.TimesformerConfig.drop_path_rate",description:`<strong>drop_path_rate</strong> (<code>float</code>, <em>optional</em>, defaults to 0) &#x2014;
The dropout ratio for stochastic depth.`,name:"drop_path_rate"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/timesformer/configuration_timesformer.py#L28"}}),K=new Rs({props:{anchor:"transformers.TimesformerConfig.example",$$slots:{default:[So]},$$scope:{ctx:E}}}),fe=new Ue({}),he=new nt({props:{name:"class transformers.TimesformerModel",anchor:"transformers.TimesformerModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.TimesformerModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/timesformer#transformers.TimesformerConfig">TimesformerConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/timesformer/modeling_timesformer.py#L534"}}),_e=new nt({props:{name:"forward",anchor:"transformers.TimesformerModel.forward",parameters:[{name:"pixel_values",val:""},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.TimesformerModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoFeatureExtractor">AutoFeatureExtractor</a>. See
<a href="/docs/transformers/main/en/model_doc/vit#transformers.ViTFeatureExtractor.__call__">VideoMAEFeatureExtractor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.TimesformerModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TimesformerModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TimesformerModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/timesformer/modeling_timesformer.py#L558",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.BaseModelOutput"
>transformers.modeling_outputs.BaseModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/timesformer#transformers.TimesformerConfig"
>TimesformerConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.BaseModelOutput"
>transformers.modeling_outputs.BaseModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),J=new Co({props:{$$slots:{default:[zo]},$$scope:{ctx:E}}}),Y=new Rs({props:{anchor:"transformers.TimesformerModel.forward.example",$$slots:{default:[Vo]},$$scope:{ctx:E}}}),ve=new Ue({}),be=new nt({props:{name:"class transformers.TimesformerForVideoClassification",anchor:"transformers.TimesformerForVideoClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.TimesformerForVideoClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/timesformer#transformers.TimesformerConfig">TimesformerConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/timesformer/modeling_timesformer.py#L645"}}),$e=new nt({props:{name:"forward",anchor:"transformers.TimesformerForVideoClassification.forward",parameters:[{name:"pixel_values",val:": typing.Optional[torch.Tensor] = None"},{name:"labels",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.TimesformerForVideoClassification.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_frames, num_channels, height, width)</code>) &#x2014;
Pixel values. Pixel values can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoFeatureExtractor">AutoFeatureExtractor</a>. See
<a href="/docs/transformers/main/en/model_doc/vit#transformers.ViTFeatureExtractor.__call__">VideoMAEFeatureExtractor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.TimesformerForVideoClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.TimesformerForVideoClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.TimesformerForVideoClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.TimesformerForVideoClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the image classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/timesformer/modeling_timesformer.py#L658",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.ImageClassifierOutput"
>transformers.modeling_outputs.ImageClassifierOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/timesformer#transformers.TimesformerConfig"
>TimesformerConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each stage) of shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states
(also called feature maps) of the model at the output of each stage.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, patch_size, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.ImageClassifierOutput"
>transformers.modeling_outputs.ImageClassifierOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),X=new Co({props:{$$slots:{default:[Io]},$$scope:{ctx:E}}}),Z=new Rs({props:{anchor:"transformers.TimesformerForVideoClassification.forward.example",$$slots:{default:[No]},$$scope:{ctx:E}}}),{c(){m=a("meta"),b=u(),_=a("h1"),p=a("a"),v=a("span"),T(o.$$.fragment),h=u(),F=a("span"),qt=i("TimeSformer"),it=u(),S=a("h2"),U=a("a"),We=a("span"),T(oe.$$.fragment),At=u(),He=a("span"),Pt=i("Overview"),lt=u(),W=a("p"),St=i("The TimeSformer model was proposed in "),ae=a("a"),zt=i("TimeSformer: Is Space-Time Attention All You Need for Video Understanding?"),Vt=i(` by Facebook Research.
This work is a milestone in action-recognition field being the first video transformer. It inspired many transformer based video understanding and classification papers.`),dt=u(),xe=a("p"),It=i("The abstract from the paper is the following:"),mt=u(),ke=a("p"),re=a("em"),Nt=i("We present a convolution-free approach to video classification built exclusively on self-attention over space and time. Our method, named \u201CTimeSformer,\u201D adapts the standard Transformer architecture to video by enabling spatiotemporal feature learning directly from a sequence of frame-level patches. Our experimental study compares different self-attention schemes and suggests that \u201Cdivided attention,\u201D where temporal attention and spatial attention are separately applied within each block, leads to the best video classification accuracy among the design choices considered. Despite the radically new design, TimeSformer achieves state-of-the-art results on several action recognition benchmarks, including the best reported accuracy on Kinetics-400 and Kinetics-600. Finally, compared to 3D convolutional networks, our model is faster to train, it can achieve dramatically higher test efficiency (at a small drop in accuracy), and it can also be applied to much longer video clips (over one minute long). Code and models are available at: "),ne=a("a"),Ot=i("this https URL"),Dt=i("."),ct=u(),Ee=a("p"),Lt=i("Tips:"),pt=u(),Ce=a("p"),Rt=i("There are many pretrained variants. Select your pretrained model based on the dataset it is trained on. Moreover, the number of input frames per clip changes based on the model size so you should consider this parameter while selecting your pretrained model."),ft=u(),P=a("p"),Ut=i("This model was contributed by "),ie=a("a"),Wt=i("fcakyon"),Ht=i(`.
The original code can be found `),le=a("a"),Bt=i("here"),Kt=i("."),ht=u(),z=a("h2"),H=a("a"),Be=a("span"),T(de.$$.fragment),Gt=u(),Ke=a("span"),Jt=i("Documentation resources"),ut=u(),Me=a("ul"),Ge=a("li"),Fe=a("a"),Yt=i("Video classification task guide"),gt=u(),V=a("h2"),B=a("a"),Je=a("span"),T(me.$$.fragment),Qt=u(),Ye=a("span"),Xt=i("TimesformerConfig"),_t=u(),k=a("div"),T(ce.$$.fragment),Zt=u(),I=a("p"),es=i("This is the configuration class to store the configuration of a "),qe=a("a"),ts=i("TimesformerModel"),ss=i(`. It is used to instantiate a
TimeSformer model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the TimeSformer
`),pe=a("a"),os=i("facebook/timesformer"),as=i(" architecture."),rs=u(),N=a("p"),ns=i("Configuration objects inherit from "),Ae=a("a"),is=i("PretrainedConfig"),ls=i(` and can be used to control the model outputs. Read the
documentation from `),Pe=a("a"),ds=i("PretrainedConfig"),ms=i(" for more information."),cs=u(),T(K.$$.fragment),vt=u(),O=a("h2"),G=a("a"),Qe=a("span"),T(fe.$$.fragment),ps=u(),Xe=a("span"),fs=i("TimesformerModel"),bt=u(),q=a("div"),T(he.$$.fragment),hs=u(),ue=a("p"),us=i(`The bare TimeSformer Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),ge=a("a"),gs=i("torch.nn.Module"),_s=i(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),vs=u(),C=a("div"),T(_e.$$.fragment),bs=u(),D=a("p"),Ts=i("The "),Se=a("a"),ws=i("TimesformerModel"),$s=i(" forward method, overrides the "),Ze=a("code"),ys=i("__call__"),js=i(" special method."),xs=u(),T(J.$$.fragment),ks=u(),T(Y.$$.fragment),Tt=u(),L=a("h2"),Q=a("a"),et=a("span"),T(ve.$$.fragment),Es=u(),tt=a("span"),Cs=i("TimesformerForVideoClassification"),wt=u(),A=a("div"),T(be.$$.fragment),Ms=u(),Te=a("p"),Fs=i(`TimeSformer Model transformer with a video classification head on top (a linear layer on top of the final hidden state
of the [CLS] token) e.g. for ImageNet.
This model is a PyTorch `),we=a("a"),qs=i("torch.nn.Module"),As=i(` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Ps=u(),M=a("div"),T($e.$$.fragment),Ss=u(),R=a("p"),zs=i("The "),ze=a("a"),Vs=i("TimesformerForVideoClassification"),Is=i(" forward method, overrides the "),st=a("code"),Ns=i("__call__"),Os=i(" special method."),Ds=u(),T(X.$$.fragment),Ls=u(),T(Z.$$.fragment),this.h()},l(e){const c=Ao('[data-svelte="svelte-1phssyn"]',document.head);m=r(c,"META",{name:!0,content:!0}),c.forEach(s),b=g(e),_=r(e,"H1",{class:!0});var ye=n(_);p=r(ye,"A",{id:!0,class:!0,href:!0});var ot=n(p);v=r(ot,"SPAN",{});var at=n(v);w(o.$$.fragment,at),at.forEach(s),ot.forEach(s),h=g(ye),F=r(ye,"SPAN",{});var rt=n(F);qt=l(rt,"TimeSformer"),rt.forEach(s),ye.forEach(s),it=g(e),S=r(e,"H2",{class:!0});var je=n(S);U=r(je,"A",{id:!0,class:!0,href:!0});var Hs=n(U);We=r(Hs,"SPAN",{});var Bs=n(We);w(oe.$$.fragment,Bs),Bs.forEach(s),Hs.forEach(s),At=g(je),He=r(je,"SPAN",{});var Ks=n(He);Pt=l(Ks,"Overview"),Ks.forEach(s),je.forEach(s),lt=g(e),W=r(e,"P",{});var yt=n(W);St=l(yt,"The TimeSformer model was proposed in "),ae=r(yt,"A",{href:!0,rel:!0});var Gs=n(ae);zt=l(Gs,"TimeSformer: Is Space-Time Attention All You Need for Video Understanding?"),Gs.forEach(s),Vt=l(yt,` by Facebook Research.
This work is a milestone in action-recognition field being the first video transformer. It inspired many transformer based video understanding and classification papers.`),yt.forEach(s),dt=g(e),xe=r(e,"P",{});var Js=n(xe);It=l(Js,"The abstract from the paper is the following:"),Js.forEach(s),mt=g(e),ke=r(e,"P",{});var Ys=n(ke);re=r(Ys,"EM",{});var jt=n(re);Nt=l(jt,"We present a convolution-free approach to video classification built exclusively on self-attention over space and time. Our method, named \u201CTimeSformer,\u201D adapts the standard Transformer architecture to video by enabling spatiotemporal feature learning directly from a sequence of frame-level patches. Our experimental study compares different self-attention schemes and suggests that \u201Cdivided attention,\u201D where temporal attention and spatial attention are separately applied within each block, leads to the best video classification accuracy among the design choices considered. Despite the radically new design, TimeSformer achieves state-of-the-art results on several action recognition benchmarks, including the best reported accuracy on Kinetics-400 and Kinetics-600. Finally, compared to 3D convolutional networks, our model is faster to train, it can achieve dramatically higher test efficiency (at a small drop in accuracy), and it can also be applied to much longer video clips (over one minute long). Code and models are available at: "),ne=r(jt,"A",{href:!0,rel:!0});var Qs=n(ne);Ot=l(Qs,"this https URL"),Qs.forEach(s),Dt=l(jt,"."),jt.forEach(s),Ys.forEach(s),ct=g(e),Ee=r(e,"P",{});var Xs=n(Ee);Lt=l(Xs,"Tips:"),Xs.forEach(s),pt=g(e),Ce=r(e,"P",{});var Zs=n(Ce);Rt=l(Zs,"There are many pretrained variants. Select your pretrained model based on the dataset it is trained on. Moreover, the number of input frames per clip changes based on the model size so you should consider this parameter while selecting your pretrained model."),Zs.forEach(s),ft=g(e),P=r(e,"P",{});var Ve=n(P);Ut=l(Ve,"This model was contributed by "),ie=r(Ve,"A",{href:!0,rel:!0});var eo=n(ie);Wt=l(eo,"fcakyon"),eo.forEach(s),Ht=l(Ve,`.
The original code can be found `),le=r(Ve,"A",{href:!0,rel:!0});var to=n(le);Bt=l(to,"here"),to.forEach(s),Kt=l(Ve,"."),Ve.forEach(s),ht=g(e),z=r(e,"H2",{class:!0});var xt=n(z);H=r(xt,"A",{id:!0,class:!0,href:!0});var so=n(H);Be=r(so,"SPAN",{});var oo=n(Be);w(de.$$.fragment,oo),oo.forEach(s),so.forEach(s),Gt=g(xt),Ke=r(xt,"SPAN",{});var ao=n(Ke);Jt=l(ao,"Documentation resources"),ao.forEach(s),xt.forEach(s),ut=g(e),Me=r(e,"UL",{});var ro=n(Me);Ge=r(ro,"LI",{});var no=n(Ge);Fe=r(no,"A",{href:!0});var io=n(Fe);Yt=l(io,"Video classification task guide"),io.forEach(s),no.forEach(s),ro.forEach(s),gt=g(e),V=r(e,"H2",{class:!0});var kt=n(V);B=r(kt,"A",{id:!0,class:!0,href:!0});var lo=n(B);Je=r(lo,"SPAN",{});var mo=n(Je);w(me.$$.fragment,mo),mo.forEach(s),lo.forEach(s),Qt=g(kt),Ye=r(kt,"SPAN",{});var co=n(Ye);Xt=l(co,"TimesformerConfig"),co.forEach(s),kt.forEach(s),_t=g(e),k=r(e,"DIV",{class:!0});var ee=n(k);w(ce.$$.fragment,ee),Zt=g(ee),I=r(ee,"P",{});var Ie=n(I);es=l(Ie,"This is the configuration class to store the configuration of a "),qe=r(Ie,"A",{href:!0});var po=n(qe);ts=l(po,"TimesformerModel"),po.forEach(s),ss=l(Ie,`. It is used to instantiate a
TimeSformer model according to the specified arguments, defining the model architecture. Instantiating a
configuration with the defaults will yield a similar configuration to that of the TimeSformer
`),pe=r(Ie,"A",{href:!0,rel:!0});var fo=n(pe);os=l(fo,"facebook/timesformer"),fo.forEach(s),as=l(Ie," architecture."),Ie.forEach(s),rs=g(ee),N=r(ee,"P",{});var Ne=n(N);ns=l(Ne,"Configuration objects inherit from "),Ae=r(Ne,"A",{href:!0});var ho=n(Ae);is=l(ho,"PretrainedConfig"),ho.forEach(s),ls=l(Ne,` and can be used to control the model outputs. Read the
documentation from `),Pe=r(Ne,"A",{href:!0});var uo=n(Pe);ds=l(uo,"PretrainedConfig"),uo.forEach(s),ms=l(Ne," for more information."),Ne.forEach(s),cs=g(ee),w(K.$$.fragment,ee),ee.forEach(s),vt=g(e),O=r(e,"H2",{class:!0});var Et=n(O);G=r(Et,"A",{id:!0,class:!0,href:!0});var go=n(G);Qe=r(go,"SPAN",{});var _o=n(Qe);w(fe.$$.fragment,_o),_o.forEach(s),go.forEach(s),ps=g(Et),Xe=r(Et,"SPAN",{});var vo=n(Xe);fs=l(vo,"TimesformerModel"),vo.forEach(s),Et.forEach(s),bt=g(e),q=r(e,"DIV",{class:!0});var Oe=n(q);w(he.$$.fragment,Oe),hs=g(Oe),ue=r(Oe,"P",{});var Ct=n(ue);us=l(Ct,`The bare TimeSformer Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),ge=r(Ct,"A",{href:!0,rel:!0});var bo=n(ge);gs=l(bo,"torch.nn.Module"),bo.forEach(s),_s=l(Ct,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Ct.forEach(s),vs=g(Oe),C=r(Oe,"DIV",{class:!0});var te=n(C);w(_e.$$.fragment,te),bs=g(te),D=r(te,"P",{});var De=n(D);Ts=l(De,"The "),Se=r(De,"A",{href:!0});var To=n(Se);ws=l(To,"TimesformerModel"),To.forEach(s),$s=l(De," forward method, overrides the "),Ze=r(De,"CODE",{});var wo=n(Ze);ys=l(wo,"__call__"),wo.forEach(s),js=l(De," special method."),De.forEach(s),xs=g(te),w(J.$$.fragment,te),ks=g(te),w(Y.$$.fragment,te),te.forEach(s),Oe.forEach(s),Tt=g(e),L=r(e,"H2",{class:!0});var Mt=n(L);Q=r(Mt,"A",{id:!0,class:!0,href:!0});var $o=n(Q);et=r($o,"SPAN",{});var yo=n(et);w(ve.$$.fragment,yo),yo.forEach(s),$o.forEach(s),Es=g(Mt),tt=r(Mt,"SPAN",{});var jo=n(tt);Cs=l(jo,"TimesformerForVideoClassification"),jo.forEach(s),Mt.forEach(s),wt=g(e),A=r(e,"DIV",{class:!0});var Le=n(A);w(be.$$.fragment,Le),Ms=g(Le),Te=r(Le,"P",{});var Ft=n(Te);Fs=l(Ft,`TimeSformer Model transformer with a video classification head on top (a linear layer on top of the final hidden state
of the [CLS] token) e.g. for ImageNet.
This model is a PyTorch `),we=r(Ft,"A",{href:!0,rel:!0});var xo=n(we);qs=l(xo,"torch.nn.Module"),xo.forEach(s),As=l(Ft,` subclass. Use it
as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Ft.forEach(s),Ps=g(Le),M=r(Le,"DIV",{class:!0});var se=n(M);w($e.$$.fragment,se),Ss=g(se),R=r(se,"P",{});var Re=n(R);zs=l(Re,"The "),ze=r(Re,"A",{href:!0});var ko=n(ze);Vs=l(ko,"TimesformerForVideoClassification"),ko.forEach(s),Is=l(Re," forward method, overrides the "),st=r(Re,"CODE",{});var Eo=n(st);Ns=l(Eo,"__call__"),Eo.forEach(s),Os=l(Re," special method."),Re.forEach(s),Ds=g(se),w(X.$$.fragment,se),Ls=g(se),w(Z.$$.fragment,se),se.forEach(s),Le.forEach(s),this.h()},h(){d(m,"name","hf:doc:metadata"),d(m,"content",JSON.stringify(Do)),d(p,"id","timesformer"),d(p,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(p,"href","#timesformer"),d(_,"class","relative group"),d(U,"id","overview"),d(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(U,"href","#overview"),d(S,"class","relative group"),d(ae,"href","https://arxiv.org/abs/2102.05095"),d(ae,"rel","nofollow"),d(ne,"href","https://github.com/facebookresearch/TimeSformer"),d(ne,"rel","nofollow"),d(ie,"href","https://huggingface.co/fcakyon"),d(ie,"rel","nofollow"),d(le,"href","https://github.com/facebookresearch/TimeSformer"),d(le,"rel","nofollow"),d(H,"id","documentation-resources"),d(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(H,"href","#documentation-resources"),d(z,"class","relative group"),d(Fe,"href","./tasks/video_classification"),d(B,"id","transformers.TimesformerConfig"),d(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(B,"href","#transformers.TimesformerConfig"),d(V,"class","relative group"),d(qe,"href","/docs/transformers/main/en/model_doc/timesformer#transformers.TimesformerModel"),d(pe,"href","https://huggingface.co/facebook/timesformer-base-finetuned-k600"),d(pe,"rel","nofollow"),d(Ae,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),d(Pe,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),d(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(G,"id","transformers.TimesformerModel"),d(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(G,"href","#transformers.TimesformerModel"),d(O,"class","relative group"),d(ge,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(ge,"rel","nofollow"),d(Se,"href","/docs/transformers/main/en/model_doc/timesformer#transformers.TimesformerModel"),d(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(Q,"id","transformers.TimesformerForVideoClassification"),d(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Q,"href","#transformers.TimesformerForVideoClassification"),d(L,"class","relative group"),d(we,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),d(we,"rel","nofollow"),d(ze,"href","/docs/transformers/main/en/model_doc/timesformer#transformers.TimesformerForVideoClassification"),d(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),d(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,c){t(document.head,m),f(e,b,c),f(e,_,c),t(_,p),t(p,v),$(o,v,null),t(_,h),t(_,F),t(F,qt),f(e,it,c),f(e,S,c),t(S,U),t(U,We),$(oe,We,null),t(S,At),t(S,He),t(He,Pt),f(e,lt,c),f(e,W,c),t(W,St),t(W,ae),t(ae,zt),t(W,Vt),f(e,dt,c),f(e,xe,c),t(xe,It),f(e,mt,c),f(e,ke,c),t(ke,re),t(re,Nt),t(re,ne),t(ne,Ot),t(re,Dt),f(e,ct,c),f(e,Ee,c),t(Ee,Lt),f(e,pt,c),f(e,Ce,c),t(Ce,Rt),f(e,ft,c),f(e,P,c),t(P,Ut),t(P,ie),t(ie,Wt),t(P,Ht),t(P,le),t(le,Bt),t(P,Kt),f(e,ht,c),f(e,z,c),t(z,H),t(H,Be),$(de,Be,null),t(z,Gt),t(z,Ke),t(Ke,Jt),f(e,ut,c),f(e,Me,c),t(Me,Ge),t(Ge,Fe),t(Fe,Yt),f(e,gt,c),f(e,V,c),t(V,B),t(B,Je),$(me,Je,null),t(V,Qt),t(V,Ye),t(Ye,Xt),f(e,_t,c),f(e,k,c),$(ce,k,null),t(k,Zt),t(k,I),t(I,es),t(I,qe),t(qe,ts),t(I,ss),t(I,pe),t(pe,os),t(I,as),t(k,rs),t(k,N),t(N,ns),t(N,Ae),t(Ae,is),t(N,ls),t(N,Pe),t(Pe,ds),t(N,ms),t(k,cs),$(K,k,null),f(e,vt,c),f(e,O,c),t(O,G),t(G,Qe),$(fe,Qe,null),t(O,ps),t(O,Xe),t(Xe,fs),f(e,bt,c),f(e,q,c),$(he,q,null),t(q,hs),t(q,ue),t(ue,us),t(ue,ge),t(ge,gs),t(ue,_s),t(q,vs),t(q,C),$(_e,C,null),t(C,bs),t(C,D),t(D,Ts),t(D,Se),t(Se,ws),t(D,$s),t(D,Ze),t(Ze,ys),t(D,js),t(C,xs),$(J,C,null),t(C,ks),$(Y,C,null),f(e,Tt,c),f(e,L,c),t(L,Q),t(Q,et),$(ve,et,null),t(L,Es),t(L,tt),t(tt,Cs),f(e,wt,c),f(e,A,c),$(be,A,null),t(A,Ms),t(A,Te),t(Te,Fs),t(Te,we),t(we,qs),t(Te,As),t(A,Ps),t(A,M),$($e,M,null),t(M,Ss),t(M,R),t(R,zs),t(R,ze),t(ze,Vs),t(R,Is),t(R,st),t(st,Ns),t(R,Os),t(M,Ds),$(X,M,null),t(M,Ls),$(Z,M,null),$t=!0},p(e,[c]){const ye={};c&2&&(ye.$$scope={dirty:c,ctx:e}),K.$set(ye);const ot={};c&2&&(ot.$$scope={dirty:c,ctx:e}),J.$set(ot);const at={};c&2&&(at.$$scope={dirty:c,ctx:e}),Y.$set(at);const rt={};c&2&&(rt.$$scope={dirty:c,ctx:e}),X.$set(rt);const je={};c&2&&(je.$$scope={dirty:c,ctx:e}),Z.$set(je)},i(e){$t||(y(o.$$.fragment,e),y(oe.$$.fragment,e),y(de.$$.fragment,e),y(me.$$.fragment,e),y(ce.$$.fragment,e),y(K.$$.fragment,e),y(fe.$$.fragment,e),y(he.$$.fragment,e),y(_e.$$.fragment,e),y(J.$$.fragment,e),y(Y.$$.fragment,e),y(ve.$$.fragment,e),y(be.$$.fragment,e),y($e.$$.fragment,e),y(X.$$.fragment,e),y(Z.$$.fragment,e),$t=!0)},o(e){j(o.$$.fragment,e),j(oe.$$.fragment,e),j(de.$$.fragment,e),j(me.$$.fragment,e),j(ce.$$.fragment,e),j(K.$$.fragment,e),j(fe.$$.fragment,e),j(he.$$.fragment,e),j(_e.$$.fragment,e),j(J.$$.fragment,e),j(Y.$$.fragment,e),j(ve.$$.fragment,e),j(be.$$.fragment,e),j($e.$$.fragment,e),j(X.$$.fragment,e),j(Z.$$.fragment,e),$t=!1},d(e){s(m),e&&s(b),e&&s(_),x(o),e&&s(it),e&&s(S),x(oe),e&&s(lt),e&&s(W),e&&s(dt),e&&s(xe),e&&s(mt),e&&s(ke),e&&s(ct),e&&s(Ee),e&&s(pt),e&&s(Ce),e&&s(ft),e&&s(P),e&&s(ht),e&&s(z),x(de),e&&s(ut),e&&s(Me),e&&s(gt),e&&s(V),x(me),e&&s(_t),e&&s(k),x(ce),x(K),e&&s(vt),e&&s(O),x(fe),e&&s(bt),e&&s(q),x(he),x(_e),x(J),x(Y),e&&s(Tt),e&&s(L),x(ve),e&&s(wt),e&&s(A),x(be),x($e),x(X),x(Z)}}}const Do={local:"timesformer",sections:[{local:"overview",title:"Overview"},{local:"documentation-resources",title:"Documentation resources"},{local:"transformers.TimesformerConfig",title:"TimesformerConfig"},{local:"transformers.TimesformerModel",title:"TimesformerModel"},{local:"transformers.TimesformerForVideoClassification",title:"TimesformerForVideoClassification"}],title:"TimeSformer"};function Lo(E){return Po(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Go extends Mo{constructor(m){super();Fo(this,m,Lo,Oo,qo,{})}}export{Go as default,Do as metadata};
