import{S as Y_,i as Z_,s as eT,e as a,k as p,w,t as n,M as tT,c as r,d as t,m as h,a as i,x as b,h as s,b as m,G as e,g,y as k,q as $,o as P,B as F,v as oT,L as gt}from"../../chunks/vendor-hf-doc-builder.js";import{T as De}from"../../chunks/Tip-hf-doc-builder.js";import{D as Te}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Ke}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as it}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as ft}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";import{P as nT}from"../../chunks/PipelineTag-hf-doc-builder.js";function sT(x){let d,y,u,f,T;return f=new Ke({props:{code:`from transformers import GPTJModel, GPTJConfig

# Initializing a GPT-J 6B configuration
configuration = GPTJConfig()

# Initializing a model from the configuration
model = GPTJModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTJModel, GPTJConfig

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a GPT-J 6B configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = GPTJConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model from the configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){d=a("p"),y=n("Example:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function aT(x){let d,y,u,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(c,"CODE",{});var E=i(u);f=s(E,"Module"),E.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,u),e(u,f),e(d,T)},d(l){l&&t(d)}}}function rT(x){let d,y,u,f,T,l,c,E;return{c(){d=a("p"),y=n(`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),u=a("code"),f=n('device_map="auto"'),T=n(" in the "),l=a("code"),c=n("from_pretrained"),E=n(" call.")},l(A){d=r(A,"P",{});var M=i(d);y=s(M,`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),u=r(M,"CODE",{});var C=i(u);f=s(C,'device_map="auto"'),C.forEach(t),T=s(M," in the "),l=r(M,"CODE",{});var D=i(l);c=s(D,"from_pretrained"),D.forEach(t),E=s(M," call."),M.forEach(t)},m(A,M){g(A,d,M),e(d,y),e(d,u),e(u,f),e(d,T),e(d,l),e(l,c),e(d,E)},d(A){A&&t(d)}}}function iT(x){let d,y,u,f,T;return f=new Ke({props:{code:`from transformers import AutoTokenizer, GPTJModel
import torch

tokenizer = AutoTokenizer.from_pretrained("hf-internal-testing/tiny-random-gptj")
model = GPTJModel.from_pretrained("hf-internal-testing/tiny-random-gptj")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTJModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJModel.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=a("p"),y=n("Example:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function lT(x){let d,y,u,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(c,"CODE",{});var E=i(u);f=s(E,"Module"),E.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,u),e(u,f),e(d,T)},d(l){l&&t(d)}}}function dT(x){let d,y,u,f,T,l,c,E;return{c(){d=a("p"),y=n(`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),u=a("code"),f=n('device_map="auto"'),T=n(" in the "),l=a("code"),c=n("from_pretrained"),E=n(" call.")},l(A){d=r(A,"P",{});var M=i(d);y=s(M,`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),u=r(M,"CODE",{});var C=i(u);f=s(C,'device_map="auto"'),C.forEach(t),T=s(M," in the "),l=r(M,"CODE",{});var D=i(l);c=s(D,"from_pretrained"),D.forEach(t),E=s(M," call."),M.forEach(t)},m(A,M){g(A,d,M),e(d,y),e(d,u),e(u,f),e(d,T),e(d,l),e(l,c),e(d,E)},d(A){A&&t(d)}}}function cT(x){let d,y,u,f,T;return f=new Ke({props:{code:`import torch
from transformers import AutoTokenizer, GPTJForCausalLM

tokenizer = AutoTokenizer.from_pretrained("hf-internal-testing/tiny-random-gptj")
model = GPTJForCausalLM.from_pretrained("hf-internal-testing/tiny-random-gptj")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")
outputs = model(**inputs, labels=inputs["input_ids"])
loss = outputs.loss
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTJForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForCausalLM.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, labels=inputs[<span class="hljs-string">&quot;input_ids&quot;</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=a("p"),y=n("Example:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function pT(x){let d,y,u,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(c,"CODE",{});var E=i(u);f=s(E,"Module"),E.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,u),e(u,f),e(d,T)},d(l){l&&t(d)}}}function hT(x){let d,y,u,f,T,l,c,E;return{c(){d=a("p"),y=n(`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of ydshieh/tiny-random-gptj-for-sequence-classification. If you get out-of-memory when loading that checkpoint, you can try
adding `),u=a("code"),f=n('device_map="auto"'),T=n(" in the "),l=a("code"),c=n("from_pretrained"),E=n(" call.")},l(A){d=r(A,"P",{});var M=i(d);y=s(M,`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of ydshieh/tiny-random-gptj-for-sequence-classification. If you get out-of-memory when loading that checkpoint, you can try
adding `),u=r(M,"CODE",{});var C=i(u);f=s(C,'device_map="auto"'),C.forEach(t),T=s(M," in the "),l=r(M,"CODE",{});var D=i(l);c=s(D,"from_pretrained"),D.forEach(t),E=s(M," call."),M.forEach(t)},m(A,M){g(A,d,M),e(d,y),e(d,u),e(u,f),e(d,T),e(d,l),e(l,c),e(d,E)},d(A){A&&t(d)}}}function uT(x){let d,y,u,f,T;return f=new Ke({props:{code:`import torch
from transformers import AutoTokenizer, GPTJForSequenceClassification

tokenizer = AutoTokenizer.from_pretrained("ydshieh/tiny-random-gptj-for-sequence-classification")
model = GPTJForSequenceClassification.from_pretrained("ydshieh/tiny-random-gptj-for-sequence-classification")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

predicted_class_id = logits.argmax().item()

# To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`
num_labels = len(model.config.id2label)
model = GPTJForSequenceClassification.from_pretrained("ydshieh/tiny-random-gptj-for-sequence-classification", num_labels=num_labels)

labels = torch.tensor([1])
loss = model(**inputs, labels=labels).loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTJForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_id = logits.argmax().item()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>, num_labels=num_labels)

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = torch.tensor([<span class="hljs-number">1</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss`}}),{c(){d=a("p"),y=n("Example of single-label classification:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example of single-label classification:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function mT(x){let d,y,u,f,T;return f=new Ke({props:{code:`import torch
from transformers import AutoTokenizer, GPTJForSequenceClassification

tokenizer = AutoTokenizer.from_pretrained("ydshieh/tiny-random-gptj-for-sequence-classification")
model = GPTJForSequenceClassification.from_pretrained("ydshieh/tiny-random-gptj-for-sequence-classification", problem_type="multi_label_classification")

inputs = tokenizer("Hello, my dog is cute", return_tensors="pt")

with torch.no_grad():
    logits = model(**inputs).logits

predicted_class_ids = torch.arange(0, logits.shape[-1])[torch.sigmoid(logits).squeeze(dim=0) > 0.5]

# To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`
num_labels = len(model.config.id2label)
model = GPTJForSequenceClassification.from_pretrained(
    "ydshieh/tiny-random-gptj-for-sequence-classification", num_labels=num_labels, problem_type="multi_label_classification"
)

labels = torch.sum(
    torch.nn.functional.one_hot(predicted_class_ids[None, :].clone(), num_classes=num_labels), dim=1
).to(torch.float)
loss = model(**inputs, labels=labels).loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTJForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>, problem_type=<span class="hljs-string">&quot;multi_label_classification&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_ids = torch.arange(<span class="hljs-number">0</span>, logits.shape[-<span class="hljs-number">1</span>])[torch.sigmoid(logits).squeeze(dim=<span class="hljs-number">0</span>) &gt; <span class="hljs-number">0.5</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on \`num_labels\` classes, you can pass \`num_labels=num_labels\` to \`.from_pretrained(...)\`</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForSequenceClassification.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;ydshieh/tiny-random-gptj-for-sequence-classification&quot;</span>, num_labels=num_labels, problem_type=<span class="hljs-string">&quot;multi_label_classification&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>labels = torch.<span class="hljs-built_in">sum</span>(
<span class="hljs-meta">... </span>    torch.nn.functional.one_hot(predicted_class_ids[<span class="hljs-literal">None</span>, :].clone(), num_classes=num_labels), dim=<span class="hljs-number">1</span>
<span class="hljs-meta">... </span>).to(torch.<span class="hljs-built_in">float</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss`}}),{c(){d=a("p"),y=n("Example of multi-label classification:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example of multi-label classification:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function fT(x){let d,y,u,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(c,"CODE",{});var E=i(u);f=s(E,"Module"),E.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,u),e(u,f),e(d,T)},d(l){l&&t(d)}}}function gT(x){let d,y,u,f,T,l,c,E;return{c(){d=a("p"),y=n(`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),u=a("code"),f=n('device_map="auto"'),T=n(" in the "),l=a("code"),c=n("from_pretrained"),E=n(" call.")},l(A){d=r(A,"P",{});var M=i(d);y=s(M,`This example uses a random model as the real ones are all very big. To get proper results, you should use
EleutherAI/gpt-j-6B instead of hf-internal-testing/tiny-random-gptj. If you get out-of-memory when loading that checkpoint, you can try
adding `),u=r(M,"CODE",{});var C=i(u);f=s(C,'device_map="auto"'),C.forEach(t),T=s(M," in the "),l=r(M,"CODE",{});var D=i(l);c=s(D,"from_pretrained"),D.forEach(t),E=s(M," call."),M.forEach(t)},m(A,M){g(A,d,M),e(d,y),e(d,u),e(u,f),e(d,T),e(d,l),e(l,c),e(d,E)},d(A){A&&t(d)}}}function _T(x){let d,y,u,f,T;return f=new Ke({props:{code:`from transformers import AutoTokenizer, GPTJForQuestionAnswering
import torch

tokenizer = AutoTokenizer.from_pretrained("hf-internal-testing/tiny-random-gptj")
model = GPTJForQuestionAnswering.from_pretrained("hf-internal-testing/tiny-random-gptj")

question, text = "Who was Jim Henson?", "Jim Henson was a nice puppet"

inputs = tokenizer(question, text, return_tensors="pt")
with torch.no_grad():
    outputs = model(**inputs)

answer_start_index = outputs.start_logits.argmax()
answer_end_index = outputs.end_logits.argmax()

predict_answer_tokens = inputs.input_ids[0, answer_start_index : answer_end_index + 1]

# target is "nice puppet"
target_start_index = torch.tensor([14])
target_end_index = torch.tensor([15])

outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
loss = outputs.loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, GPTJForQuestionAnswering
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;hf-internal-testing/tiny-random-gptj&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>question, text = <span class="hljs-string">&quot;Who was Jim Henson?&quot;</span>, <span class="hljs-string">&quot;Jim Henson was a nice puppet&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(question, text, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>answer_start_index = outputs.start_logits.argmax()
<span class="hljs-meta">&gt;&gt;&gt; </span>answer_end_index = outputs.end_logits.argmax()

<span class="hljs-meta">&gt;&gt;&gt; </span>predict_answer_tokens = inputs.input_ids[<span class="hljs-number">0</span>, answer_start_index : answer_end_index + <span class="hljs-number">1</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># target is &quot;nice puppet&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_start_index = torch.tensor([<span class="hljs-number">14</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>target_end_index = torch.tensor([<span class="hljs-number">15</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = outputs.loss`}}),{c(){d=a("p"),y=n("Example:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function TT(x){let d,y,u,f,T,l,c,E,A,M,C,D,oe,j,Pe,H,Fe,ye,B,Ee,ie,V,je,le,X,xe,ve,Q,Ge,de,ce,q,z,me,Y,we,fe,O,Je,pe,L,Me,K,qe,Ce,R,Ae,ze,S,Ie,Z,be,ee,I,ae,N,ge,Le;return{c(){d=a("p"),y=n("TensorFlow models and layers in "),u=a("code"),f=n("transformers"),T=n(" accept two formats as input:"),l=p(),c=a("ul"),E=a("li"),A=n("having all inputs as keyword arguments (like PyTorch models), or"),M=p(),C=a("li"),D=n("having all inputs as a list, tuple or dict in the first positional argument."),oe=p(),j=a("p"),Pe=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=a("code"),Fe=n("model.fit()"),ye=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=a("code"),Ee=n("model.fit()"),ie=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),V=a("code"),je=n("fit()"),le=n(" and "),X=a("code"),xe=n("predict()"),ve=n(`, such as when creating your own layers or models with
the Keras `),Q=a("code"),Ge=n("Functional"),de=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),ce=p(),q=a("ul"),z=a("li"),me=n("a single Tensor with "),Y=a("code"),we=n("input_ids"),fe=n(" only and nothing else: "),O=a("code"),Je=n("model(input_ids)"),pe=p(),L=a("li"),Me=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=a("code"),qe=n("model([input_ids, attention_mask])"),Ce=n(" or "),R=a("code"),Ae=n("model([input_ids, attention_mask, token_type_ids])"),ze=p(),S=a("li"),Ie=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=a("code"),be=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),ee=p(),I=a("p"),ae=n(`Note that when creating models and layers with
`),N=a("a"),ge=n("subclassing"),Le=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=r(v,"P",{});var G=i(d);y=s(G,"TensorFlow models and layers in "),u=r(G,"CODE",{});var Ye=i(u);f=s(Ye,"transformers"),Ye.forEach(t),T=s(G," accept two formats as input:"),G.forEach(t),l=h(v),c=r(v,"UL",{});var ne=i(c);E=r(ne,"LI",{});var he=i(E);A=s(he,"having all inputs as keyword arguments (like PyTorch models), or"),he.forEach(t),M=h(ne),C=r(ne,"LI",{});var Ze=i(C);D=s(Ze,"having all inputs as a list, tuple or dict in the first positional argument."),Ze.forEach(t),ne.forEach(t),oe=h(v),j=r(v,"P",{});var J=i(j);Pe=s(J,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=r(J,"CODE",{});var et=i(H);Fe=s(et,"model.fit()"),et.forEach(t),ye=s(J,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=r(J,"CODE",{});var tt=i(B);Ee=s(tt,"model.fit()"),tt.forEach(t),ie=s(J,` supports! If, however, you want to use the second
format outside of Keras methods like `),V=r(J,"CODE",{});var Se=i(V);je=s(Se,"fit()"),Se.forEach(t),le=s(J," and "),X=r(J,"CODE",{});var ot=i(X);xe=s(ot,"predict()"),ot.forEach(t),ve=s(J,`, such as when creating your own layers or models with
the Keras `),Q=r(J,"CODE",{});var nt=i(Q);Ge=s(nt,"Functional"),nt.forEach(t),de=s(J,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),J.forEach(t),ce=h(v),q=r(v,"UL",{});var U=i(q);z=r(U,"LI",{});var te=i(z);me=s(te,"a single Tensor with "),Y=r(te,"CODE",{});var st=i(Y);we=s(st,"input_ids"),st.forEach(t),fe=s(te," only and nothing else: "),O=r(te,"CODE",{});var Re=i(O);Je=s(Re,"model(input_ids)"),Re.forEach(t),te.forEach(t),pe=h(U),L=r(U,"LI",{});var W=i(L);Me=s(W,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=r(W,"CODE",{});var ke=i(K);qe=s(ke,"model([input_ids, attention_mask])"),ke.forEach(t),Ce=s(W," or "),R=r(W,"CODE",{});var Be=i(R);Ae=s(Be,"model([input_ids, attention_mask, token_type_ids])"),Be.forEach(t),W.forEach(t),ze=h(U),S=r(U,"LI",{});var ue=i(S);Ie=s(ue,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=r(ue,"CODE",{});var at=i(Z);be=s(at,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),at.forEach(t),ue.forEach(t),U.forEach(t),ee=h(v),I=r(v,"P",{});var se=i(I);ae=s(se,`Note that when creating models and layers with
`),N=r(se,"A",{href:!0,rel:!0});var rt=i(N);ge=s(rt,"subclassing"),rt.forEach(t),Le=s(se,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),se.forEach(t),this.h()},h(){m(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),m(N,"rel","nofollow")},m(v,G){g(v,d,G),e(d,y),e(d,u),e(u,f),e(d,T),g(v,l,G),g(v,c,G),e(c,E),e(E,A),e(c,M),e(c,C),e(C,D),g(v,oe,G),g(v,j,G),e(j,Pe),e(j,H),e(H,Fe),e(j,ye),e(j,B),e(B,Ee),e(j,ie),e(j,V),e(V,je),e(j,le),e(j,X),e(X,xe),e(j,ve),e(j,Q),e(Q,Ge),e(j,de),g(v,ce,G),g(v,q,G),e(q,z),e(z,me),e(z,Y),e(Y,we),e(z,fe),e(z,O),e(O,Je),e(q,pe),e(q,L),e(L,Me),e(L,K),e(K,qe),e(L,Ce),e(L,R),e(R,Ae),e(q,ze),e(q,S),e(S,Ie),e(S,Z),e(Z,be),g(v,ee,G),g(v,I,G),e(I,ae),e(I,N),e(N,ge),e(I,Le)},d(v){v&&t(d),v&&t(l),v&&t(c),v&&t(oe),v&&t(j),v&&t(ce),v&&t(q),v&&t(ee),v&&t(I)}}}function yT(x){let d,y,u,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(c,"CODE",{});var E=i(u);f=s(E,"Module"),E.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,u),e(u,f),e(d,T)},d(l){l&&t(d)}}}function vT(x){let d,y,u,f,T;return f=new Ke({props:{code:`from transformers import AutoTokenizer, TFGPTJModel
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")
model = TFGPTJModel.from_pretrained("EleutherAI/gpt-j-6B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="tf")
outputs = model(inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFGPTJModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFGPTJModel.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=a("p"),y=n("Example:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function wT(x){let d,y,u,f,T,l,c,E,A,M,C,D,oe,j,Pe,H,Fe,ye,B,Ee,ie,V,je,le,X,xe,ve,Q,Ge,de,ce,q,z,me,Y,we,fe,O,Je,pe,L,Me,K,qe,Ce,R,Ae,ze,S,Ie,Z,be,ee,I,ae,N,ge,Le;return{c(){d=a("p"),y=n("TensorFlow models and layers in "),u=a("code"),f=n("transformers"),T=n(" accept two formats as input:"),l=p(),c=a("ul"),E=a("li"),A=n("having all inputs as keyword arguments (like PyTorch models), or"),M=p(),C=a("li"),D=n("having all inputs as a list, tuple or dict in the first positional argument."),oe=p(),j=a("p"),Pe=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=a("code"),Fe=n("model.fit()"),ye=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=a("code"),Ee=n("model.fit()"),ie=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),V=a("code"),je=n("fit()"),le=n(" and "),X=a("code"),xe=n("predict()"),ve=n(`, such as when creating your own layers or models with
the Keras `),Q=a("code"),Ge=n("Functional"),de=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),ce=p(),q=a("ul"),z=a("li"),me=n("a single Tensor with "),Y=a("code"),we=n("input_ids"),fe=n(" only and nothing else: "),O=a("code"),Je=n("model(input_ids)"),pe=p(),L=a("li"),Me=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=a("code"),qe=n("model([input_ids, attention_mask])"),Ce=n(" or "),R=a("code"),Ae=n("model([input_ids, attention_mask, token_type_ids])"),ze=p(),S=a("li"),Ie=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=a("code"),be=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),ee=p(),I=a("p"),ae=n(`Note that when creating models and layers with
`),N=a("a"),ge=n("subclassing"),Le=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=r(v,"P",{});var G=i(d);y=s(G,"TensorFlow models and layers in "),u=r(G,"CODE",{});var Ye=i(u);f=s(Ye,"transformers"),Ye.forEach(t),T=s(G," accept two formats as input:"),G.forEach(t),l=h(v),c=r(v,"UL",{});var ne=i(c);E=r(ne,"LI",{});var he=i(E);A=s(he,"having all inputs as keyword arguments (like PyTorch models), or"),he.forEach(t),M=h(ne),C=r(ne,"LI",{});var Ze=i(C);D=s(Ze,"having all inputs as a list, tuple or dict in the first positional argument."),Ze.forEach(t),ne.forEach(t),oe=h(v),j=r(v,"P",{});var J=i(j);Pe=s(J,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=r(J,"CODE",{});var et=i(H);Fe=s(et,"model.fit()"),et.forEach(t),ye=s(J,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=r(J,"CODE",{});var tt=i(B);Ee=s(tt,"model.fit()"),tt.forEach(t),ie=s(J,` supports! If, however, you want to use the second
format outside of Keras methods like `),V=r(J,"CODE",{});var Se=i(V);je=s(Se,"fit()"),Se.forEach(t),le=s(J," and "),X=r(J,"CODE",{});var ot=i(X);xe=s(ot,"predict()"),ot.forEach(t),ve=s(J,`, such as when creating your own layers or models with
the Keras `),Q=r(J,"CODE",{});var nt=i(Q);Ge=s(nt,"Functional"),nt.forEach(t),de=s(J,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),J.forEach(t),ce=h(v),q=r(v,"UL",{});var U=i(q);z=r(U,"LI",{});var te=i(z);me=s(te,"a single Tensor with "),Y=r(te,"CODE",{});var st=i(Y);we=s(st,"input_ids"),st.forEach(t),fe=s(te," only and nothing else: "),O=r(te,"CODE",{});var Re=i(O);Je=s(Re,"model(input_ids)"),Re.forEach(t),te.forEach(t),pe=h(U),L=r(U,"LI",{});var W=i(L);Me=s(W,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=r(W,"CODE",{});var ke=i(K);qe=s(ke,"model([input_ids, attention_mask])"),ke.forEach(t),Ce=s(W," or "),R=r(W,"CODE",{});var Be=i(R);Ae=s(Be,"model([input_ids, attention_mask, token_type_ids])"),Be.forEach(t),W.forEach(t),ze=h(U),S=r(U,"LI",{});var ue=i(S);Ie=s(ue,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=r(ue,"CODE",{});var at=i(Z);be=s(at,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),at.forEach(t),ue.forEach(t),U.forEach(t),ee=h(v),I=r(v,"P",{});var se=i(I);ae=s(se,`Note that when creating models and layers with
`),N=r(se,"A",{href:!0,rel:!0});var rt=i(N);ge=s(rt,"subclassing"),rt.forEach(t),Le=s(se,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),se.forEach(t),this.h()},h(){m(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),m(N,"rel","nofollow")},m(v,G){g(v,d,G),e(d,y),e(d,u),e(u,f),e(d,T),g(v,l,G),g(v,c,G),e(c,E),e(E,A),e(c,M),e(c,C),e(C,D),g(v,oe,G),g(v,j,G),e(j,Pe),e(j,H),e(H,Fe),e(j,ye),e(j,B),e(B,Ee),e(j,ie),e(j,V),e(V,je),e(j,le),e(j,X),e(X,xe),e(j,ve),e(j,Q),e(Q,Ge),e(j,de),g(v,ce,G),g(v,q,G),e(q,z),e(z,me),e(z,Y),e(Y,we),e(z,fe),e(z,O),e(O,Je),e(q,pe),e(q,L),e(L,Me),e(L,K),e(K,qe),e(L,Ce),e(L,R),e(R,Ae),e(q,ze),e(q,S),e(S,Ie),e(S,Z),e(Z,be),g(v,ee,G),g(v,I,G),e(I,ae),e(I,N),e(N,ge),e(I,Le)},d(v){v&&t(d),v&&t(l),v&&t(c),v&&t(oe),v&&t(j),v&&t(ce),v&&t(q),v&&t(ee),v&&t(I)}}}function bT(x){let d,y,u,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(c,"CODE",{});var E=i(u);f=s(E,"Module"),E.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,u),e(u,f),e(d,T)},d(l){l&&t(d)}}}function kT(x){let d,y,u,f,T;return f=new Ke({props:{code:`from transformers import AutoTokenizer, TFGPTJForCausalLM
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")
model = TFGPTJForCausalLM.from_pretrained("EleutherAI/gpt-j-6B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="tf")
outputs = model(inputs)
logits = outputs.logits`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFGPTJForCausalLM
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFGPTJForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = outputs.logits`}}),{c(){d=a("p"),y=n("Example:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function $T(x){let d,y,u,f,T,l,c,E,A,M,C,D,oe,j,Pe,H,Fe,ye,B,Ee,ie,V,je,le,X,xe,ve,Q,Ge,de,ce,q,z,me,Y,we,fe,O,Je,pe,L,Me,K,qe,Ce,R,Ae,ze,S,Ie,Z,be,ee,I,ae,N,ge,Le;return{c(){d=a("p"),y=n("TensorFlow models and layers in "),u=a("code"),f=n("transformers"),T=n(" accept two formats as input:"),l=p(),c=a("ul"),E=a("li"),A=n("having all inputs as keyword arguments (like PyTorch models), or"),M=p(),C=a("li"),D=n("having all inputs as a list, tuple or dict in the first positional argument."),oe=p(),j=a("p"),Pe=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=a("code"),Fe=n("model.fit()"),ye=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=a("code"),Ee=n("model.fit()"),ie=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),V=a("code"),je=n("fit()"),le=n(" and "),X=a("code"),xe=n("predict()"),ve=n(`, such as when creating your own layers or models with
the Keras `),Q=a("code"),Ge=n("Functional"),de=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),ce=p(),q=a("ul"),z=a("li"),me=n("a single Tensor with "),Y=a("code"),we=n("input_ids"),fe=n(" only and nothing else: "),O=a("code"),Je=n("model(input_ids)"),pe=p(),L=a("li"),Me=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=a("code"),qe=n("model([input_ids, attention_mask])"),Ce=n(" or "),R=a("code"),Ae=n("model([input_ids, attention_mask, token_type_ids])"),ze=p(),S=a("li"),Ie=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=a("code"),be=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),ee=p(),I=a("p"),ae=n(`Note that when creating models and layers with
`),N=a("a"),ge=n("subclassing"),Le=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=r(v,"P",{});var G=i(d);y=s(G,"TensorFlow models and layers in "),u=r(G,"CODE",{});var Ye=i(u);f=s(Ye,"transformers"),Ye.forEach(t),T=s(G," accept two formats as input:"),G.forEach(t),l=h(v),c=r(v,"UL",{});var ne=i(c);E=r(ne,"LI",{});var he=i(E);A=s(he,"having all inputs as keyword arguments (like PyTorch models), or"),he.forEach(t),M=h(ne),C=r(ne,"LI",{});var Ze=i(C);D=s(Ze,"having all inputs as a list, tuple or dict in the first positional argument."),Ze.forEach(t),ne.forEach(t),oe=h(v),j=r(v,"P",{});var J=i(j);Pe=s(J,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=r(J,"CODE",{});var et=i(H);Fe=s(et,"model.fit()"),et.forEach(t),ye=s(J,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=r(J,"CODE",{});var tt=i(B);Ee=s(tt,"model.fit()"),tt.forEach(t),ie=s(J,` supports! If, however, you want to use the second
format outside of Keras methods like `),V=r(J,"CODE",{});var Se=i(V);je=s(Se,"fit()"),Se.forEach(t),le=s(J," and "),X=r(J,"CODE",{});var ot=i(X);xe=s(ot,"predict()"),ot.forEach(t),ve=s(J,`, such as when creating your own layers or models with
the Keras `),Q=r(J,"CODE",{});var nt=i(Q);Ge=s(nt,"Functional"),nt.forEach(t),de=s(J,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),J.forEach(t),ce=h(v),q=r(v,"UL",{});var U=i(q);z=r(U,"LI",{});var te=i(z);me=s(te,"a single Tensor with "),Y=r(te,"CODE",{});var st=i(Y);we=s(st,"input_ids"),st.forEach(t),fe=s(te," only and nothing else: "),O=r(te,"CODE",{});var Re=i(O);Je=s(Re,"model(input_ids)"),Re.forEach(t),te.forEach(t),pe=h(U),L=r(U,"LI",{});var W=i(L);Me=s(W,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=r(W,"CODE",{});var ke=i(K);qe=s(ke,"model([input_ids, attention_mask])"),ke.forEach(t),Ce=s(W," or "),R=r(W,"CODE",{});var Be=i(R);Ae=s(Be,"model([input_ids, attention_mask, token_type_ids])"),Be.forEach(t),W.forEach(t),ze=h(U),S=r(U,"LI",{});var ue=i(S);Ie=s(ue,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=r(ue,"CODE",{});var at=i(Z);be=s(at,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),at.forEach(t),ue.forEach(t),U.forEach(t),ee=h(v),I=r(v,"P",{});var se=i(I);ae=s(se,`Note that when creating models and layers with
`),N=r(se,"A",{href:!0,rel:!0});var rt=i(N);ge=s(rt,"subclassing"),rt.forEach(t),Le=s(se,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),se.forEach(t),this.h()},h(){m(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),m(N,"rel","nofollow")},m(v,G){g(v,d,G),e(d,y),e(d,u),e(u,f),e(d,T),g(v,l,G),g(v,c,G),e(c,E),e(E,A),e(c,M),e(c,C),e(C,D),g(v,oe,G),g(v,j,G),e(j,Pe),e(j,H),e(H,Fe),e(j,ye),e(j,B),e(B,Ee),e(j,ie),e(j,V),e(V,je),e(j,le),e(j,X),e(X,xe),e(j,ve),e(j,Q),e(Q,Ge),e(j,de),g(v,ce,G),g(v,q,G),e(q,z),e(z,me),e(z,Y),e(Y,we),e(z,fe),e(z,O),e(O,Je),e(q,pe),e(q,L),e(L,Me),e(L,K),e(K,qe),e(L,Ce),e(L,R),e(R,Ae),e(q,ze),e(q,S),e(S,Ie),e(S,Z),e(Z,be),g(v,ee,G),g(v,I,G),e(I,ae),e(I,N),e(N,ge),e(I,Le)},d(v){v&&t(d),v&&t(l),v&&t(c),v&&t(oe),v&&t(j),v&&t(ce),v&&t(q),v&&t(ee),v&&t(I)}}}function PT(x){let d,y,u,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(c,"CODE",{});var E=i(u);f=s(E,"Module"),E.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,u),e(u,f),e(d,T)},d(l){l&&t(d)}}}function FT(x){let d,y,u,f,T;return f=new Ke({props:{code:`from transformers import AutoTokenizer, TFGPTJForSequenceClassification
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")
model = TFGPTJForSequenceClassification.from_pretrained("EleutherAI/gpt-j-6B")

inputs = tokenizer("Hello, my dog is cute", return_tensors="tf")

logits = model(**inputs).logits

predicted_class_id = int(tf.math.argmax(logits, axis=-1)[0])`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFGPTJForSequenceClassification
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFGPTJForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(**inputs).logits

<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_class_id = <span class="hljs-built_in">int</span>(tf.math.argmax(logits, axis=-<span class="hljs-number">1</span>)[<span class="hljs-number">0</span>])`}}),{c(){d=a("p"),y=n("Example:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function ET(x){let d,y;return d=new Ke({props:{code:'# To train a model on `num_labels` classes, you can pass `num_labels=num_labels` to `.from_pretrained(...)`\nnum_labels = len(model.config.id2label)\nmodel = TFGPTJForSequenceClassification.from_pretrained("EleutherAI/gpt-j-6B", num_labels=num_labels)\n\nlabels = tf.constant(1)\nloss = model(**inputs, labels=labels).loss',highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># To train a model on `num_labels` classes, you can pass `num_labels=num_labels` to `.from_pretrained(...)`</span>\n<span class="hljs-meta">&gt;&gt;&gt; </span>num_labels = <span class="hljs-built_in">len</span>(model.config.id2label)\n<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFGPTJForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>, num_labels=num_labels)\n\n<span class="hljs-meta">&gt;&gt;&gt; </span>labels = tf.constant(<span class="hljs-number">1</span>)\n<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs, labels=labels).loss'}}),{c(){w(d.$$.fragment)},l(u){b(d.$$.fragment,u)},m(u,f){k(d,u,f),y=!0},p:gt,i(u){y||($(d.$$.fragment,u),y=!0)},o(u){P(d.$$.fragment,u),y=!1},d(u){F(d,u)}}}function jT(x){let d,y,u,f,T,l,c,E,A,M,C,D,oe,j,Pe,H,Fe,ye,B,Ee,ie,V,je,le,X,xe,ve,Q,Ge,de,ce,q,z,me,Y,we,fe,O,Je,pe,L,Me,K,qe,Ce,R,Ae,ze,S,Ie,Z,be,ee,I,ae,N,ge,Le;return{c(){d=a("p"),y=n("TensorFlow models and layers in "),u=a("code"),f=n("transformers"),T=n(" accept two formats as input:"),l=p(),c=a("ul"),E=a("li"),A=n("having all inputs as keyword arguments (like PyTorch models), or"),M=p(),C=a("li"),D=n("having all inputs as a list, tuple or dict in the first positional argument."),oe=p(),j=a("p"),Pe=n(`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=a("code"),Fe=n("model.fit()"),ye=n(` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=a("code"),Ee=n("model.fit()"),ie=n(` supports! If, however, you want to use the second
format outside of Keras methods like `),V=a("code"),je=n("fit()"),le=n(" and "),X=a("code"),xe=n("predict()"),ve=n(`, such as when creating your own layers or models with
the Keras `),Q=a("code"),Ge=n("Functional"),de=n(` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),ce=p(),q=a("ul"),z=a("li"),me=n("a single Tensor with "),Y=a("code"),we=n("input_ids"),fe=n(" only and nothing else: "),O=a("code"),Je=n("model(input_ids)"),pe=p(),L=a("li"),Me=n(`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=a("code"),qe=n("model([input_ids, attention_mask])"),Ce=n(" or "),R=a("code"),Ae=n("model([input_ids, attention_mask, token_type_ids])"),ze=p(),S=a("li"),Ie=n(`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=a("code"),be=n('model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),ee=p(),I=a("p"),ae=n(`Note that when creating models and layers with
`),N=a("a"),ge=n("subclassing"),Le=n(` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),this.h()},l(v){d=r(v,"P",{});var G=i(d);y=s(G,"TensorFlow models and layers in "),u=r(G,"CODE",{});var Ye=i(u);f=s(Ye,"transformers"),Ye.forEach(t),T=s(G," accept two formats as input:"),G.forEach(t),l=h(v),c=r(v,"UL",{});var ne=i(c);E=r(ne,"LI",{});var he=i(E);A=s(he,"having all inputs as keyword arguments (like PyTorch models), or"),he.forEach(t),M=h(ne),C=r(ne,"LI",{});var Ze=i(C);D=s(Ze,"having all inputs as a list, tuple or dict in the first positional argument."),Ze.forEach(t),ne.forEach(t),oe=h(v),j=r(v,"P",{});var J=i(j);Pe=s(J,`The reason the second format is supported is that Keras methods prefer this format when passing inputs to models
and layers. Because of this support, when using methods like `),H=r(J,"CODE",{});var et=i(H);Fe=s(et,"model.fit()"),et.forEach(t),ye=s(J,` things should \u201Cjust work\u201D for you - just
pass your inputs and labels in any format that `),B=r(J,"CODE",{});var tt=i(B);Ee=s(tt,"model.fit()"),tt.forEach(t),ie=s(J,` supports! If, however, you want to use the second
format outside of Keras methods like `),V=r(J,"CODE",{});var Se=i(V);je=s(Se,"fit()"),Se.forEach(t),le=s(J," and "),X=r(J,"CODE",{});var ot=i(X);xe=s(ot,"predict()"),ot.forEach(t),ve=s(J,`, such as when creating your own layers or models with
the Keras `),Q=r(J,"CODE",{});var nt=i(Q);Ge=s(nt,"Functional"),nt.forEach(t),de=s(J,` API, there are three possibilities you can use to gather all the input Tensors in the first
positional argument:`),J.forEach(t),ce=h(v),q=r(v,"UL",{});var U=i(q);z=r(U,"LI",{});var te=i(z);me=s(te,"a single Tensor with "),Y=r(te,"CODE",{});var st=i(Y);we=s(st,"input_ids"),st.forEach(t),fe=s(te," only and nothing else: "),O=r(te,"CODE",{});var Re=i(O);Je=s(Re,"model(input_ids)"),Re.forEach(t),te.forEach(t),pe=h(U),L=r(U,"LI",{});var W=i(L);Me=s(W,`a list of varying length with one or several input Tensors IN THE ORDER given in the docstring:
`),K=r(W,"CODE",{});var ke=i(K);qe=s(ke,"model([input_ids, attention_mask])"),ke.forEach(t),Ce=s(W," or "),R=r(W,"CODE",{});var Be=i(R);Ae=s(Be,"model([input_ids, attention_mask, token_type_ids])"),Be.forEach(t),W.forEach(t),ze=h(U),S=r(U,"LI",{});var ue=i(S);Ie=s(ue,`a dictionary with one or several input Tensors associated to the input names given in the docstring:
`),Z=r(ue,"CODE",{});var at=i(Z);be=s(at,'model({"input_ids": input_ids, "token_type_ids": token_type_ids})'),at.forEach(t),ue.forEach(t),U.forEach(t),ee=h(v),I=r(v,"P",{});var se=i(I);ae=s(se,`Note that when creating models and layers with
`),N=r(se,"A",{href:!0,rel:!0});var rt=i(N);ge=s(rt,"subclassing"),rt.forEach(t),Le=s(se,` then you don\u2019t need to worry
about any of this, as you can just pass inputs like you would to any other Python function!`),se.forEach(t),this.h()},h(){m(N,"href","https://keras.io/guides/making_new_layers_and_models_via_subclassing/"),m(N,"rel","nofollow")},m(v,G){g(v,d,G),e(d,y),e(d,u),e(u,f),e(d,T),g(v,l,G),g(v,c,G),e(c,E),e(E,A),e(c,M),e(c,C),e(C,D),g(v,oe,G),g(v,j,G),e(j,Pe),e(j,H),e(H,Fe),e(j,ye),e(j,B),e(B,Ee),e(j,ie),e(j,V),e(V,je),e(j,le),e(j,X),e(X,xe),e(j,ve),e(j,Q),e(Q,Ge),e(j,de),g(v,ce,G),g(v,q,G),e(q,z),e(z,me),e(z,Y),e(Y,we),e(z,fe),e(z,O),e(O,Je),e(q,pe),e(q,L),e(L,Me),e(L,K),e(K,qe),e(L,Ce),e(L,R),e(R,Ae),e(q,ze),e(q,S),e(S,Ie),e(S,Z),e(Z,be),g(v,ee,G),g(v,I,G),e(I,ae),e(I,N),e(N,ge),e(I,Le)},d(v){v&&t(d),v&&t(l),v&&t(c),v&&t(oe),v&&t(j),v&&t(ce),v&&t(q),v&&t(ee),v&&t(I)}}}function xT(x){let d,y,u,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(c,"CODE",{});var E=i(u);f=s(E,"Module"),E.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,u),e(u,f),e(d,T)},d(l){l&&t(d)}}}function GT(x){let d,y,u,f,T;return f=new Ke({props:{code:`from transformers import AutoTokenizer, TFGPTJForQuestionAnswering
import tensorflow as tf

tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")
model = TFGPTJForQuestionAnswering.from_pretrained("EleutherAI/gpt-j-6B")

question, text = "Who was Jim Henson?", "Jim Henson was a nice puppet"

inputs = tokenizer(question, text, return_tensors="tf")
outputs = model(**inputs)

answer_start_index = int(tf.math.argmax(outputs.start_logits, axis=-1)[0])
answer_end_index = int(tf.math.argmax(outputs.end_logits, axis=-1)[0])

predict_answer_tokens = inputs.input_ids[0, answer_start_index : answer_end_index + 1]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, TFGPTJForQuestionAnswering
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFGPTJForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>question, text = <span class="hljs-string">&quot;Who was Jim Henson?&quot;</span>, <span class="hljs-string">&quot;Jim Henson was a nice puppet&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(question, text, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>answer_start_index = <span class="hljs-built_in">int</span>(tf.math.argmax(outputs.start_logits, axis=-<span class="hljs-number">1</span>)[<span class="hljs-number">0</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>answer_end_index = <span class="hljs-built_in">int</span>(tf.math.argmax(outputs.end_logits, axis=-<span class="hljs-number">1</span>)[<span class="hljs-number">0</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>predict_answer_tokens = inputs.input_ids[<span class="hljs-number">0</span>, answer_start_index : answer_end_index + <span class="hljs-number">1</span>]`}}),{c(){d=a("p"),y=n("Example:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function JT(x){let d,y;return d=new Ke({props:{code:`# target is "nice puppet"
target_start_index = tf.constant([14])
target_end_index = tf.constant([15])

outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
loss = tf.math.reduce_mean(outputs.loss)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># target is &quot;nice puppet&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_start_index = tf.constant([<span class="hljs-number">14</span>])
<span class="hljs-meta">&gt;&gt;&gt; </span>target_end_index = tf.constant([<span class="hljs-number">15</span>])

<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs, start_positions=target_start_index, end_positions=target_end_index)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = tf.math.reduce_mean(outputs.loss)`}}),{c(){w(d.$$.fragment)},l(u){b(d.$$.fragment,u)},m(u,f){k(d,u,f),y=!0},p:gt,i(u){y||($(d.$$.fragment,u),y=!0)},o(u){P(d.$$.fragment,u),y=!1},d(u){F(d,u)}}}function MT(x){let d,y,u,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(c,"CODE",{});var E=i(u);f=s(E,"Module"),E.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,u),e(u,f),e(d,T)},d(l){l&&t(d)}}}function qT(x){let d,y,u,f,T;return f=new Ke({props:{code:`from transformers import AutoTokenizer, FlaxGPTJModel

tokenizer = AutoTokenizer.from_pretrained("gptj")
model = FlaxGPTJModel.from_pretrained("gptj")

inputs = tokenizer("Hello, my dog is cute", return_tensors="jax")
outputs = model(**inputs)

last_hidden_states = outputs.last_hidden_state`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxGPTJModel

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;gptj&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxGPTJModel.from_pretrained(<span class="hljs-string">&quot;gptj&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;jax&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state`}}),{c(){d=a("p"),y=n("Example:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function CT(x){let d,y,u,f,T;return{c(){d=a("p"),y=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),u=a("code"),f=n("Module"),T=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Although the recipe for forward pass needs to be defined within this function, one should call the "),u=r(c,"CODE",{});var E=i(u);f=s(E,"Module"),E.forEach(t),T=s(c,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),c.forEach(t)},m(l,c){g(l,d,c),e(d,y),e(d,u),e(u,f),e(d,T)},d(l){l&&t(d)}}}function AT(x){let d,y,u,f,T;return f=new Ke({props:{code:`from transformers import AutoTokenizer, FlaxGPTJForCausalLM

tokenizer = AutoTokenizer.from_pretrained("gptj")
model = FlaxGPTJForCausalLM.from_pretrained("gptj")

inputs = tokenizer("Hello, my dog is cute", return_tensors="np")
outputs = model(**inputs)

# retrieve logts for next token
next_token_logits = outputs.logits[:, -1]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer, FlaxGPTJForCausalLM

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;gptj&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = FlaxGPTJForCausalLM.from_pretrained(<span class="hljs-string">&quot;gptj&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;Hello, my dog is cute&quot;</span>, return_tensors=<span class="hljs-string">&quot;np&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># retrieve logts for next token</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>next_token_logits = outputs.logits[:, -<span class="hljs-number">1</span>]`}}),{c(){d=a("p"),y=n("Example:"),u=p(),w(f.$$.fragment)},l(l){d=r(l,"P",{});var c=i(d);y=s(c,"Example:"),c.forEach(t),u=h(l),b(f.$$.fragment,l)},m(l,c){g(l,d,c),e(d,y),g(l,u,c),k(f,l,c),T=!0},p:gt,i(l){T||($(f.$$.fragment,l),T=!0)},o(l){P(f.$$.fragment,l),T=!1},d(l){l&&t(d),l&&t(u),F(f,l)}}}function zT(x){let d,y,u,f,T,l,c,E,A,M,C,D,oe,j,Pe,H,Fe,ye,B,Ee,ie,V,je,le,X,xe,ve,Q,Ge,de,ce,q,z,me,Y,we,fe,O,Je,pe,L,Me,K,qe,Ce,R,Ae,ze,S,Ie,Z,be,ee,I,ae,N,ge,Le,v,G,Ye,ne,he,Ze,J,et,tt,Se,ot,nt,U,te,st,Re,W,ke,Be,ue,at,se,rt,Ui,bo,sd,ha,ad,rd,Wi,bn,Qi,ua,id,Hi,kn,Ki,Rt,ko,rr,$n,ld,ir,dd,Ri,ma,cd,Vi,Pn,Xi,re,Fn,pd,En,hd,ud,md,jn,fd,xn,gd,_d,Td,Gn,yd,Jn,vd,wd,bd,Mn,kd,qn,$d,Pd,Fd,Cn,Ed,An,jd,xd,Gd,zn,Jd,In,Md,qd,Cd,fa,Ln,Ad,zd,Id,kt,ga,Ld,Od,On,Nd,Dd,Nn,Sd,Bd,Dn,Ud,Wd,Qd,Lt,_a,Hd,Kd,Sn,Rd,Vd,Bn,Xd,Yd,Zd,Ot,Ta,ec,tc,Un,oc,nc,Wn,sc,ac,Yi,ya,lr,rc,Zi,Nt,dr,va,ic,lc,cr,wa,dc,cc,pr,ba,pc,el,Vt,$o,hr,Qn,hc,ur,uc,tl,qt,Hn,mc,_t,fc,ka,gc,_c,Kn,Tc,yc,$a,vc,wc,Pa,bc,kc,$c,Po,ol,Xt,Fo,mr,Rn,Pc,fr,Fc,nl,Ct,Vn,Ec,Xn,jc,Yn,xc,Gc,Jc,lt,Zn,Mc,Yt,qc,Fa,Cc,Ac,gr,zc,Ic,Lc,Eo,Oc,jo,Nc,xo,sl,Zt,Go,_r,es,Dc,Tr,Sc,al,Tt,ts,Bc,yr,Uc,Wc,os,Qc,ns,Hc,Kc,Rc,dt,ss,Vc,eo,Xc,Ea,Yc,Zc,vr,ep,tp,op,Jo,np,Mo,sp,qo,rl,to,Co,wr,as,ap,br,rp,il,Ue,rs,ip,kr,lp,dp,ja,xa,cp,pp,hp,yt,up,$r,mp,fp,Pr,gp,_p,Fr,Tp,yp,Er,vp,wp,bp,is,kp,ls,$p,Pp,Fp,Ve,ds,Ep,oo,jp,Ga,xp,Gp,jr,Jp,Mp,qp,Ao,Cp,zo,Ap,Io,zp,Lo,ll,no,Oo,xr,cs,Ip,Gr,Lp,dl,vt,ps,Op,so,Np,Jr,Dp,Sp,Mr,Bp,Up,Wp,hs,Qp,us,Hp,Kp,Rp,ct,ms,Vp,ao,Xp,Ja,Yp,Zp,qr,eh,th,oh,No,nh,Do,sh,So,cl,ro,Bo,Cr,fs,ah,Ar,rh,pl,We,gs,ih,zr,lh,dh,_s,ch,Ma,ph,hh,uh,Ts,mh,ys,fh,gh,_h,Uo,Th,$t,vs,yh,io,vh,qa,wh,bh,Ir,kh,$h,Ph,Wo,Fh,Qo,hl,lo,Ho,Lr,ws,Eh,Or,jh,ul,Qe,bs,xh,Nr,Gh,Jh,ks,Mh,Ca,qh,Ch,Ah,$s,zh,Ps,Ih,Lh,Oh,Ko,Nh,Pt,Fs,Dh,co,Sh,Aa,Bh,Uh,Dr,Wh,Qh,Hh,Ro,Kh,Vo,ml,po,Xo,Sr,Es,Rh,Br,Vh,fl,_e,js,Xh,Ur,Yh,Zh,za,Ia,eu,tu,ou,wt,nu,Wr,su,au,Qr,ru,iu,Hr,lu,du,Kr,cu,pu,hu,xs,uu,La,mu,fu,gu,Gs,_u,Js,Tu,yu,vu,Yo,wu,pt,Ms,bu,ho,ku,Oa,$u,Pu,Rr,Fu,Eu,ju,Zo,xu,en,Gu,tn,gl,uo,on,Vr,qs,Ju,Xr,Mu,_l,He,Cs,qu,mo,Cu,Yr,Au,zu,Zr,Iu,Lu,Ou,As,Nu,Na,Du,Su,Bu,zs,Uu,Is,Wu,Qu,Hu,nn,Ku,ht,Ls,Ru,fo,Vu,Da,Xu,Yu,ei,Zu,em,tm,sn,om,an,nm,rn,Tl,go,ln,ti,Os,sm,oi,am,yl,Oe,Ns,rm,ni,im,lm,Ds,dm,Sa,cm,pm,hm,Ss,um,Bs,mm,fm,gm,si,_m,Tm,At,ai,Us,ym,vm,ri,Ws,wm,bm,ii,Qs,km,$m,li,Hs,Pm,Fm,Ft,Ks,Em,_o,jm,di,xm,Gm,ci,Jm,Mm,qm,dn,Cm,cn,vl,To,pn,pi,Rs,Am,hi,zm,wl,Ne,Vs,Im,ui,Lm,Om,Xs,Nm,Ba,Dm,Sm,Bm,Ys,Um,Zs,Wm,Qm,Hm,mi,Km,Rm,zt,fi,ea,Vm,Xm,gi,ta,Ym,Zm,_i,oa,ef,tf,Ti,na,of,nf,Et,sa,sf,yo,af,yi,rf,lf,vi,df,cf,pf,hn,hf,un,bl;return l=new it({}),j=new it({}),ee=new Ke({props:{code:`from transformers import GPTJForCausalLM
import torch

model = GPTJForCausalLM.from_pretrained(
    "EleutherAI/gpt-j-6B", revision="float16", torch_dtype=torch.float16, low_cpu_mem_usage=True
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTJForCausalLM
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForCausalLM.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>, revision=<span class="hljs-string">&quot;float16&quot;</span>, torch_dtype=torch.float16, low_cpu_mem_usage=<span class="hljs-literal">True</span>
<span class="hljs-meta">... </span>)`}}),ue=new it({}),bn=new Ke({props:{code:`from transformers import AutoModelForCausalLM, AutoTokenizer

model = AutoModelForCausalLM.from_pretrained("EleutherAI/gpt-j-6B")
tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")

prompt = (
    "In a shocking finding, scientists discovered a herd of unicorns living in a remote, "
    "previously unexplored valley, in the Andes Mountains. Even more surprising to the "
    "researchers was the fact that the unicorns spoke perfect English."
)

input_ids = tokenizer(prompt, return_tensors="pt").input_ids

gen_tokens = model.generate(
    input_ids,
    do_sample=True,
    temperature=0.9,
    max_length=100,
)
gen_text = tokenizer.batch_decode(gen_tokens)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForCausalLM, AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = (
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;In a shocking finding, scientists discovered a herd of unicorns living in a remote, &quot;</span>
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;previously unexplored valley, in the Andes Mountains. Even more surprising to the &quot;</span>
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;researchers was the fact that the unicorns spoke perfect English.&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span>gen_tokens = model.generate(
<span class="hljs-meta">... </span>    input_ids,
<span class="hljs-meta">... </span>    do_sample=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    temperature=<span class="hljs-number">0.9</span>,
<span class="hljs-meta">... </span>    max_length=<span class="hljs-number">100</span>,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>gen_text = tokenizer.batch_decode(gen_tokens)[<span class="hljs-number">0</span>]`}}),kn=new Ke({props:{code:`from transformers import GPTJForCausalLM, AutoTokenizer
import torch

model = GPTJForCausalLM.from_pretrained("EleutherAI/gpt-j-6B", torch_dtype=torch.float16)
tokenizer = AutoTokenizer.from_pretrained("EleutherAI/gpt-j-6B")

prompt = (
    "In a shocking finding, scientists discovered a herd of unicorns living in a remote, "
    "previously unexplored valley, in the Andes Mountains. Even more surprising to the "
    "researchers was the fact that the unicorns spoke perfect English."
)

input_ids = tokenizer(prompt, return_tensors="pt").input_ids

gen_tokens = model.generate(
    input_ids,
    do_sample=True,
    temperature=0.9,
    max_length=100,
)
gen_text = tokenizer.batch_decode(gen_tokens)[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPTJForCausalLM, AutoTokenizer
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>model = GPTJForCausalLM.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;EleutherAI/gpt-j-6B&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = (
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;In a shocking finding, scientists discovered a herd of unicorns living in a remote, &quot;</span>
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;previously unexplored valley, in the Andes Mountains. Even more surprising to the &quot;</span>
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;researchers was the fact that the unicorns spoke perfect English.&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>input_ids = tokenizer(prompt, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span>gen_tokens = model.generate(
<span class="hljs-meta">... </span>    input_ids,
<span class="hljs-meta">... </span>    do_sample=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    temperature=<span class="hljs-number">0.9</span>,
<span class="hljs-meta">... </span>    max_length=<span class="hljs-number">100</span>,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>gen_text = tokenizer.batch_decode(gen_tokens)[<span class="hljs-number">0</span>]`}}),$n=new it({}),Pn=new nT({props:{pipeline:"text-generation"}}),Qn=new it({}),Hn=new Te({props:{name:"class transformers.GPTJConfig",anchor:"transformers.GPTJConfig",parameters:[{name:"vocab_size",val:" = 50400"},{name:"n_positions",val:" = 2048"},{name:"n_embd",val:" = 4096"},{name:"n_layer",val:" = 28"},{name:"n_head",val:" = 16"},{name:"rotary_dim",val:" = 64"},{name:"n_inner",val:" = None"},{name:"activation_function",val:" = 'gelu_new'"},{name:"resid_pdrop",val:" = 0.0"},{name:"embd_pdrop",val:" = 0.0"},{name:"attn_pdrop",val:" = 0.0"},{name:"layer_norm_epsilon",val:" = 1e-05"},{name:"initializer_range",val:" = 0.02"},{name:"use_cache",val:" = True"},{name:"bos_token_id",val:" = 50256"},{name:"eos_token_id",val:" = 50256"},{name:"tie_word_embeddings",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.GPTJConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 50400) &#x2014;
Vocabulary size of the GPT-J model. Defines the number of different tokens that can be represented by the
<code>inputs_ids</code> passed when calling <a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJModel">GPTJModel</a>.`,name:"vocab_size"},{anchor:"transformers.GPTJConfig.n_positions",description:`<strong>n_positions</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
The maximum sequence length that this model might ever be used with. Typically set this to something large
just in case (e.g., 512 or 1024 or 2048).`,name:"n_positions"},{anchor:"transformers.GPTJConfig.n_embd",description:`<strong>n_embd</strong> (<code>int</code>, <em>optional</em>, defaults to 4096) &#x2014;
Dimensionality of the embeddings and hidden states.`,name:"n_embd"},{anchor:"transformers.GPTJConfig.n_layer",description:`<strong>n_layer</strong> (<code>int</code>, <em>optional</em>, defaults to 28) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"n_layer"},{anchor:"transformers.GPTJConfig.n_head",description:`<strong>n_head</strong> (<code>int</code>, <em>optional</em>, defaults to 16) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"n_head"},{anchor:"transformers.GPTJConfig.rotary_dim",description:`<strong>rotary_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 64) &#x2014;
Number of dimensions in the embedding that Rotary Position Embedding is applied to.`,name:"rotary_dim"},{anchor:"transformers.GPTJConfig.n_inner",description:`<strong>n_inner</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
Dimensionality of the inner feed-forward layers. <code>None</code> will set it to 4 times n_embd`,name:"n_inner"},{anchor:"transformers.GPTJConfig.activation_function",description:`<strong>activation_function</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;gelu_new&quot;</code>) &#x2014;
Activation function, to be selected in the list <code>[&quot;relu&quot;, &quot;silu&quot;, &quot;gelu&quot;, &quot;tanh&quot;, &quot;gelu_new&quot;]</code>.`,name:"activation_function"},{anchor:"transformers.GPTJConfig.resid_pdrop",description:`<strong>resid_pdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"resid_pdrop"},{anchor:"transformers.GPTJConfig.embd_pdrop",description:`<strong>embd_pdrop</strong> (<code>int</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout ratio for the embeddings.`,name:"embd_pdrop"},{anchor:"transformers.GPTJConfig.attn_pdrop",description:`<strong>attn_pdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout ratio for the attention.`,name:"attn_pdrop"},{anchor:"transformers.GPTJConfig.layer_norm_epsilon",description:`<strong>layer_norm_epsilon</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-5) &#x2014;
The epsilon to use in the layer normalization layers.`,name:"layer_norm_epsilon"},{anchor:"transformers.GPTJConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.GPTJConfig.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return the last key/values attentions (not used by all models).`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/configuration_gptj.py#L33"}}),Po=new ft({props:{anchor:"transformers.GPTJConfig.example",$$slots:{default:[sT]},$$scope:{ctx:x}}}),Rn=new it({}),Vn=new Te({props:{name:"class transformers.GPTJModel",anchor:"transformers.GPTJModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTJModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_gptj.py#L472"}}),Zn=new Te({props:{name:"forward",anchor:"transformers.GPTJModel.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.Tensor]]] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTJModel.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTJModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTJModel.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTJModel.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTJModel.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_attention_heads,)</code> or <code>(n_layer, num_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTJModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_dim)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <em>input_ids</em> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.GPTJModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTJModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTJModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_gptj.py#L539",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPast"
>transformers.modeling_outputs.BaseModelOutputWithPast</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>) and optionally if
<code>config.is_encoder_decoder=True</code> 2 additional tensors of shape <code>(batch_size, num_heads, encoder_sequence_length, embed_size_per_head)</code>.</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks and optionally if
<code>config.is_encoder_decoder=True</code> in the cross-attention blocks) that can be used (see <code>past_key_values</code>
input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.BaseModelOutputWithPast"
>transformers.modeling_outputs.BaseModelOutputWithPast</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Eo=new De({props:{$$slots:{default:[aT]},$$scope:{ctx:x}}}),jo=new De({props:{warning:!0,$$slots:{default:[rT]},$$scope:{ctx:x}}}),xo=new ft({props:{anchor:"transformers.GPTJModel.forward.example",$$slots:{default:[iT]},$$scope:{ctx:x}}}),es=new it({}),ts=new Te({props:{name:"class transformers.GPTJForCausalLM",anchor:"transformers.GPTJForCausalLM",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTJForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_gptj.py#L722"}}),ss=new Te({props:{name:"forward",anchor:"transformers.GPTJForCausalLM.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.Tensor]]] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTJForCausalLM.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTJForCausalLM.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTJForCausalLM.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTJForCausalLM.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTJForCausalLM.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_attention_heads,)</code> or <code>(n_layer, num_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTJForCausalLM.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_dim)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <em>input_ids</em> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.GPTJForCausalLM.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTJForCausalLM.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTJForCausalLM.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTJForCausalLM.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for language modeling. Note that the labels <strong>are shifted</strong> inside the model, i.e. you can set
<code>labels = input_ids</code> Indices are selected in <code>[-100, 0, ..., config.vocab_size]</code> All labels set to <code>-100</code>
are ignored (masked), the loss is only computed for labels in <code>[0, ..., config.vocab_size]</code>`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_gptj.py#L812",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithPast"
>transformers.modeling_outputs.CausalLMOutputWithPast</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>)</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.CausalLMOutputWithPast"
>transformers.modeling_outputs.CausalLMOutputWithPast</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Jo=new De({props:{$$slots:{default:[lT]},$$scope:{ctx:x}}}),Mo=new De({props:{warning:!0,$$slots:{default:[dT]},$$scope:{ctx:x}}}),qo=new ft({props:{anchor:"transformers.GPTJForCausalLM.forward.example",$$slots:{default:[cT]},$$scope:{ctx:x}}}),as=new it({}),rs=new Te({props:{name:"class transformers.GPTJForSequenceClassification",anchor:"transformers.GPTJForSequenceClassification",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTJForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_gptj.py#L920"}}),ds=new Te({props:{name:"forward",anchor:"transformers.GPTJForSequenceClassification.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.Tensor]]] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTJForSequenceClassification.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTJForSequenceClassification.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTJForSequenceClassification.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTJForSequenceClassification.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTJForSequenceClassification.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_attention_heads,)</code> or <code>(n_layer, num_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTJForSequenceClassification.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_dim)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <em>input_ids</em> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.GPTJForSequenceClassification.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTJForSequenceClassification.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTJForSequenceClassification.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTJForSequenceClassification.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_gptj.py#L936",returnDescription:`
<p>A <code>transformers.modeling_outputs.SequenceClassifierOutputWithPast</code> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>tuple(tuple(torch.FloatTensor))</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 Tuple of <code>tuple(torch.FloatTensor)</code> of length <code>config.n_layers</code>, with each tuple having 2 tensors of shape
<code>(batch_size, num_heads, sequence_length, embed_size_per_head)</code>)</p>
<p>Contains pre-computed hidden-states (key and values in the self-attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><code>transformers.modeling_outputs.SequenceClassifierOutputWithPast</code> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Ao=new De({props:{$$slots:{default:[pT]},$$scope:{ctx:x}}}),zo=new De({props:{warning:!0,$$slots:{default:[hT]},$$scope:{ctx:x}}}),Io=new ft({props:{anchor:"transformers.GPTJForSequenceClassification.forward.example",$$slots:{default:[uT]},$$scope:{ctx:x}}}),Lo=new ft({props:{anchor:"transformers.GPTJForSequenceClassification.forward.example-2",$$slots:{default:[mT]},$$scope:{ctx:x}}}),cs=new it({}),ps=new Te({props:{name:"class transformers.GPTJForQuestionAnswering",anchor:"transformers.GPTJForQuestionAnswering",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.GPTJForQuestionAnswering.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_gptj.py#L1045"}}),ms=new Te({props:{name:"forward",anchor:"transformers.GPTJForQuestionAnswering.forward",parameters:[{name:"input_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"attention_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"token_type_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"position_ids",val:": typing.Optional[torch.LongTensor] = None"},{name:"head_mask",val:": typing.Optional[torch.FloatTensor] = None"},{name:"inputs_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"start_positions",val:": typing.Optional[torch.LongTensor] = None"},{name:"end_positions",val:": typing.Optional[torch.LongTensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.GPTJForQuestionAnswering.forward.input_ids",description:`<strong>input_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.GPTJForQuestionAnswering.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.GPTJForQuestionAnswering.forward.token_type_ids",description:`<strong>token_type_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.GPTJForQuestionAnswering.forward.position_ids",description:`<strong>position_ids</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.n_positions - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.GPTJForQuestionAnswering.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_attention_heads,)</code> or <code>(n_layer, num_attention_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.GPTJForQuestionAnswering.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_dim)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <em>input_ids</em> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.GPTJForQuestionAnswering.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.GPTJForQuestionAnswering.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.GPTJForQuestionAnswering.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.GPTJForQuestionAnswering.forward.start_positions",description:`<strong>start_positions</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the start of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"start_positions"},{anchor:"transformers.GPTJForQuestionAnswering.forward.end_positions",description:`<strong>end_positions</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the end of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"end_positions"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_gptj.py#L1061",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.QuestionAnsweringModelOutput"
>transformers.modeling_outputs.QuestionAnsweringModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Total span extraction loss is the sum of a Cross-Entropy for the start and end positions.</p>
</li>
<li>
<p><strong>start_logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-start scores (before SoftMax).</p>
</li>
<li>
<p><strong>end_logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-end scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_outputs.QuestionAnsweringModelOutput"
>transformers.modeling_outputs.QuestionAnsweringModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),No=new De({props:{$$slots:{default:[fT]},$$scope:{ctx:x}}}),Do=new De({props:{warning:!0,$$slots:{default:[gT]},$$scope:{ctx:x}}}),So=new ft({props:{anchor:"transformers.GPTJForQuestionAnswering.forward.example",$$slots:{default:[_T]},$$scope:{ctx:x}}}),fs=new it({}),gs=new Te({props:{name:"class transformers.TFGPTJModel",anchor:"transformers.TFGPTJModel",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFGPTJModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_tf_gptj.py#L657"}}),Uo=new De({props:{$$slots:{default:[TT]},$$scope:{ctx:x}}}),vs=new Te({props:{name:"call",anchor:"transformers.TFGPTJModel.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFGPTJModel.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past</code> is <code>None</code> else <code>past[0].shape[-2]</code> (<code>sequence_length</code> of
input past key value states). Indices of input sequence tokens in the vocabulary.</p>
<p>If <code>past</code> is used, only input IDs that do not have their past calculated should be passed as <code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFGPTJModel.call.past_key_values",description:`<strong>past_key_values</strong> (<code>List[tf.Tensor]</code> of length <code>config.n_layers</code>) &#x2014;
Contains pre-computed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past</code> output below). Can be used to speed up sequential decoding. The token ids which have their past
given to this model should not be passed as input ids as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.TFGPTJModel.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFGPTJModel.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.TFGPTJModel.call.position_ids",description:`<strong>position_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFGPTJModel.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFGPTJModel.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFGPTJModel.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFGPTJModel.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFGPTJModel.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFGPTJModel.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFGPTJModel.call.use_cache",description:`<strong>use_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, <code>past_key_values</code> key value states are returned and can be used to speed up decoding (see
<code>past</code>). Set to <code>False</code> during training, <code>True</code> during generation`,name:"use_cache"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_tf_gptj.py#L662",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFBaseModelOutputWithPast"
>transformers.modeling_tf_outputs.TFBaseModelOutputWithPast</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
<p>If <code>past_key_values</code> is used only the last hidden-state of the sequences of shape <code>(batch_size, 1, hidden_size)</code> is output.</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>List[tf.Tensor]</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 List of <code>tf.Tensor</code> of length <code>config.n_layers</code>, with each tensor of shape <code>(2, batch_size, num_heads, sequence_length, embed_size_per_head)</code>).</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFBaseModelOutputWithPast"
>transformers.modeling_tf_outputs.TFBaseModelOutputWithPast</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Wo=new De({props:{$$slots:{default:[yT]},$$scope:{ctx:x}}}),Qo=new ft({props:{anchor:"transformers.TFGPTJModel.call.example",$$slots:{default:[vT]},$$scope:{ctx:x}}}),ws=new it({}),bs=new Te({props:{name:"class transformers.TFGPTJForCausalLM",anchor:"transformers.TFGPTJForCausalLM",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFGPTJForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_tf_gptj.py#L726"}}),Ko=new De({props:{$$slots:{default:[wT]},$$scope:{ctx:x}}}),Fs=new Te({props:{name:"call",anchor:"transformers.TFGPTJForCausalLM.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFGPTJForCausalLM.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past</code> is <code>None</code> else <code>past[0].shape[-2]</code> (<code>sequence_length</code> of
input past key value states). Indices of input sequence tokens in the vocabulary.</p>
<p>If <code>past</code> is used, only input IDs that do not have their past calculated should be passed as <code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFGPTJForCausalLM.call.past_key_values",description:`<strong>past_key_values</strong> (<code>List[tf.Tensor]</code> of length <code>config.n_layers</code>) &#x2014;
Contains pre-computed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past</code> output below). Can be used to speed up sequential decoding. The token ids which have their past
given to this model should not be passed as input ids as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.TFGPTJForCausalLM.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFGPTJForCausalLM.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.TFGPTJForCausalLM.call.position_ids",description:`<strong>position_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFGPTJForCausalLM.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFGPTJForCausalLM.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFGPTJForCausalLM.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFGPTJForCausalLM.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFGPTJForCausalLM.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFGPTJForCausalLM.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFGPTJForCausalLM.call.labels",description:`<strong>labels</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Labels for language modeling. Note that the labels <strong>are shifted</strong> inside the model, i.e. you can set
<code>labels = input_ids</code> Indices are selected in <code>[-100, 0, ..., config.vocab_size]</code> All labels set to <code>-100</code>
are ignored (masked), the loss is only computed for labels in <code>[0, ..., config.vocab_size]</code>`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_tf_gptj.py#L765",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFCausalLMOutputWithPast"
>transformers.modeling_tf_outputs.TFCausalLMOutputWithPast</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(n,)</code>, <em>optional</em>, where n is the number of non-masked labels, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>List[tf.Tensor]</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 List of <code>tf.Tensor</code> of length <code>config.n_layers</code>, with each tensor of shape <code>(2, batch_size, num_heads, sequence_length, embed_size_per_head)</code>).</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFCausalLMOutputWithPast"
>transformers.modeling_tf_outputs.TFCausalLMOutputWithPast</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Ro=new De({props:{$$slots:{default:[bT]},$$scope:{ctx:x}}}),Vo=new ft({props:{anchor:"transformers.TFGPTJForCausalLM.call.example",$$slots:{default:[kT]},$$scope:{ctx:x}}}),Es=new it({}),js=new Te({props:{name:"class transformers.TFGPTJForSequenceClassification",anchor:"transformers.TFGPTJForSequenceClassification",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFGPTJForSequenceClassification.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_tf_gptj.py#L854"}}),Yo=new De({props:{$$slots:{default:[$T]},$$scope:{ctx:x}}}),Ms=new Te({props:{name:"call",anchor:"transformers.TFGPTJForSequenceClassification.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"labels",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"use_cache",val:": typing.Optional[bool] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFGPTJForSequenceClassification.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past</code> is <code>None</code> else <code>past[0].shape[-2]</code> (<code>sequence_length</code> of
input past key value states). Indices of input sequence tokens in the vocabulary.</p>
<p>If <code>past</code> is used, only input IDs that do not have their past calculated should be passed as <code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFGPTJForSequenceClassification.call.past_key_values",description:`<strong>past_key_values</strong> (<code>List[tf.Tensor]</code> of length <code>config.n_layers</code>) &#x2014;
Contains pre-computed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past</code> output below). Can be used to speed up sequential decoding. The token ids which have their past
given to this model should not be passed as input ids as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.TFGPTJForSequenceClassification.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFGPTJForSequenceClassification.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.TFGPTJForSequenceClassification.call.position_ids",description:`<strong>position_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFGPTJForSequenceClassification.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFGPTJForSequenceClassification.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFGPTJForSequenceClassification.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFGPTJForSequenceClassification.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFGPTJForSequenceClassification.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFGPTJForSequenceClassification.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFGPTJForSequenceClassification.call.labels",description:`<strong>labels</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the sequence classification/regression loss. Indices should be in <code>[0, ..., config.num_labels - 1]</code>. If <code>config.num_labels == 1</code> a regression loss is computed (Mean-Square loss), If
<code>config.num_labels &gt; 1</code> a classification loss is computed (Cross-Entropy).`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_tf_gptj.py#L868",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/model_doc/gpt2#transformers.modeling_tf_outputs.TFSequenceClassifierOutputWithPast"
>transformers.modeling_tf_outputs.TFSequenceClassifierOutputWithPast</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, )</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Classification (or regression if config.num_labels==1) loss.</p>
</li>
<li>
<p><strong>logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, config.num_labels)</code>) \u2014 Classification (or regression if config.num_labels==1) scores (before SoftMax).</p>
</li>
<li>
<p><strong>past_key_values</strong> (<code>List[tf.Tensor]</code>, <em>optional</em>, returned when <code>use_cache=True</code> is passed or when <code>config.use_cache=True</code>) \u2014 List of <code>tf.Tensor</code> of length <code>config.n_layers</code>, with each tensor of shape <code>(2, batch_size, num_heads, sequence_length, embed_size_per_head)</code>).</p>
<p>Contains pre-computed hidden-states (key and values in the attention blocks) that can be used (see
<code>past_key_values</code> input) to speed up sequential decoding.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/model_doc/gpt2#transformers.modeling_tf_outputs.TFSequenceClassifierOutputWithPast"
>transformers.modeling_tf_outputs.TFSequenceClassifierOutputWithPast</a> or <code>tuple(tf.Tensor)</code></p>
`}}),Zo=new De({props:{$$slots:{default:[PT]},$$scope:{ctx:x}}}),en=new ft({props:{anchor:"transformers.TFGPTJForSequenceClassification.call.example",$$slots:{default:[FT]},$$scope:{ctx:x}}}),tn=new ft({props:{anchor:"transformers.TFGPTJForSequenceClassification.call.example-2",$$slots:{default:[ET]},$$scope:{ctx:x}}}),qs=new it({}),Cs=new Te({props:{name:"class transformers.TFGPTJForQuestionAnswering",anchor:"transformers.TFGPTJForQuestionAnswering",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.TFGPTJForQuestionAnswering.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_tf_gptj.py#L979"}}),nn=new De({props:{$$slots:{default:[jT]},$$scope:{ctx:x}}}),Ls=new Te({props:{name:"call",anchor:"transformers.TFGPTJForQuestionAnswering.call",parameters:[{name:"input_ids",val:": typing.Union[typing.List[tensorflow.python.framework.ops.Tensor], typing.List[numpy.ndarray], typing.List[keras.engine.keras_tensor.KerasTensor], typing.Dict[str, tensorflow.python.framework.ops.Tensor], typing.Dict[str, numpy.ndarray], typing.Dict[str, keras.engine.keras_tensor.KerasTensor], tensorflow.python.framework.ops.Tensor, numpy.ndarray, keras.engine.keras_tensor.KerasTensor, NoneType] = None"},{name:"past_key_values",val:": typing.Union[typing.Tuple[typing.Tuple[typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor]]], NoneType] = None"},{name:"attention_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"token_type_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"position_ids",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"head_mask",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"inputs_embeds",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"start_positions",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"end_positions",val:": typing.Union[numpy.ndarray, tensorflow.python.framework.ops.Tensor, NoneType] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"training",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.TFGPTJForQuestionAnswering.call.input_ids",description:`<strong>input_ids</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code> if <code>past</code> is <code>None</code> else <code>past[0].shape[-2]</code> (<code>sequence_length</code> of
input past key value states). Indices of input sequence tokens in the vocabulary.</p>
<p>If <code>past</code> is used, only input IDs that do not have their past calculated should be passed as <code>input_ids</code>.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.past_key_values",description:`<strong>past_key_values</strong> (<code>List[tf.Tensor]</code> of length <code>config.n_layers</code>) &#x2014;
Contains pre-computed hidden-states (key and values in the attention blocks) as computed by the model (see
<code>past</code> output below). Can be used to speed up sequential decoding. The token ids which have their past
given to this model should not be passed as input ids as they have already been computed.`,name:"past_key_values"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.attention_mask",description:`<strong>attention_mask</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.token_type_ids",description:`<strong>token_type_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Segment token indices to indicate first and second portions of the inputs. Indices are selected in <code>[0, 1]</code>:</p>
<ul>
<li>0 corresponds to a <em>sentence A</em> token,</li>
<li>1 corresponds to a <em>sentence B</em> token.</li>
</ul>
<p><a href="../glossary#token-type-ids">What are token type IDs?</a>`,name:"token_type_ids"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.position_ids",description:`<strong>position_ids</strong> (<code>tf.Tensor</code> or <code>Numpy array</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.</p>
<p><a href="../glossary#position-ids">What are position IDs?</a>`,name:"position_ids"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.head_mask",description:`<strong>head_mask</strong> (<code>Numpy array</code> or <code>tf.Tensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing <code>input_ids</code> you can choose to directly pass an embedded representation. This
is useful if you want more control over how to convert <code>input_ids</code> indices into associated vectors than the
model&#x2019;s internal embedding lookup matrix.`,name:"inputs_embeds"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail. This argument can be used only in eager mode, in graph mode the value in the
config will be used instead.`,name:"output_attentions"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail. This argument can be used only in eager mode, in graph mode the value in the config will be
used instead.`,name:"output_hidden_states"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple. This argument can be used
in eager mode, in graph mode the value will always be set to True.`,name:"return_dict"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.training",description:`<strong>training</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to use the model in training mode (some modules like dropout modules have different
behaviors between training and evaluation).`,name:"training"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.start_positions",description:`<strong>start_positions</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the start of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"start_positions"},{anchor:"transformers.TFGPTJForQuestionAnswering.call.end_positions",description:`<strong>end_positions</strong> (<code>np.ndarray</code> or <code>tf.Tensor</code> of shape <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for position (index) of the end of the labelled span for computing the token classification loss.
Positions are clamped to the length of the sequence (<code>sequence_length</code>). Position outside of the sequence
are not taken into account for computing the loss.`,name:"end_positions"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_tf_gptj.py#L990",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput"
>transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput</a> or a tuple of <code>tf.Tensor</code> (if
<code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various elements depending on the
configuration (<a
  href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, )</code>, <em>optional</em>, returned when <code>start_positions</code> and <code>end_positions</code> are provided) \u2014 Total span extraction loss is the sum of a Cross-Entropy for the start and end positions.</p>
</li>
<li>
<p><strong>start_logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-start scores (before SoftMax).</p>
</li>
<li>
<p><strong>end_logits</strong> (<code>tf.Tensor</code> of shape <code>(batch_size, sequence_length)</code>) \u2014 Span-end scores (before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(tf.Tensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>tf.Tensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput"
>transformers.modeling_tf_outputs.TFQuestionAnsweringModelOutput</a> or <code>tuple(tf.Tensor)</code></p>
`}}),sn=new De({props:{$$slots:{default:[xT]},$$scope:{ctx:x}}}),an=new ft({props:{anchor:"transformers.TFGPTJForQuestionAnswering.call.example",$$slots:{default:[GT]},$$scope:{ctx:x}}}),rn=new ft({props:{anchor:"transformers.TFGPTJForQuestionAnswering.call.example-2",$$slots:{default:[JT]},$$scope:{ctx:x}}}),Os=new it({}),Ns=new Te({props:{name:"class transformers.FlaxGPTJModel",anchor:"transformers.FlaxGPTJModel",parameters:[{name:"config",val:": GPTJConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxGPTJModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxGPTJModel.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/main/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/main/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_flax_gptj.py#L616"}}),Ks=new Te({props:{name:"__call__",anchor:"transformers.FlaxGPTJModel.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"position_ids",val:" = None"},{name:"params",val:": dict = None"},{name:"past_key_values",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.FlaxGPTJModel.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code>. Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxGPTJModel.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxGPTJModel.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxGPTJModel.__call__.past_key_values",description:`<strong>past_key_values</strong> (<code>Dict[str, np.ndarray]</code>, <em>optional</em>, returned by <code>init_cache</code> or when passing previous <code>past_key_values</code>) &#x2014;
Dictionary of pre-computed hidden-states (key and values in the attention blocks) that can be used for fast
auto-regressive decoding. Pre-computed key and value hidden-states are of shape <em>[batch_size, max_length]</em>.`,name:"past_key_values"},{anchor:"transformers.FlaxGPTJModel.__call__.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxGPTJModel.__call__.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxGPTJModel.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_flax_gptj.py#L434",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),dn=new De({props:{$$slots:{default:[MT]},$$scope:{ctx:x}}}),cn=new ft({props:{anchor:"transformers.FlaxGPTJModel.__call__.example",$$slots:{default:[qT]},$$scope:{ctx:x}}}),Rs=new it({}),Vs=new Te({props:{name:"class transformers.FlaxGPTJForCausalLM",anchor:"transformers.FlaxGPTJForCausalLM",parameters:[{name:"config",val:": GPTJConfig"},{name:"input_shape",val:": typing.Tuple = (1, 1)"},{name:"seed",val:": int = 0"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"},{name:"_do_init",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.FlaxGPTJForCausalLM.config",description:`<strong>config</strong> (<a href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig">GPTJConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/main/en/main_classes/model#transformers.FlaxPreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"},{anchor:"transformers.FlaxGPTJForCausalLM.dtype",description:`<strong>dtype</strong> (<code>jax.numpy.dtype</code>, <em>optional</em>, defaults to <code>jax.numpy.float32</code>) &#x2014;
The data type of the computation. Can be one of <code>jax.numpy.float32</code>, <code>jax.numpy.float16</code> (on GPUs) and
<code>jax.numpy.bfloat16</code> (on TPUs).</p>
<p>This can be used to enable mixed-precision training or half-precision inference on GPUs or TPUs. If
specified all the computation will be performed with the given <code>dtype</code>.</p>
<p><strong>Note that this only specifies the dtype of the computation and does not influence the dtype of model
parameters.</strong></p>
<p>If you wish to change the dtype of the model parameters, see <a href="/docs/transformers/main/en/main_classes/model#transformers.FlaxPreTrainedModel.to_fp16">to_fp16()</a> and
<a href="/docs/transformers/main/en/main_classes/model#transformers.FlaxPreTrainedModel.to_bf16">to_bf16()</a>.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_flax_gptj.py#L682"}}),sa=new Te({props:{name:"__call__",anchor:"transformers.FlaxGPTJForCausalLM.__call__",parameters:[{name:"input_ids",val:""},{name:"attention_mask",val:" = None"},{name:"position_ids",val:" = None"},{name:"params",val:": dict = None"},{name:"past_key_values",val:": dict = None"},{name:"dropout_rng",val:": PRNGKey = None"},{name:"train",val:": bool = False"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.FlaxGPTJForCausalLM.__call__.input_ids",description:`<strong>input_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, input_ids_length)</code>) &#x2014;
<code>input_ids_length</code> = <code>sequence_length</code>. Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. See <a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/main/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_ids"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.attention_mask",description:`<strong>attention_mask</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.position_ids",description:`<strong>position_ids</strong> (<code>numpy.ndarray</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Indices of positions of each input sequence tokens in the position embeddings. Selected in the range <code>[0, config.max_position_embeddings - 1]</code>.`,name:"position_ids"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.past_key_values",description:`<strong>past_key_values</strong> (<code>Dict[str, np.ndarray]</code>, <em>optional</em>, returned by <code>init_cache</code> or when passing previous <code>past_key_values</code>) &#x2014;
Dictionary of pre-computed hidden-states (key and values in the attention blocks) that can be used for fast
auto-regressive decoding. Pre-computed key and value hidden-states are of shape <em>[batch_size, max_length]</em>.`,name:"past_key_values"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.FlaxGPTJForCausalLM.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/main/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/models/gptj/modeling_flax_gptj.py#L434",returnDescription:`
<p>A <a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/main/en/model_doc/gptj#transformers.GPTJConfig"
>GPTJConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>logits</strong> (<code>jnp.ndarray</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for the output of the embeddings + one for the output of each layer) of shape
<code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(jnp.ndarray)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>jnp.ndarray</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/main_classes/output#transformers.modeling_flax_outputs.FlaxMaskedLMOutput"
>transformers.modeling_flax_outputs.FlaxMaskedLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),hn=new De({props:{$$slots:{default:[CT]},$$scope:{ctx:x}}}),un=new ft({props:{anchor:"transformers.FlaxGPTJForCausalLM.__call__.example",$$slots:{default:[AT]},$$scope:{ctx:x}}}),{c(){d=a("meta"),y=p(),u=a("h1"),f=a("a"),T=a("span"),w(l.$$.fragment),c=p(),E=a("span"),A=n("GPT-J"),M=p(),C=a("h2"),D=a("a"),oe=a("span"),w(j.$$.fragment),Pe=p(),H=a("span"),Fe=n("Overview"),ye=p(),B=a("p"),Ee=n("The GPT-J model was released in the "),ie=a("a"),V=n("kingoflolz/mesh-transformer-jax"),je=n(` repository by Ben Wang and Aran Komatsuzaki. It is a GPT-2-like
causal language model trained on `),le=a("a"),X=n("the Pile"),xe=n(" dataset."),ve=p(),Q=a("p"),Ge=n("This model was contributed by "),de=a("a"),ce=n("Stella Biderman"),q=n("."),z=p(),me=a("p"),Y=n("Tips:"),we=p(),fe=a("ul"),O=a("li"),Je=n("To load "),pe=a("a"),L=n("GPT-J"),Me=n(` in float32 one would need at least 2x model size CPU
RAM: 1x for initial weights and another 1x to load the checkpoint. So for GPT-J it would take at least 48GB of CPU
RAM to just load the model. To reduce the CPU RAM usage there are a few options. The `),K=a("code"),qe=n("torch_dtype"),Ce=n(` argument can be
used to initialize the model in half-precision. And the `),R=a("code"),Ae=n("low_cpu_mem_usage"),ze=n(` argument can be used to keep the RAM
usage to 1x. There is also a `),S=a("a"),Ie=n("fp16 branch"),Z=n(` which stores
the fp16 weights, which could be used to further minimize the RAM usage. Combining all this it should take roughly
12.1GB of CPU RAM to load the model.`),be=p(),w(ee.$$.fragment),I=p(),ae=a("ul"),N=a("li"),ge=a("p"),Le=n(`The model should fit on 16GB GPU for inference. For training/fine-tuning it would take much more GPU RAM. Adam
optimizer for example makes four copies of the model: model, gradients, average and squared average of the gradients.
So it would need at least 4x model size GPU memory, even with mixed precision as gradient updates are in fp32. This
is not including the activations and data batches, which would again require some more GPU RAM. So one should explore
solutions such as DeepSpeed, to train/fine-tune the model. Another option is to use the original codebase to
train/fine-tune the model on TPU and then convert the model to Transformers format for inference. Instructions for
that could be found `),v=a("a"),G=n("here"),Ye=p(),ne=a("li"),he=a("p"),Ze=n(`Although the embedding matrix has a size of 50400, only 50257 entries are used by the GPT-2 tokenizer. These extra
tokens are added for the sake of efficiency on TPUs. To avoid the mismatch between embedding matrix size and vocab
size, the tokenizer for `),J=a("a"),et=n("GPT-J"),tt=n(` contains 143 extra tokens
`),Se=a("code"),ot=n("<|extratoken_1|>... <|extratoken_143|>"),nt=n(", so the "),U=a("code"),te=n("vocab_size"),st=n(" of tokenizer also becomes 50400."),Re=p(),W=a("h3"),ke=a("a"),Be=a("span"),w(ue.$$.fragment),at=p(),se=a("span"),rt=n("Generation"),Ui=p(),bo=a("p"),sd=n("The "),ha=a("a"),ad=n("generate()"),rd=n(` method can be used to generate text using GPT-J
model.`),Wi=p(),w(bn.$$.fragment),Qi=p(),ua=a("p"),id=n("\u2026or in float16 precision:"),Hi=p(),w(kn.$$.fragment),Ki=p(),Rt=a("h2"),ko=a("a"),rr=a("span"),w($n.$$.fragment),ld=p(),ir=a("span"),dd=n("Resources"),Ri=p(),ma=a("p"),cd=n("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with GPT-J. If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Vi=p(),w(Pn.$$.fragment),Xi=p(),re=a("ul"),Fn=a("li"),pd=n("Description of "),En=a("a"),hd=n("GPT-J"),ud=n("."),md=p(),jn=a("li"),fd=n("A blog on how to "),xn=a("a"),gd=n("Deploy GPT-J 6B for inference using Hugging Face Transformers and Amazon SageMaker"),_d=n("."),Td=p(),Gn=a("li"),yd=n("A blog on how to "),Jn=a("a"),vd=n("Accelerate GPT-J inference with DeepSpeed-Inference on GPUs"),wd=n("."),bd=p(),Mn=a("li"),kd=n("A blog post introducing "),qn=a("a"),$d=n("GPT-J-6B: 6B JAX-Based Transformer"),Pd=n(". \u{1F30E}"),Fd=p(),Cn=a("li"),Ed=n("A notebook for "),An=a("a"),jd=n("GPT-J-6B Inference Demo"),xd=n(". \u{1F30E}"),Gd=p(),zn=a("li"),Jd=n("Another notebook demonstrating "),In=a("a"),Md=n("Inference with GPT-J-6B"),qd=n("."),Cd=p(),fa=a("li"),Ln=a("a"),Ad=n("Causal language modeling"),zd=n(" chapter of the \u{1F917} Hugging Face Course."),Id=p(),kt=a("li"),ga=a("a"),Ld=n("GPTJForCausalLM"),Od=n(" is supported by this "),On=a("a"),Nd=n("causal language modeling example script"),Dd=n(", "),Nn=a("a"),Sd=n("text generation example script"),Bd=n(", and "),Dn=a("a"),Ud=n("notebook"),Wd=n("."),Qd=p(),Lt=a("li"),_a=a("a"),Hd=n("TFGPTJForCausalLM"),Kd=n(" is supported by this "),Sn=a("a"),Rd=n("causal language modeling example script"),Vd=n(" and "),Bn=a("a"),Xd=n("notebook"),Yd=n("."),Zd=p(),Ot=a("li"),Ta=a("a"),ec=n("FlaxGPTJForCausalLM"),tc=n(" is supported by this "),Un=a("a"),oc=n("causal language modeling example script"),nc=n(" and "),Wn=a("a"),sc=n("notebook"),ac=n("."),Yi=p(),ya=a("p"),lr=a("strong"),rc=n("Documentation resources"),Zi=p(),Nt=a("ul"),dr=a("li"),va=a("a"),ic=n("Text classification task guide"),lc=p(),cr=a("li"),wa=a("a"),dc=n("Question answering task guide"),cc=p(),pr=a("li"),ba=a("a"),pc=n("Causal language modeling task guide"),el=p(),Vt=a("h2"),$o=a("a"),hr=a("span"),w(Qn.$$.fragment),hc=p(),ur=a("span"),uc=n("GPTJConfig"),tl=p(),qt=a("div"),w(Hn.$$.fragment),mc=p(),_t=a("p"),fc=n("This is the configuration class to store the configuration of a "),ka=a("a"),gc=n("GPTJModel"),_c=n(`. It is used to instantiate a GPT-J
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the GPT-J
`),Kn=a("a"),Tc=n("EleutherAI/gpt-j-6B"),yc=n(` architecture. Configuration objects inherit from
`),$a=a("a"),vc=n("PretrainedConfig"),wc=n(" and can be used to control the model outputs. Read the documentation from "),Pa=a("a"),bc=n("PretrainedConfig"),kc=n(`
for more information.`),$c=p(),w(Po.$$.fragment),ol=p(),Xt=a("h2"),Fo=a("a"),mr=a("span"),w(Rn.$$.fragment),Pc=p(),fr=a("span"),Fc=n("GPTJModel"),nl=p(),Ct=a("div"),w(Vn.$$.fragment),Ec=p(),Xn=a("p"),jc=n(`The bare GPT-J Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),Yn=a("a"),xc=n("torch.nn.Module"),Gc=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Jc=p(),lt=a("div"),w(Zn.$$.fragment),Mc=p(),Yt=a("p"),qc=n("The "),Fa=a("a"),Cc=n("GPTJModel"),Ac=n(" forward method, overrides the "),gr=a("code"),zc=n("__call__"),Ic=n(" special method."),Lc=p(),w(Eo.$$.fragment),Oc=p(),w(jo.$$.fragment),Nc=p(),w(xo.$$.fragment),sl=p(),Zt=a("h2"),Go=a("a"),_r=a("span"),w(es.$$.fragment),Dc=p(),Tr=a("span"),Sc=n("GPTJForCausalLM"),al=p(),Tt=a("div"),w(ts.$$.fragment),Bc=p(),yr=a("p"),Uc=n("The GPT-J Model transformer with a language modeling head on top."),Wc=p(),os=a("p"),Qc=n("This model is a PyTorch "),ns=a("a"),Hc=n("torch.nn.Module"),Kc=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Rc=p(),dt=a("div"),w(ss.$$.fragment),Vc=p(),eo=a("p"),Xc=n("The "),Ea=a("a"),Yc=n("GPTJForCausalLM"),Zc=n(" forward method, overrides the "),vr=a("code"),ep=n("__call__"),tp=n(" special method."),op=p(),w(Jo.$$.fragment),np=p(),w(Mo.$$.fragment),sp=p(),w(qo.$$.fragment),rl=p(),to=a("h2"),Co=a("a"),wr=a("span"),w(as.$$.fragment),ap=p(),br=a("span"),rp=n("GPTJForSequenceClassification"),il=p(),Ue=a("div"),w(rs.$$.fragment),ip=p(),kr=a("p"),lp=n("The GPT-J Model transformer with a sequence classification head on top (linear layer)."),dp=p(),ja=a("p"),xa=a("a"),cp=n("GPTJForSequenceClassification"),pp=n(` uses the last token in order to do the classification, as other causal models
(e.g. GPT, GPT-2, GPT-Neo) do.`),hp=p(),yt=a("p"),up=n(`Since it does classification on the last token, it requires to know the position of the last token. If a
`),$r=a("code"),mp=n("pad_token_id"),fp=n(` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),Pr=a("code"),gp=n("pad_token_id"),_p=n(` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Fr=a("code"),Tp=n("inputs_embeds"),yp=n(" are passed instead of "),Er=a("code"),vp=n("input_ids"),wp=n(`, it does the same (take the last value in
each row of the batch).`),bp=p(),is=a("p"),kp=n("This model is a PyTorch "),ls=a("a"),$p=n("torch.nn.Module"),Pp=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Fp=p(),Ve=a("div"),w(ds.$$.fragment),Ep=p(),oo=a("p"),jp=n("The "),Ga=a("a"),xp=n("GPTJForSequenceClassification"),Gp=n(" forward method, overrides the "),jr=a("code"),Jp=n("__call__"),Mp=n(" special method."),qp=p(),w(Ao.$$.fragment),Cp=p(),w(zo.$$.fragment),Ap=p(),w(Io.$$.fragment),zp=p(),w(Lo.$$.fragment),ll=p(),no=a("h2"),Oo=a("a"),xr=a("span"),w(cs.$$.fragment),Ip=p(),Gr=a("span"),Lp=n("GPTJForQuestionAnswering"),dl=p(),vt=a("div"),w(ps.$$.fragment),Op=p(),so=a("p"),Np=n(`The GPT-J Model transformer with a span classification head on top for extractive question-answering tasks like
SQuAD (a linear layers on top of the hidden-states output to compute `),Jr=a("code"),Dp=n("span start logits"),Sp=n(" and "),Mr=a("code"),Bp=n("span end logits"),Up=n(")."),Wp=p(),hs=a("p"),Qp=n("This model is a PyTorch "),us=a("a"),Hp=n("torch.nn.Module"),Kp=n(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Rp=p(),ct=a("div"),w(ms.$$.fragment),Vp=p(),ao=a("p"),Xp=n("The "),Ja=a("a"),Yp=n("GPTJForQuestionAnswering"),Zp=n(" forward method, overrides the "),qr=a("code"),eh=n("__call__"),th=n(" special method."),oh=p(),w(No.$$.fragment),nh=p(),w(Do.$$.fragment),sh=p(),w(So.$$.fragment),cl=p(),ro=a("h2"),Bo=a("a"),Cr=a("span"),w(fs.$$.fragment),ah=p(),Ar=a("span"),rh=n("TFGPTJModel"),pl=p(),We=a("div"),w(gs.$$.fragment),ih=p(),zr=a("p"),lh=n("The bare GPT-J Model transformer outputting raw hidden-states without any specific head on top."),dh=p(),_s=a("p"),ch=n("This model inherits from "),Ma=a("a"),ph=n("TFPreTrainedModel"),hh=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),uh=p(),Ts=a("p"),mh=n("This model is also a "),ys=a("a"),fh=n("tf.keras.Model"),gh=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),_h=p(),w(Uo.$$.fragment),Th=p(),$t=a("div"),w(vs.$$.fragment),yh=p(),io=a("p"),vh=n("The "),qa=a("a"),wh=n("TFGPTJModel"),bh=n(" forward method, overrides the "),Ir=a("code"),kh=n("__call__"),$h=n(" special method."),Ph=p(),w(Wo.$$.fragment),Fh=p(),w(Qo.$$.fragment),hl=p(),lo=a("h2"),Ho=a("a"),Lr=a("span"),w(ws.$$.fragment),Eh=p(),Or=a("span"),jh=n("TFGPTJForCausalLM"),ul=p(),Qe=a("div"),w(bs.$$.fragment),xh=p(),Nr=a("p"),Gh=n("The GPT-J Model transformer with a language modeling head on top."),Jh=p(),ks=a("p"),Mh=n("This model inherits from "),Ca=a("a"),qh=n("TFPreTrainedModel"),Ch=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ah=p(),$s=a("p"),zh=n("This model is also a "),Ps=a("a"),Ih=n("tf.keras.Model"),Lh=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Oh=p(),w(Ko.$$.fragment),Nh=p(),Pt=a("div"),w(Fs.$$.fragment),Dh=p(),co=a("p"),Sh=n("The "),Aa=a("a"),Bh=n("TFGPTJForCausalLM"),Uh=n(" forward method, overrides the "),Dr=a("code"),Wh=n("__call__"),Qh=n(" special method."),Hh=p(),w(Ro.$$.fragment),Kh=p(),w(Vo.$$.fragment),ml=p(),po=a("h2"),Xo=a("a"),Sr=a("span"),w(Es.$$.fragment),Rh=p(),Br=a("span"),Vh=n("TFGPTJForSequenceClassification"),fl=p(),_e=a("div"),w(js.$$.fragment),Xh=p(),Ur=a("p"),Yh=n("The GPT-J Model transformer with a sequence classification head on top (linear layer)."),Zh=p(),za=a("p"),Ia=a("a"),eu=n("GPTJForSequenceClassification"),tu=n(` uses the last token in order to do the classification, as other causal models
(e.g. GPT, GPT-2, GPT-Neo) do.`),ou=p(),wt=a("p"),nu=n(`Since it does classification on the last token, it requires to know the position of the last token. If a
`),Wr=a("code"),su=n("pad_token_id"),au=n(` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),Qr=a("code"),ru=n("pad_token_id"),iu=n(` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Hr=a("code"),lu=n("inputs_embeds"),du=n(" are passed instead of "),Kr=a("code"),cu=n("input_ids"),pu=n(`, it does the same (take the last value in
each row of the batch).`),hu=p(),xs=a("p"),uu=n("This model inherits from "),La=a("a"),mu=n("TFPreTrainedModel"),fu=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),gu=p(),Gs=a("p"),_u=n("This model is also a "),Js=a("a"),Tu=n("tf.keras.Model"),yu=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),vu=p(),w(Yo.$$.fragment),wu=p(),pt=a("div"),w(Ms.$$.fragment),bu=p(),ho=a("p"),ku=n("The "),Oa=a("a"),$u=n("TFGPTJForSequenceClassification"),Pu=n(" forward method, overrides the "),Rr=a("code"),Fu=n("__call__"),Eu=n(" special method."),ju=p(),w(Zo.$$.fragment),xu=p(),w(en.$$.fragment),Gu=p(),w(tn.$$.fragment),gl=p(),uo=a("h2"),on=a("a"),Vr=a("span"),w(qs.$$.fragment),Ju=p(),Xr=a("span"),Mu=n("TFGPTJForQuestionAnswering"),_l=p(),He=a("div"),w(Cs.$$.fragment),qu=p(),mo=a("p"),Cu=n(`The GPT-J Model transformer with a span classification head on top for extractive question-answering tasks like
SQuAD (a linear layers on top of the hidden-states output to compute `),Yr=a("code"),Au=n("span start logits"),zu=n(" and "),Zr=a("code"),Iu=n("span end logits"),Lu=n(")."),Ou=p(),As=a("p"),Nu=n("This model inherits from "),Na=a("a"),Du=n("TFPreTrainedModel"),Su=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Bu=p(),zs=a("p"),Uu=n("This model is also a "),Is=a("a"),Wu=n("tf.keras.Model"),Qu=n(` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Hu=p(),w(nn.$$.fragment),Ku=p(),ht=a("div"),w(Ls.$$.fragment),Ru=p(),fo=a("p"),Vu=n("The "),Da=a("a"),Xu=n("TFGPTJForQuestionAnswering"),Yu=n(" forward method, overrides the "),ei=a("code"),Zu=n("__call__"),em=n(" special method."),tm=p(),w(sn.$$.fragment),om=p(),w(an.$$.fragment),nm=p(),w(rn.$$.fragment),Tl=p(),go=a("h2"),ln=a("a"),ti=a("span"),w(Os.$$.fragment),sm=p(),oi=a("span"),am=n("FlaxGPTJModel"),yl=p(),Oe=a("div"),w(Ns.$$.fragment),rm=p(),ni=a("p"),im=n("The bare GPTJ Model transformer outputting raw hidden-states without any specific head on top."),lm=p(),Ds=a("p"),dm=n("This model inherits from "),Sa=a("a"),cm=n("FlaxPreTrainedModel"),pm=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),hm=p(),Ss=a("p"),um=n(`This model is also a Flax Linen
`),Bs=a("a"),mm=n("flax.nn.Module"),fm=n(` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),gm=p(),si=a("p"),_m=n("Finally, this model supports inherent JAX features such as:"),Tm=p(),At=a("ul"),ai=a("li"),Us=a("a"),ym=n("Just-In-Time (JIT) compilation"),vm=p(),ri=a("li"),Ws=a("a"),wm=n("Automatic Differentiation"),bm=p(),ii=a("li"),Qs=a("a"),km=n("Vectorization"),$m=p(),li=a("li"),Hs=a("a"),Pm=n("Parallelization"),Fm=p(),Ft=a("div"),w(Ks.$$.fragment),Em=p(),_o=a("p"),jm=n("The "),di=a("code"),xm=n("FlaxGPTJPreTrainedModel"),Gm=n(" forward method, overrides the "),ci=a("code"),Jm=n("__call__"),Mm=n(" special method."),qm=p(),w(dn.$$.fragment),Cm=p(),w(cn.$$.fragment),vl=p(),To=a("h2"),pn=a("a"),pi=a("span"),w(Rs.$$.fragment),Am=p(),hi=a("span"),zm=n("FlaxGPTJForCausalLM"),wl=p(),Ne=a("div"),w(Vs.$$.fragment),Im=p(),ui=a("p"),Lm=n("The GPTJ Model transformer with a language modeling head on top."),Om=p(),Xs=a("p"),Nm=n("This model inherits from "),Ba=a("a"),Dm=n("FlaxPreTrainedModel"),Sm=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Bm=p(),Ys=a("p"),Um=n(`This model is also a Flax Linen
`),Zs=a("a"),Wm=n("flax.nn.Module"),Qm=n(` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),Hm=p(),mi=a("p"),Km=n("Finally, this model supports inherent JAX features such as:"),Rm=p(),zt=a("ul"),fi=a("li"),ea=a("a"),Vm=n("Just-In-Time (JIT) compilation"),Xm=p(),gi=a("li"),ta=a("a"),Ym=n("Automatic Differentiation"),Zm=p(),_i=a("li"),oa=a("a"),ef=n("Vectorization"),tf=p(),Ti=a("li"),na=a("a"),of=n("Parallelization"),nf=p(),Et=a("div"),w(sa.$$.fragment),sf=p(),yo=a("p"),af=n("The "),yi=a("code"),rf=n("FlaxGPTJPreTrainedModel"),lf=n(" forward method, overrides the "),vi=a("code"),df=n("__call__"),cf=n(" special method."),pf=p(),w(hn.$$.fragment),hf=p(),w(un.$$.fragment),this.h()},l(o){const _=tT('[data-svelte="svelte-1phssyn"]',document.head);d=r(_,"META",{name:!0,content:!0}),_.forEach(t),y=h(o),u=r(o,"H1",{class:!0});var aa=i(u);f=r(aa,"A",{id:!0,class:!0,href:!0});var wi=i(f);T=r(wi,"SPAN",{});var bi=i(T);b(l.$$.fragment,bi),bi.forEach(t),wi.forEach(t),c=h(aa),E=r(aa,"SPAN",{});var ki=i(E);A=s(ki,"GPT-J"),ki.forEach(t),aa.forEach(t),M=h(o),C=r(o,"H2",{class:!0});var ra=i(C);D=r(ra,"A",{id:!0,class:!0,href:!0});var $i=i(D);oe=r($i,"SPAN",{});var Pi=i(oe);b(j.$$.fragment,Pi),Pi.forEach(t),$i.forEach(t),Pe=h(ra),H=r(ra,"SPAN",{});var Fi=i(H);Fe=s(Fi,"Overview"),Fi.forEach(t),ra.forEach(t),ye=h(o),B=r(o,"P",{});var vo=i(B);Ee=s(vo,"The GPT-J model was released in the "),ie=r(vo,"A",{href:!0,rel:!0});var Ei=i(ie);V=s(Ei,"kingoflolz/mesh-transformer-jax"),Ei.forEach(t),je=s(vo,` repository by Ben Wang and Aran Komatsuzaki. It is a GPT-2-like
causal language model trained on `),le=r(vo,"A",{href:!0,rel:!0});var ji=i(le);X=s(ji,"the Pile"),ji.forEach(t),xe=s(vo," dataset."),vo.forEach(t),ve=h(o),Q=r(o,"P",{});var ia=i(Q);Ge=s(ia,"This model was contributed by "),de=r(ia,"A",{href:!0,rel:!0});var xi=i(de);ce=s(xi,"Stella Biderman"),xi.forEach(t),q=s(ia,"."),ia.forEach(t),z=h(o),me=r(o,"P",{});var Gi=i(me);Y=s(Gi,"Tips:"),Gi.forEach(t),we=h(o),fe=r(o,"UL",{});var Ji=i(fe);O=r(Ji,"LI",{});var bt=i(O);Je=s(bt,"To load "),pe=r(bt,"A",{href:!0,rel:!0});var Mi=i(pe);L=s(Mi,"GPT-J"),Mi.forEach(t),Me=s(bt,` in float32 one would need at least 2x model size CPU
RAM: 1x for initial weights and another 1x to load the checkpoint. So for GPT-J it would take at least 48GB of CPU
RAM to just load the model. To reduce the CPU RAM usage there are a few options. The `),K=r(bt,"CODE",{});var qi=i(K);qe=s(qi,"torch_dtype"),qi.forEach(t),Ce=s(bt,` argument can be
used to initialize the model in half-precision. And the `),R=r(bt,"CODE",{});var Ci=i(R);Ae=s(Ci,"low_cpu_mem_usage"),Ci.forEach(t),ze=s(bt,` argument can be used to keep the RAM
usage to 1x. There is also a `),S=r(bt,"A",{href:!0,rel:!0});var Ai=i(S);Ie=s(Ai,"fp16 branch"),Ai.forEach(t),Z=s(bt,` which stores
the fp16 weights, which could be used to further minimize the RAM usage. Combining all this it should take roughly
12.1GB of CPU RAM to load the model.`),bt.forEach(t),Ji.forEach(t),be=h(o),b(ee.$$.fragment,o),I=h(o),ae=r(o,"UL",{});var la=i(ae);N=r(la,"LI",{});var zi=i(N);ge=r(zi,"P",{});var Ua=i(ge);Le=s(Ua,`The model should fit on 16GB GPU for inference. For training/fine-tuning it would take much more GPU RAM. Adam
optimizer for example makes four copies of the model: model, gradients, average and squared average of the gradients.
So it would need at least 4x model size GPU memory, even with mixed precision as gradient updates are in fp32. This
is not including the activations and data batches, which would again require some more GPU RAM. So one should explore
solutions such as DeepSpeed, to train/fine-tune the model. Another option is to use the original codebase to
train/fine-tune the model on TPU and then convert the model to Transformers format for inference. Instructions for
that could be found `),v=r(Ua,"A",{href:!0,rel:!0});var Ii=i(v);G=s(Ii,"here"),Ii.forEach(t),Ua.forEach(t),zi.forEach(t),Ye=h(la),ne=r(la,"LI",{});var Li=i(ne);he=r(Li,"P",{});var It=i(he);Ze=s(It,`Although the embedding matrix has a size of 50400, only 50257 entries are used by the GPT-2 tokenizer. These extra
tokens are added for the sake of efficiency on TPUs. To avoid the mismatch between embedding matrix size and vocab
size, the tokenizer for `),J=r(It,"A",{href:!0,rel:!0});var Oi=i(J);et=s(Oi,"GPT-J"),Oi.forEach(t),tt=s(It,` contains 143 extra tokens
`),Se=r(It,"CODE",{});var Ni=i(Se);ot=s(Ni,"<|extratoken_1|>... <|extratoken_143|>"),Ni.forEach(t),nt=s(It,", so the "),U=r(It,"CODE",{});var Di=i(U);te=s(Di,"vocab_size"),Di.forEach(t),st=s(It," of tokenizer also becomes 50400."),It.forEach(t),Li.forEach(t),la.forEach(t),Re=h(o),W=r(o,"H3",{class:!0});var da=i(W);ke=r(da,"A",{id:!0,class:!0,href:!0});var Si=i(ke);Be=r(Si,"SPAN",{});var Bi=i(Be);b(ue.$$.fragment,Bi),Bi.forEach(t),Si.forEach(t),at=h(da),se=r(da,"SPAN",{});var gf=i(se);rt=s(gf,"Generation"),gf.forEach(t),da.forEach(t),Ui=h(o),bo=r(o,"P",{});var kl=i(bo);sd=s(kl,"The "),ha=r(kl,"A",{href:!0});var _f=i(ha);ad=s(_f,"generate()"),_f.forEach(t),rd=s(kl,` method can be used to generate text using GPT-J
model.`),kl.forEach(t),Wi=h(o),b(bn.$$.fragment,o),Qi=h(o),ua=r(o,"P",{});var Tf=i(ua);id=s(Tf,"\u2026or in float16 precision:"),Tf.forEach(t),Hi=h(o),b(kn.$$.fragment,o),Ki=h(o),Rt=r(o,"H2",{class:!0});var $l=i(Rt);ko=r($l,"A",{id:!0,class:!0,href:!0});var yf=i(ko);rr=r(yf,"SPAN",{});var vf=i(rr);b($n.$$.fragment,vf),vf.forEach(t),yf.forEach(t),ld=h($l),ir=r($l,"SPAN",{});var wf=i(ir);dd=s(wf,"Resources"),wf.forEach(t),$l.forEach(t),Ri=h(o),ma=r(o,"P",{});var bf=i(ma);cd=s(bf,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with GPT-J. If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),bf.forEach(t),Vi=h(o),b(Pn.$$.fragment,o),Xi=h(o),re=r(o,"UL",{});var $e=i(re);Fn=r($e,"LI",{});var Pl=i(Fn);pd=s(Pl,"Description of "),En=r(Pl,"A",{href:!0,rel:!0});var kf=i(En);hd=s(kf,"GPT-J"),kf.forEach(t),ud=s(Pl,"."),Pl.forEach(t),md=h($e),jn=r($e,"LI",{});var Fl=i(jn);fd=s(Fl,"A blog on how to "),xn=r(Fl,"A",{href:!0,rel:!0});var $f=i(xn);gd=s($f,"Deploy GPT-J 6B for inference using Hugging Face Transformers and Amazon SageMaker"),$f.forEach(t),_d=s(Fl,"."),Fl.forEach(t),Td=h($e),Gn=r($e,"LI",{});var El=i(Gn);yd=s(El,"A blog on how to "),Jn=r(El,"A",{href:!0,rel:!0});var Pf=i(Jn);vd=s(Pf,"Accelerate GPT-J inference with DeepSpeed-Inference on GPUs"),Pf.forEach(t),wd=s(El,"."),El.forEach(t),bd=h($e),Mn=r($e,"LI",{});var jl=i(Mn);kd=s(jl,"A blog post introducing "),qn=r(jl,"A",{href:!0,rel:!0});var Ff=i(qn);$d=s(Ff,"GPT-J-6B: 6B JAX-Based Transformer"),Ff.forEach(t),Pd=s(jl,". \u{1F30E}"),jl.forEach(t),Fd=h($e),Cn=r($e,"LI",{});var xl=i(Cn);Ed=s(xl,"A notebook for "),An=r(xl,"A",{href:!0,rel:!0});var Ef=i(An);jd=s(Ef,"GPT-J-6B Inference Demo"),Ef.forEach(t),xd=s(xl,". \u{1F30E}"),xl.forEach(t),Gd=h($e),zn=r($e,"LI",{});var Gl=i(zn);Jd=s(Gl,"Another notebook demonstrating "),In=r(Gl,"A",{href:!0,rel:!0});var jf=i(In);Md=s(jf,"Inference with GPT-J-6B"),jf.forEach(t),qd=s(Gl,"."),Gl.forEach(t),Cd=h($e),fa=r($e,"LI",{});var uf=i(fa);Ln=r(uf,"A",{href:!0,rel:!0});var xf=i(Ln);Ad=s(xf,"Causal language modeling"),xf.forEach(t),zd=s(uf," chapter of the \u{1F917} Hugging Face Course."),uf.forEach(t),Id=h($e),kt=r($e,"LI",{});var wo=i(kt);ga=r(wo,"A",{href:!0});var Gf=i(ga);Ld=s(Gf,"GPTJForCausalLM"),Gf.forEach(t),Od=s(wo," is supported by this "),On=r(wo,"A",{href:!0,rel:!0});var Jf=i(On);Nd=s(Jf,"causal language modeling example script"),Jf.forEach(t),Dd=s(wo,", "),Nn=r(wo,"A",{href:!0,rel:!0});var Mf=i(Nn);Sd=s(Mf,"text generation example script"),Mf.forEach(t),Bd=s(wo,", and "),Dn=r(wo,"A",{href:!0,rel:!0});var qf=i(Dn);Ud=s(qf,"notebook"),qf.forEach(t),Wd=s(wo,"."),wo.forEach(t),Qd=h($e),Lt=r($e,"LI",{});var ca=i(Lt);_a=r(ca,"A",{href:!0});var Cf=i(_a);Hd=s(Cf,"TFGPTJForCausalLM"),Cf.forEach(t),Kd=s(ca," is supported by this "),Sn=r(ca,"A",{href:!0,rel:!0});var Af=i(Sn);Rd=s(Af,"causal language modeling example script"),Af.forEach(t),Vd=s(ca," and "),Bn=r(ca,"A",{href:!0,rel:!0});var zf=i(Bn);Xd=s(zf,"notebook"),zf.forEach(t),Yd=s(ca,"."),ca.forEach(t),Zd=h($e),Ot=r($e,"LI",{});var pa=i(Ot);Ta=r(pa,"A",{href:!0});var If=i(Ta);ec=s(If,"FlaxGPTJForCausalLM"),If.forEach(t),tc=s(pa," is supported by this "),Un=r(pa,"A",{href:!0,rel:!0});var Lf=i(Un);oc=s(Lf,"causal language modeling example script"),Lf.forEach(t),nc=s(pa," and "),Wn=r(pa,"A",{href:!0,rel:!0});var Of=i(Wn);sc=s(Of,"notebook"),Of.forEach(t),ac=s(pa,"."),pa.forEach(t),$e.forEach(t),Yi=h(o),ya=r(o,"P",{});var Nf=i(ya);lr=r(Nf,"STRONG",{});var Df=i(lr);rc=s(Df,"Documentation resources"),Df.forEach(t),Nf.forEach(t),Zi=h(o),Nt=r(o,"UL",{});var Wa=i(Nt);dr=r(Wa,"LI",{});var Sf=i(dr);va=r(Sf,"A",{href:!0});var Bf=i(va);ic=s(Bf,"Text classification task guide"),Bf.forEach(t),Sf.forEach(t),lc=h(Wa),cr=r(Wa,"LI",{});var Uf=i(cr);wa=r(Uf,"A",{href:!0});var Wf=i(wa);dc=s(Wf,"Question answering task guide"),Wf.forEach(t),Uf.forEach(t),cc=h(Wa),pr=r(Wa,"LI",{});var Qf=i(pr);ba=r(Qf,"A",{href:!0});var Hf=i(ba);pc=s(Hf,"Causal language modeling task guide"),Hf.forEach(t),Qf.forEach(t),Wa.forEach(t),el=h(o),Vt=r(o,"H2",{class:!0});var Jl=i(Vt);$o=r(Jl,"A",{id:!0,class:!0,href:!0});var Kf=i($o);hr=r(Kf,"SPAN",{});var Rf=i(hr);b(Qn.$$.fragment,Rf),Rf.forEach(t),Kf.forEach(t),hc=h(Jl),ur=r(Jl,"SPAN",{});var Vf=i(ur);uc=s(Vf,"GPTJConfig"),Vf.forEach(t),Jl.forEach(t),tl=h(o),qt=r(o,"DIV",{class:!0});var Qa=i(qt);b(Hn.$$.fragment,Qa),mc=h(Qa),_t=r(Qa,"P",{});var Dt=i(_t);fc=s(Dt,"This is the configuration class to store the configuration of a "),ka=r(Dt,"A",{href:!0});var Xf=i(ka);gc=s(Xf,"GPTJModel"),Xf.forEach(t),_c=s(Dt,`. It is used to instantiate a GPT-J
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the GPT-J
`),Kn=r(Dt,"A",{href:!0,rel:!0});var Yf=i(Kn);Tc=s(Yf,"EleutherAI/gpt-j-6B"),Yf.forEach(t),yc=s(Dt,` architecture. Configuration objects inherit from
`),$a=r(Dt,"A",{href:!0});var Zf=i($a);vc=s(Zf,"PretrainedConfig"),Zf.forEach(t),wc=s(Dt," and can be used to control the model outputs. Read the documentation from "),Pa=r(Dt,"A",{href:!0});var eg=i(Pa);bc=s(eg,"PretrainedConfig"),eg.forEach(t),kc=s(Dt,`
for more information.`),Dt.forEach(t),$c=h(Qa),b(Po.$$.fragment,Qa),Qa.forEach(t),ol=h(o),Xt=r(o,"H2",{class:!0});var Ml=i(Xt);Fo=r(Ml,"A",{id:!0,class:!0,href:!0});var tg=i(Fo);mr=r(tg,"SPAN",{});var og=i(mr);b(Rn.$$.fragment,og),og.forEach(t),tg.forEach(t),Pc=h(Ml),fr=r(Ml,"SPAN",{});var ng=i(fr);Fc=s(ng,"GPTJModel"),ng.forEach(t),Ml.forEach(t),nl=h(o),Ct=r(o,"DIV",{class:!0});var Ha=i(Ct);b(Vn.$$.fragment,Ha),Ec=h(Ha),Xn=r(Ha,"P",{});var ql=i(Xn);jc=s(ql,`The bare GPT-J Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),Yn=r(ql,"A",{href:!0,rel:!0});var sg=i(Yn);xc=s(sg,"torch.nn.Module"),sg.forEach(t),Gc=s(ql,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),ql.forEach(t),Jc=h(Ha),lt=r(Ha,"DIV",{class:!0});var St=i(lt);b(Zn.$$.fragment,St),Mc=h(St),Yt=r(St,"P",{});var Ka=i(Yt);qc=s(Ka,"The "),Fa=r(Ka,"A",{href:!0});var ag=i(Fa);Cc=s(ag,"GPTJModel"),ag.forEach(t),Ac=s(Ka," forward method, overrides the "),gr=r(Ka,"CODE",{});var rg=i(gr);zc=s(rg,"__call__"),rg.forEach(t),Ic=s(Ka," special method."),Ka.forEach(t),Lc=h(St),b(Eo.$$.fragment,St),Oc=h(St),b(jo.$$.fragment,St),Nc=h(St),b(xo.$$.fragment,St),St.forEach(t),Ha.forEach(t),sl=h(o),Zt=r(o,"H2",{class:!0});var Cl=i(Zt);Go=r(Cl,"A",{id:!0,class:!0,href:!0});var ig=i(Go);_r=r(ig,"SPAN",{});var lg=i(_r);b(es.$$.fragment,lg),lg.forEach(t),ig.forEach(t),Dc=h(Cl),Tr=r(Cl,"SPAN",{});var dg=i(Tr);Sc=s(dg,"GPTJForCausalLM"),dg.forEach(t),Cl.forEach(t),al=h(o),Tt=r(o,"DIV",{class:!0});var mn=i(Tt);b(ts.$$.fragment,mn),Bc=h(mn),yr=r(mn,"P",{});var cg=i(yr);Uc=s(cg,"The GPT-J Model transformer with a language modeling head on top."),cg.forEach(t),Wc=h(mn),os=r(mn,"P",{});var Al=i(os);Qc=s(Al,"This model is a PyTorch "),ns=r(Al,"A",{href:!0,rel:!0});var pg=i(ns);Hc=s(pg,"torch.nn.Module"),pg.forEach(t),Kc=s(Al,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Al.forEach(t),Rc=h(mn),dt=r(mn,"DIV",{class:!0});var Bt=i(dt);b(ss.$$.fragment,Bt),Vc=h(Bt),eo=r(Bt,"P",{});var Ra=i(eo);Xc=s(Ra,"The "),Ea=r(Ra,"A",{href:!0});var hg=i(Ea);Yc=s(hg,"GPTJForCausalLM"),hg.forEach(t),Zc=s(Ra," forward method, overrides the "),vr=r(Ra,"CODE",{});var ug=i(vr);ep=s(ug,"__call__"),ug.forEach(t),tp=s(Ra," special method."),Ra.forEach(t),op=h(Bt),b(Jo.$$.fragment,Bt),np=h(Bt),b(Mo.$$.fragment,Bt),sp=h(Bt),b(qo.$$.fragment,Bt),Bt.forEach(t),mn.forEach(t),rl=h(o),to=r(o,"H2",{class:!0});var zl=i(to);Co=r(zl,"A",{id:!0,class:!0,href:!0});var mg=i(Co);wr=r(mg,"SPAN",{});var fg=i(wr);b(as.$$.fragment,fg),fg.forEach(t),mg.forEach(t),ap=h(zl),br=r(zl,"SPAN",{});var gg=i(br);rp=s(gg,"GPTJForSequenceClassification"),gg.forEach(t),zl.forEach(t),il=h(o),Ue=r(o,"DIV",{class:!0});var jt=i(Ue);b(rs.$$.fragment,jt),ip=h(jt),kr=r(jt,"P",{});var _g=i(kr);lp=s(_g,"The GPT-J Model transformer with a sequence classification head on top (linear layer)."),_g.forEach(t),dp=h(jt),ja=r(jt,"P",{});var mf=i(ja);xa=r(mf,"A",{href:!0});var Tg=i(xa);cp=s(Tg,"GPTJForSequenceClassification"),Tg.forEach(t),pp=s(mf,` uses the last token in order to do the classification, as other causal models
(e.g. GPT, GPT-2, GPT-Neo) do.`),mf.forEach(t),hp=h(jt),yt=r(jt,"P",{});var Ut=i(yt);up=s(Ut,`Since it does classification on the last token, it requires to know the position of the last token. If a
`),$r=r(Ut,"CODE",{});var yg=i($r);mp=s(yg,"pad_token_id"),yg.forEach(t),fp=s(Ut,` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),Pr=r(Ut,"CODE",{});var vg=i(Pr);gp=s(vg,"pad_token_id"),vg.forEach(t),_p=s(Ut,` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Fr=r(Ut,"CODE",{});var wg=i(Fr);Tp=s(wg,"inputs_embeds"),wg.forEach(t),yp=s(Ut," are passed instead of "),Er=r(Ut,"CODE",{});var bg=i(Er);vp=s(bg,"input_ids"),bg.forEach(t),wp=s(Ut,`, it does the same (take the last value in
each row of the batch).`),Ut.forEach(t),bp=h(jt),is=r(jt,"P",{});var Il=i(is);kp=s(Il,"This model is a PyTorch "),ls=r(Il,"A",{href:!0,rel:!0});var kg=i(ls);$p=s(kg,"torch.nn.Module"),kg.forEach(t),Pp=s(Il,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Il.forEach(t),Fp=h(jt),Ve=r(jt,"DIV",{class:!0});var xt=i(Ve);b(ds.$$.fragment,xt),Ep=h(xt),oo=r(xt,"P",{});var Va=i(oo);jp=s(Va,"The "),Ga=r(Va,"A",{href:!0});var $g=i(Ga);xp=s($g,"GPTJForSequenceClassification"),$g.forEach(t),Gp=s(Va," forward method, overrides the "),jr=r(Va,"CODE",{});var Pg=i(jr);Jp=s(Pg,"__call__"),Pg.forEach(t),Mp=s(Va," special method."),Va.forEach(t),qp=h(xt),b(Ao.$$.fragment,xt),Cp=h(xt),b(zo.$$.fragment,xt),Ap=h(xt),b(Io.$$.fragment,xt),zp=h(xt),b(Lo.$$.fragment,xt),xt.forEach(t),jt.forEach(t),ll=h(o),no=r(o,"H2",{class:!0});var Ll=i(no);Oo=r(Ll,"A",{id:!0,class:!0,href:!0});var Fg=i(Oo);xr=r(Fg,"SPAN",{});var Eg=i(xr);b(cs.$$.fragment,Eg),Eg.forEach(t),Fg.forEach(t),Ip=h(Ll),Gr=r(Ll,"SPAN",{});var jg=i(Gr);Lp=s(jg,"GPTJForQuestionAnswering"),jg.forEach(t),Ll.forEach(t),dl=h(o),vt=r(o,"DIV",{class:!0});var fn=i(vt);b(ps.$$.fragment,fn),Op=h(fn),so=r(fn,"P",{});var Xa=i(so);Np=s(Xa,`The GPT-J Model transformer with a span classification head on top for extractive question-answering tasks like
SQuAD (a linear layers on top of the hidden-states output to compute `),Jr=r(Xa,"CODE",{});var xg=i(Jr);Dp=s(xg,"span start logits"),xg.forEach(t),Sp=s(Xa," and "),Mr=r(Xa,"CODE",{});var Gg=i(Mr);Bp=s(Gg,"span end logits"),Gg.forEach(t),Up=s(Xa,")."),Xa.forEach(t),Wp=h(fn),hs=r(fn,"P",{});var Ol=i(hs);Qp=s(Ol,"This model is a PyTorch "),us=r(Ol,"A",{href:!0,rel:!0});var Jg=i(us);Hp=s(Jg,"torch.nn.Module"),Jg.forEach(t),Kp=s(Ol,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Ol.forEach(t),Rp=h(fn),ct=r(fn,"DIV",{class:!0});var Wt=i(ct);b(ms.$$.fragment,Wt),Vp=h(Wt),ao=r(Wt,"P",{});var Ya=i(ao);Xp=s(Ya,"The "),Ja=r(Ya,"A",{href:!0});var Mg=i(Ja);Yp=s(Mg,"GPTJForQuestionAnswering"),Mg.forEach(t),Zp=s(Ya," forward method, overrides the "),qr=r(Ya,"CODE",{});var qg=i(qr);eh=s(qg,"__call__"),qg.forEach(t),th=s(Ya," special method."),Ya.forEach(t),oh=h(Wt),b(No.$$.fragment,Wt),nh=h(Wt),b(Do.$$.fragment,Wt),sh=h(Wt),b(So.$$.fragment,Wt),Wt.forEach(t),fn.forEach(t),cl=h(o),ro=r(o,"H2",{class:!0});var Nl=i(ro);Bo=r(Nl,"A",{id:!0,class:!0,href:!0});var Cg=i(Bo);Cr=r(Cg,"SPAN",{});var Ag=i(Cr);b(fs.$$.fragment,Ag),Ag.forEach(t),Cg.forEach(t),ah=h(Nl),Ar=r(Nl,"SPAN",{});var zg=i(Ar);rh=s(zg,"TFGPTJModel"),zg.forEach(t),Nl.forEach(t),pl=h(o),We=r(o,"DIV",{class:!0});var Gt=i(We);b(gs.$$.fragment,Gt),ih=h(Gt),zr=r(Gt,"P",{});var Ig=i(zr);lh=s(Ig,"The bare GPT-J Model transformer outputting raw hidden-states without any specific head on top."),Ig.forEach(t),dh=h(Gt),_s=r(Gt,"P",{});var Dl=i(_s);ch=s(Dl,"This model inherits from "),Ma=r(Dl,"A",{href:!0});var Lg=i(Ma);ph=s(Lg,"TFPreTrainedModel"),Lg.forEach(t),hh=s(Dl,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Dl.forEach(t),uh=h(Gt),Ts=r(Gt,"P",{});var Sl=i(Ts);mh=s(Sl,"This model is also a "),ys=r(Sl,"A",{href:!0,rel:!0});var Og=i(ys);fh=s(Og,"tf.keras.Model"),Og.forEach(t),gh=s(Sl,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Sl.forEach(t),_h=h(Gt),b(Uo.$$.fragment,Gt),Th=h(Gt),$t=r(Gt,"DIV",{class:!0});var gn=i($t);b(vs.$$.fragment,gn),yh=h(gn),io=r(gn,"P",{});var Za=i(io);vh=s(Za,"The "),qa=r(Za,"A",{href:!0});var Ng=i(qa);wh=s(Ng,"TFGPTJModel"),Ng.forEach(t),bh=s(Za," forward method, overrides the "),Ir=r(Za,"CODE",{});var Dg=i(Ir);kh=s(Dg,"__call__"),Dg.forEach(t),$h=s(Za," special method."),Za.forEach(t),Ph=h(gn),b(Wo.$$.fragment,gn),Fh=h(gn),b(Qo.$$.fragment,gn),gn.forEach(t),Gt.forEach(t),hl=h(o),lo=r(o,"H2",{class:!0});var Bl=i(lo);Ho=r(Bl,"A",{id:!0,class:!0,href:!0});var Sg=i(Ho);Lr=r(Sg,"SPAN",{});var Bg=i(Lr);b(ws.$$.fragment,Bg),Bg.forEach(t),Sg.forEach(t),Eh=h(Bl),Or=r(Bl,"SPAN",{});var Ug=i(Or);jh=s(Ug,"TFGPTJForCausalLM"),Ug.forEach(t),Bl.forEach(t),ul=h(o),Qe=r(o,"DIV",{class:!0});var Jt=i(Qe);b(bs.$$.fragment,Jt),xh=h(Jt),Nr=r(Jt,"P",{});var Wg=i(Nr);Gh=s(Wg,"The GPT-J Model transformer with a language modeling head on top."),Wg.forEach(t),Jh=h(Jt),ks=r(Jt,"P",{});var Ul=i(ks);Mh=s(Ul,"This model inherits from "),Ca=r(Ul,"A",{href:!0});var Qg=i(Ca);qh=s(Qg,"TFPreTrainedModel"),Qg.forEach(t),Ch=s(Ul,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ul.forEach(t),Ah=h(Jt),$s=r(Jt,"P",{});var Wl=i($s);zh=s(Wl,"This model is also a "),Ps=r(Wl,"A",{href:!0,rel:!0});var Hg=i(Ps);Ih=s(Hg,"tf.keras.Model"),Hg.forEach(t),Lh=s(Wl,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Wl.forEach(t),Oh=h(Jt),b(Ko.$$.fragment,Jt),Nh=h(Jt),Pt=r(Jt,"DIV",{class:!0});var _n=i(Pt);b(Fs.$$.fragment,_n),Dh=h(_n),co=r(_n,"P",{});var er=i(co);Sh=s(er,"The "),Aa=r(er,"A",{href:!0});var Kg=i(Aa);Bh=s(Kg,"TFGPTJForCausalLM"),Kg.forEach(t),Uh=s(er," forward method, overrides the "),Dr=r(er,"CODE",{});var Rg=i(Dr);Wh=s(Rg,"__call__"),Rg.forEach(t),Qh=s(er," special method."),er.forEach(t),Hh=h(_n),b(Ro.$$.fragment,_n),Kh=h(_n),b(Vo.$$.fragment,_n),_n.forEach(t),Jt.forEach(t),ml=h(o),po=r(o,"H2",{class:!0});var Ql=i(po);Xo=r(Ql,"A",{id:!0,class:!0,href:!0});var Vg=i(Xo);Sr=r(Vg,"SPAN",{});var Xg=i(Sr);b(Es.$$.fragment,Xg),Xg.forEach(t),Vg.forEach(t),Rh=h(Ql),Br=r(Ql,"SPAN",{});var Yg=i(Br);Vh=s(Yg,"TFGPTJForSequenceClassification"),Yg.forEach(t),Ql.forEach(t),fl=h(o),_e=r(o,"DIV",{class:!0});var Xe=i(_e);b(js.$$.fragment,Xe),Xh=h(Xe),Ur=r(Xe,"P",{});var Zg=i(Ur);Yh=s(Zg,"The GPT-J Model transformer with a sequence classification head on top (linear layer)."),Zg.forEach(t),Zh=h(Xe),za=r(Xe,"P",{});var ff=i(za);Ia=r(ff,"A",{href:!0});var e_=i(Ia);eu=s(e_,"GPTJForSequenceClassification"),e_.forEach(t),tu=s(ff,` uses the last token in order to do the classification, as other causal models
(e.g. GPT, GPT-2, GPT-Neo) do.`),ff.forEach(t),ou=h(Xe),wt=r(Xe,"P",{});var Qt=i(wt);nu=s(Qt,`Since it does classification on the last token, it requires to know the position of the last token. If a
`),Wr=r(Qt,"CODE",{});var t_=i(Wr);su=s(t_,"pad_token_id"),t_.forEach(t),au=s(Qt,` is defined in the configuration, it finds the last token that is not a padding token in each row. If
no `),Qr=r(Qt,"CODE",{});var o_=i(Qr);ru=s(o_,"pad_token_id"),o_.forEach(t),iu=s(Qt,` is defined, it simply takes the last value in each row of the batch. Since it cannot guess the
padding tokens when `),Hr=r(Qt,"CODE",{});var n_=i(Hr);lu=s(n_,"inputs_embeds"),n_.forEach(t),du=s(Qt," are passed instead of "),Kr=r(Qt,"CODE",{});var s_=i(Kr);cu=s(s_,"input_ids"),s_.forEach(t),pu=s(Qt,`, it does the same (take the last value in
each row of the batch).`),Qt.forEach(t),hu=h(Xe),xs=r(Xe,"P",{});var Hl=i(xs);uu=s(Hl,"This model inherits from "),La=r(Hl,"A",{href:!0});var a_=i(La);mu=s(a_,"TFPreTrainedModel"),a_.forEach(t),fu=s(Hl,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Hl.forEach(t),gu=h(Xe),Gs=r(Xe,"P",{});var Kl=i(Gs);_u=s(Kl,"This model is also a "),Js=r(Kl,"A",{href:!0,rel:!0});var r_=i(Js);Tu=s(r_,"tf.keras.Model"),r_.forEach(t),yu=s(Kl,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Kl.forEach(t),vu=h(Xe),b(Yo.$$.fragment,Xe),wu=h(Xe),pt=r(Xe,"DIV",{class:!0});var Ht=i(pt);b(Ms.$$.fragment,Ht),bu=h(Ht),ho=r(Ht,"P",{});var tr=i(ho);ku=s(tr,"The "),Oa=r(tr,"A",{href:!0});var i_=i(Oa);$u=s(i_,"TFGPTJForSequenceClassification"),i_.forEach(t),Pu=s(tr," forward method, overrides the "),Rr=r(tr,"CODE",{});var l_=i(Rr);Fu=s(l_,"__call__"),l_.forEach(t),Eu=s(tr," special method."),tr.forEach(t),ju=h(Ht),b(Zo.$$.fragment,Ht),xu=h(Ht),b(en.$$.fragment,Ht),Gu=h(Ht),b(tn.$$.fragment,Ht),Ht.forEach(t),Xe.forEach(t),gl=h(o),uo=r(o,"H2",{class:!0});var Rl=i(uo);on=r(Rl,"A",{id:!0,class:!0,href:!0});var d_=i(on);Vr=r(d_,"SPAN",{});var c_=i(Vr);b(qs.$$.fragment,c_),c_.forEach(t),d_.forEach(t),Ju=h(Rl),Xr=r(Rl,"SPAN",{});var p_=i(Xr);Mu=s(p_,"TFGPTJForQuestionAnswering"),p_.forEach(t),Rl.forEach(t),_l=h(o),He=r(o,"DIV",{class:!0});var Mt=i(He);b(Cs.$$.fragment,Mt),qu=h(Mt),mo=r(Mt,"P",{});var or=i(mo);Cu=s(or,`The GPT-J Model transformer with a span classification head on top for extractive question-answering tasks like
SQuAD (a linear layers on top of the hidden-states output to compute `),Yr=r(or,"CODE",{});var h_=i(Yr);Au=s(h_,"span start logits"),h_.forEach(t),zu=s(or," and "),Zr=r(or,"CODE",{});var u_=i(Zr);Iu=s(u_,"span end logits"),u_.forEach(t),Lu=s(or,")."),or.forEach(t),Ou=h(Mt),As=r(Mt,"P",{});var Vl=i(As);Nu=s(Vl,"This model inherits from "),Na=r(Vl,"A",{href:!0});var m_=i(Na);Du=s(m_,"TFPreTrainedModel"),m_.forEach(t),Su=s(Vl,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Vl.forEach(t),Bu=h(Mt),zs=r(Mt,"P",{});var Xl=i(zs);Uu=s(Xl,"This model is also a "),Is=r(Xl,"A",{href:!0,rel:!0});var f_=i(Is);Wu=s(f_,"tf.keras.Model"),f_.forEach(t),Qu=s(Xl,` subclass. Use it
as a regular TF 2.0 Keras Model and refer to the TF 2.0 documentation for all matter related to general usage and
behavior.`),Xl.forEach(t),Hu=h(Mt),b(nn.$$.fragment,Mt),Ku=h(Mt),ht=r(Mt,"DIV",{class:!0});var Kt=i(ht);b(Ls.$$.fragment,Kt),Ru=h(Kt),fo=r(Kt,"P",{});var nr=i(fo);Vu=s(nr,"The "),Da=r(nr,"A",{href:!0});var g_=i(Da);Xu=s(g_,"TFGPTJForQuestionAnswering"),g_.forEach(t),Yu=s(nr," forward method, overrides the "),ei=r(nr,"CODE",{});var __=i(ei);Zu=s(__,"__call__"),__.forEach(t),em=s(nr," special method."),nr.forEach(t),tm=h(Kt),b(sn.$$.fragment,Kt),om=h(Kt),b(an.$$.fragment,Kt),nm=h(Kt),b(rn.$$.fragment,Kt),Kt.forEach(t),Mt.forEach(t),Tl=h(o),go=r(o,"H2",{class:!0});var Yl=i(go);ln=r(Yl,"A",{id:!0,class:!0,href:!0});var T_=i(ln);ti=r(T_,"SPAN",{});var y_=i(ti);b(Os.$$.fragment,y_),y_.forEach(t),T_.forEach(t),sm=h(Yl),oi=r(Yl,"SPAN",{});var v_=i(oi);am=s(v_,"FlaxGPTJModel"),v_.forEach(t),Yl.forEach(t),yl=h(o),Oe=r(o,"DIV",{class:!0});var ut=i(Oe);b(Ns.$$.fragment,ut),rm=h(ut),ni=r(ut,"P",{});var w_=i(ni);im=s(w_,"The bare GPTJ Model transformer outputting raw hidden-states without any specific head on top."),w_.forEach(t),lm=h(ut),Ds=r(ut,"P",{});var Zl=i(Ds);dm=s(Zl,"This model inherits from "),Sa=r(Zl,"A",{href:!0});var b_=i(Sa);cm=s(b_,"FlaxPreTrainedModel"),b_.forEach(t),pm=s(Zl,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Zl.forEach(t),hm=h(ut),Ss=r(ut,"P",{});var ed=i(Ss);um=s(ed,`This model is also a Flax Linen
`),Bs=r(ed,"A",{href:!0,rel:!0});var k_=i(Bs);mm=s(k_,"flax.nn.Module"),k_.forEach(t),fm=s(ed,` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),ed.forEach(t),gm=h(ut),si=r(ut,"P",{});var $_=i(si);_m=s($_,"Finally, this model supports inherent JAX features such as:"),$_.forEach(t),Tm=h(ut),At=r(ut,"UL",{});var Tn=i(At);ai=r(Tn,"LI",{});var P_=i(ai);Us=r(P_,"A",{href:!0,rel:!0});var F_=i(Us);ym=s(F_,"Just-In-Time (JIT) compilation"),F_.forEach(t),P_.forEach(t),vm=h(Tn),ri=r(Tn,"LI",{});var E_=i(ri);Ws=r(E_,"A",{href:!0,rel:!0});var j_=i(Ws);wm=s(j_,"Automatic Differentiation"),j_.forEach(t),E_.forEach(t),bm=h(Tn),ii=r(Tn,"LI",{});var x_=i(ii);Qs=r(x_,"A",{href:!0,rel:!0});var G_=i(Qs);km=s(G_,"Vectorization"),G_.forEach(t),x_.forEach(t),$m=h(Tn),li=r(Tn,"LI",{});var J_=i(li);Hs=r(J_,"A",{href:!0,rel:!0});var M_=i(Hs);Pm=s(M_,"Parallelization"),M_.forEach(t),J_.forEach(t),Tn.forEach(t),Fm=h(ut),Ft=r(ut,"DIV",{class:!0});var yn=i(Ft);b(Ks.$$.fragment,yn),Em=h(yn),_o=r(yn,"P",{});var sr=i(_o);jm=s(sr,"The "),di=r(sr,"CODE",{});var q_=i(di);xm=s(q_,"FlaxGPTJPreTrainedModel"),q_.forEach(t),Gm=s(sr," forward method, overrides the "),ci=r(sr,"CODE",{});var C_=i(ci);Jm=s(C_,"__call__"),C_.forEach(t),Mm=s(sr," special method."),sr.forEach(t),qm=h(yn),b(dn.$$.fragment,yn),Cm=h(yn),b(cn.$$.fragment,yn),yn.forEach(t),ut.forEach(t),vl=h(o),To=r(o,"H2",{class:!0});var td=i(To);pn=r(td,"A",{id:!0,class:!0,href:!0});var A_=i(pn);pi=r(A_,"SPAN",{});var z_=i(pi);b(Rs.$$.fragment,z_),z_.forEach(t),A_.forEach(t),Am=h(td),hi=r(td,"SPAN",{});var I_=i(hi);zm=s(I_,"FlaxGPTJForCausalLM"),I_.forEach(t),td.forEach(t),wl=h(o),Ne=r(o,"DIV",{class:!0});var mt=i(Ne);b(Vs.$$.fragment,mt),Im=h(mt),ui=r(mt,"P",{});var L_=i(ui);Lm=s(L_,"The GPTJ Model transformer with a language modeling head on top."),L_.forEach(t),Om=h(mt),Xs=r(mt,"P",{});var od=i(Xs);Nm=s(od,"This model inherits from "),Ba=r(od,"A",{href:!0});var O_=i(Ba);Dm=s(O_,"FlaxPreTrainedModel"),O_.forEach(t),Sm=s(od,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),od.forEach(t),Bm=h(mt),Ys=r(mt,"P",{});var nd=i(Ys);Um=s(nd,`This model is also a Flax Linen
`),Zs=r(nd,"A",{href:!0,rel:!0});var N_=i(Zs);Wm=s(N_,"flax.nn.Module"),N_.forEach(t),Qm=s(nd,` subclass. Use it as a
regular Flax Module and refer to the Flax documentation for all matter related to general usage and behavior.`),nd.forEach(t),Hm=h(mt),mi=r(mt,"P",{});var D_=i(mi);Km=s(D_,"Finally, this model supports inherent JAX features such as:"),D_.forEach(t),Rm=h(mt),zt=r(mt,"UL",{});var vn=i(zt);fi=r(vn,"LI",{});var S_=i(fi);ea=r(S_,"A",{href:!0,rel:!0});var B_=i(ea);Vm=s(B_,"Just-In-Time (JIT) compilation"),B_.forEach(t),S_.forEach(t),Xm=h(vn),gi=r(vn,"LI",{});var U_=i(gi);ta=r(U_,"A",{href:!0,rel:!0});var W_=i(ta);Ym=s(W_,"Automatic Differentiation"),W_.forEach(t),U_.forEach(t),Zm=h(vn),_i=r(vn,"LI",{});var Q_=i(_i);oa=r(Q_,"A",{href:!0,rel:!0});var H_=i(oa);ef=s(H_,"Vectorization"),H_.forEach(t),Q_.forEach(t),tf=h(vn),Ti=r(vn,"LI",{});var K_=i(Ti);na=r(K_,"A",{href:!0,rel:!0});var R_=i(na);of=s(R_,"Parallelization"),R_.forEach(t),K_.forEach(t),vn.forEach(t),nf=h(mt),Et=r(mt,"DIV",{class:!0});var wn=i(Et);b(sa.$$.fragment,wn),sf=h(wn),yo=r(wn,"P",{});var ar=i(yo);af=s(ar,"The "),yi=r(ar,"CODE",{});var V_=i(yi);rf=s(V_,"FlaxGPTJPreTrainedModel"),V_.forEach(t),lf=s(ar," forward method, overrides the "),vi=r(ar,"CODE",{});var X_=i(vi);df=s(X_,"__call__"),X_.forEach(t),cf=s(ar," special method."),ar.forEach(t),pf=h(wn),b(hn.$$.fragment,wn),hf=h(wn),b(un.$$.fragment,wn),wn.forEach(t),mt.forEach(t),this.h()},h(){m(d,"name","hf:doc:metadata"),m(d,"content",JSON.stringify(IT)),m(f,"id","gptj"),m(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(f,"href","#gptj"),m(u,"class","relative group"),m(D,"id","overview"),m(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(D,"href","#overview"),m(C,"class","relative group"),m(ie,"href","https://github.com/kingoflolz/mesh-transformer-jax"),m(ie,"rel","nofollow"),m(le,"href","https://pile.eleuther.ai/"),m(le,"rel","nofollow"),m(de,"href","https://huggingface.co/stellaathena"),m(de,"rel","nofollow"),m(pe,"href","https://huggingface.co/EleutherAI/gpt-j-6B"),m(pe,"rel","nofollow"),m(S,"href","https://huggingface.co/EleutherAI/gpt-j-6B/tree/float16"),m(S,"rel","nofollow"),m(v,"href","https://github.com/kingoflolz/mesh-transformer-jax/blob/master/howto_finetune.md"),m(v,"rel","nofollow"),m(J,"href","https://huggingface.co/EleutherAI/gpt-j-6B"),m(J,"rel","nofollow"),m(ke,"id","generation"),m(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ke,"href","#generation"),m(W,"class","relative group"),m(ha,"href","/docs/transformers/main/en/main_classes/text_generation#transformers.GenerationMixin.generate"),m(ko,"id","resources"),m(ko,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ko,"href","#resources"),m(Rt,"class","relative group"),m(En,"href","https://huggingface.co/EleutherAI/gpt-j-6B"),m(En,"rel","nofollow"),m(xn,"href","https://huggingface.co/blog/gptj-sagemaker"),m(xn,"rel","nofollow"),m(Jn,"href","https://www.philschmid.de/gptj-deepspeed-inference"),m(Jn,"rel","nofollow"),m(qn,"href","https://arankomatsuzaki.wordpress.com/2021/06/04/gpt-j/"),m(qn,"rel","nofollow"),m(An,"href","https://colab.research.google.com/github/kingoflolz/mesh-transformer-jax/blob/master/colab_demo.ipynb"),m(An,"rel","nofollow"),m(In,"href","https://colab.research.google.com/github/NielsRogge/Transformers-Tutorials/blob/master/GPT-J-6B/Inference_with_GPT_J_6B.ipynb"),m(In,"rel","nofollow"),m(Ln,"href","https://huggingface.co/course/en/chapter7/6?fw=pt#training-a-causal-language-model-from-scratch"),m(Ln,"rel","nofollow"),m(ga,"href","/docs/transformers/main/en/model_doc/gptj#transformers.GPTJForCausalLM"),m(On,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/language-modeling#gpt-2gpt-and-causal-language-modeling"),m(On,"rel","nofollow"),m(Nn,"href","https://github.com/huggingface/transformers/tree/main/examples/pytorch/text-generation"),m(Nn,"rel","nofollow"),m(Dn,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/language_modeling.ipynb"),m(Dn,"rel","nofollow"),m(_a,"href","/docs/transformers/main/en/model_doc/gptj#transformers.TFGPTJForCausalLM"),m(Sn,"href","https://github.com/huggingface/transformers/tree/main/examples/tensorflow/language-modeling#run_clmpy"),m(Sn,"rel","nofollow"),m(Bn,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/language_modeling-tf.ipynb"),m(Bn,"rel","nofollow"),m(Ta,"href","/docs/transformers/main/en/model_doc/gptj#transformers.FlaxGPTJForCausalLM"),m(Un,"href","https://github.com/huggingface/transformers/tree/main/examples/flax/language-modeling#causal-language-modeling"),m(Un,"rel","nofollow"),m(Wn,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/causal_language_modeling_flax.ipynb"),m(Wn,"rel","nofollow"),m(va,"href","./tasks/sequence_classification"),m(wa,"href","./tasks/question_answering"),m(ba,"href","./tasks/language_modeling"),m($o,"id","transformers.GPTJConfig"),m($o,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m($o,"href","#transformers.GPTJConfig"),m(Vt,"class","relative group"),m(ka,"href","/docs/transformers/main/en/model_doc/gptj#transformers.GPTJModel"),m(Kn,"href","https://huggingface.co/EleutherAI/gpt-j-6B"),m(Kn,"rel","nofollow"),m($a,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),m(Pa,"href","/docs/transformers/main/en/main_classes/configuration#transformers.PretrainedConfig"),m(qt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Fo,"id","transformers.GPTJModel"),m(Fo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Fo,"href","#transformers.GPTJModel"),m(Xt,"class","relative group"),m(Yn,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),m(Yn,"rel","nofollow"),m(Fa,"href","/docs/transformers/main/en/model_doc/gptj#transformers.GPTJModel"),m(lt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Go,"id","transformers.GPTJForCausalLM"),m(Go,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Go,"href","#transformers.GPTJForCausalLM"),m(Zt,"class","relative group"),m(ns,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),m(ns,"rel","nofollow"),m(Ea,"href","/docs/transformers/main/en/model_doc/gptj#transformers.GPTJForCausalLM"),m(dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Co,"id","transformers.GPTJForSequenceClassification"),m(Co,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Co,"href","#transformers.GPTJForSequenceClassification"),m(to,"class","relative group"),m(xa,"href","/docs/transformers/main/en/model_doc/gptj#transformers.GPTJForSequenceClassification"),m(ls,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),m(ls,"rel","nofollow"),m(Ga,"href","/docs/transformers/main/en/model_doc/gptj#transformers.GPTJForSequenceClassification"),m(Ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Oo,"id","transformers.GPTJForQuestionAnswering"),m(Oo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Oo,"href","#transformers.GPTJForQuestionAnswering"),m(no,"class","relative group"),m(us,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),m(us,"rel","nofollow"),m(Ja,"href","/docs/transformers/main/en/model_doc/gptj#transformers.GPTJForQuestionAnswering"),m(ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(vt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Bo,"id","transformers.TFGPTJModel"),m(Bo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Bo,"href","#transformers.TFGPTJModel"),m(ro,"class","relative group"),m(Ma,"href","/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel"),m(ys,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),m(ys,"rel","nofollow"),m(qa,"href","/docs/transformers/main/en/model_doc/gptj#transformers.TFGPTJModel"),m($t,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(We,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Ho,"id","transformers.TFGPTJForCausalLM"),m(Ho,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Ho,"href","#transformers.TFGPTJForCausalLM"),m(lo,"class","relative group"),m(Ca,"href","/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel"),m(Ps,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),m(Ps,"rel","nofollow"),m(Aa,"href","/docs/transformers/main/en/model_doc/gptj#transformers.TFGPTJForCausalLM"),m(Pt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Qe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Xo,"id","transformers.TFGPTJForSequenceClassification"),m(Xo,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Xo,"href","#transformers.TFGPTJForSequenceClassification"),m(po,"class","relative group"),m(Ia,"href","/docs/transformers/main/en/model_doc/gptj#transformers.GPTJForSequenceClassification"),m(La,"href","/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel"),m(Js,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),m(Js,"rel","nofollow"),m(Oa,"href","/docs/transformers/main/en/model_doc/gptj#transformers.TFGPTJForSequenceClassification"),m(pt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(on,"id","transformers.TFGPTJForQuestionAnswering"),m(on,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(on,"href","#transformers.TFGPTJForQuestionAnswering"),m(uo,"class","relative group"),m(Na,"href","/docs/transformers/main/en/main_classes/model#transformers.TFPreTrainedModel"),m(Is,"href","https://www.tensorflow.org/api_docs/python/tf/keras/Model"),m(Is,"rel","nofollow"),m(Da,"href","/docs/transformers/main/en/model_doc/gptj#transformers.TFGPTJForQuestionAnswering"),m(ht,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(He,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(ln,"id","transformers.FlaxGPTJModel"),m(ln,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(ln,"href","#transformers.FlaxGPTJModel"),m(go,"class","relative group"),m(Sa,"href","/docs/transformers/main/en/main_classes/model#transformers.FlaxPreTrainedModel"),m(Bs,"href","https://flax.readthedocs.io/en/latest/_autosummary/flax.nn.module.html"),m(Bs,"rel","nofollow"),m(Us,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),m(Us,"rel","nofollow"),m(Ws,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),m(Ws,"rel","nofollow"),m(Qs,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),m(Qs,"rel","nofollow"),m(Hs,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),m(Hs,"rel","nofollow"),m(Ft,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(pn,"id","transformers.FlaxGPTJForCausalLM"),m(pn,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(pn,"href","#transformers.FlaxGPTJForCausalLM"),m(To,"class","relative group"),m(Ba,"href","/docs/transformers/main/en/main_classes/model#transformers.FlaxPreTrainedModel"),m(Zs,"href","https://flax.readthedocs.io/en/latest/_autosummary/flax.nn.module.html"),m(Zs,"rel","nofollow"),m(ea,"href","https://jax.readthedocs.io/en/latest/jax.html#just-in-time-compilation-jit"),m(ea,"rel","nofollow"),m(ta,"href","https://jax.readthedocs.io/en/latest/jax.html#automatic-differentiation"),m(ta,"rel","nofollow"),m(oa,"href","https://jax.readthedocs.io/en/latest/jax.html#vectorization-vmap"),m(oa,"rel","nofollow"),m(na,"href","https://jax.readthedocs.io/en/latest/jax.html#parallelization-pmap"),m(na,"rel","nofollow"),m(Et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),m(Ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,_){e(document.head,d),g(o,y,_),g(o,u,_),e(u,f),e(f,T),k(l,T,null),e(u,c),e(u,E),e(E,A),g(o,M,_),g(o,C,_),e(C,D),e(D,oe),k(j,oe,null),e(C,Pe),e(C,H),e(H,Fe),g(o,ye,_),g(o,B,_),e(B,Ee),e(B,ie),e(ie,V),e(B,je),e(B,le),e(le,X),e(B,xe),g(o,ve,_),g(o,Q,_),e(Q,Ge),e(Q,de),e(de,ce),e(Q,q),g(o,z,_),g(o,me,_),e(me,Y),g(o,we,_),g(o,fe,_),e(fe,O),e(O,Je),e(O,pe),e(pe,L),e(O,Me),e(O,K),e(K,qe),e(O,Ce),e(O,R),e(R,Ae),e(O,ze),e(O,S),e(S,Ie),e(O,Z),g(o,be,_),k(ee,o,_),g(o,I,_),g(o,ae,_),e(ae,N),e(N,ge),e(ge,Le),e(ge,v),e(v,G),e(ae,Ye),e(ae,ne),e(ne,he),e(he,Ze),e(he,J),e(J,et),e(he,tt),e(he,Se),e(Se,ot),e(he,nt),e(he,U),e(U,te),e(he,st),g(o,Re,_),g(o,W,_),e(W,ke),e(ke,Be),k(ue,Be,null),e(W,at),e(W,se),e(se,rt),g(o,Ui,_),g(o,bo,_),e(bo,sd),e(bo,ha),e(ha,ad),e(bo,rd),g(o,Wi,_),k(bn,o,_),g(o,Qi,_),g(o,ua,_),e(ua,id),g(o,Hi,_),k(kn,o,_),g(o,Ki,_),g(o,Rt,_),e(Rt,ko),e(ko,rr),k($n,rr,null),e(Rt,ld),e(Rt,ir),e(ir,dd),g(o,Ri,_),g(o,ma,_),e(ma,cd),g(o,Vi,_),k(Pn,o,_),g(o,Xi,_),g(o,re,_),e(re,Fn),e(Fn,pd),e(Fn,En),e(En,hd),e(Fn,ud),e(re,md),e(re,jn),e(jn,fd),e(jn,xn),e(xn,gd),e(jn,_d),e(re,Td),e(re,Gn),e(Gn,yd),e(Gn,Jn),e(Jn,vd),e(Gn,wd),e(re,bd),e(re,Mn),e(Mn,kd),e(Mn,qn),e(qn,$d),e(Mn,Pd),e(re,Fd),e(re,Cn),e(Cn,Ed),e(Cn,An),e(An,jd),e(Cn,xd),e(re,Gd),e(re,zn),e(zn,Jd),e(zn,In),e(In,Md),e(zn,qd),e(re,Cd),e(re,fa),e(fa,Ln),e(Ln,Ad),e(fa,zd),e(re,Id),e(re,kt),e(kt,ga),e(ga,Ld),e(kt,Od),e(kt,On),e(On,Nd),e(kt,Dd),e(kt,Nn),e(Nn,Sd),e(kt,Bd),e(kt,Dn),e(Dn,Ud),e(kt,Wd),e(re,Qd),e(re,Lt),e(Lt,_a),e(_a,Hd),e(Lt,Kd),e(Lt,Sn),e(Sn,Rd),e(Lt,Vd),e(Lt,Bn),e(Bn,Xd),e(Lt,Yd),e(re,Zd),e(re,Ot),e(Ot,Ta),e(Ta,ec),e(Ot,tc),e(Ot,Un),e(Un,oc),e(Ot,nc),e(Ot,Wn),e(Wn,sc),e(Ot,ac),g(o,Yi,_),g(o,ya,_),e(ya,lr),e(lr,rc),g(o,Zi,_),g(o,Nt,_),e(Nt,dr),e(dr,va),e(va,ic),e(Nt,lc),e(Nt,cr),e(cr,wa),e(wa,dc),e(Nt,cc),e(Nt,pr),e(pr,ba),e(ba,pc),g(o,el,_),g(o,Vt,_),e(Vt,$o),e($o,hr),k(Qn,hr,null),e(Vt,hc),e(Vt,ur),e(ur,uc),g(o,tl,_),g(o,qt,_),k(Hn,qt,null),e(qt,mc),e(qt,_t),e(_t,fc),e(_t,ka),e(ka,gc),e(_t,_c),e(_t,Kn),e(Kn,Tc),e(_t,yc),e(_t,$a),e($a,vc),e(_t,wc),e(_t,Pa),e(Pa,bc),e(_t,kc),e(qt,$c),k(Po,qt,null),g(o,ol,_),g(o,Xt,_),e(Xt,Fo),e(Fo,mr),k(Rn,mr,null),e(Xt,Pc),e(Xt,fr),e(fr,Fc),g(o,nl,_),g(o,Ct,_),k(Vn,Ct,null),e(Ct,Ec),e(Ct,Xn),e(Xn,jc),e(Xn,Yn),e(Yn,xc),e(Xn,Gc),e(Ct,Jc),e(Ct,lt),k(Zn,lt,null),e(lt,Mc),e(lt,Yt),e(Yt,qc),e(Yt,Fa),e(Fa,Cc),e(Yt,Ac),e(Yt,gr),e(gr,zc),e(Yt,Ic),e(lt,Lc),k(Eo,lt,null),e(lt,Oc),k(jo,lt,null),e(lt,Nc),k(xo,lt,null),g(o,sl,_),g(o,Zt,_),e(Zt,Go),e(Go,_r),k(es,_r,null),e(Zt,Dc),e(Zt,Tr),e(Tr,Sc),g(o,al,_),g(o,Tt,_),k(ts,Tt,null),e(Tt,Bc),e(Tt,yr),e(yr,Uc),e(Tt,Wc),e(Tt,os),e(os,Qc),e(os,ns),e(ns,Hc),e(os,Kc),e(Tt,Rc),e(Tt,dt),k(ss,dt,null),e(dt,Vc),e(dt,eo),e(eo,Xc),e(eo,Ea),e(Ea,Yc),e(eo,Zc),e(eo,vr),e(vr,ep),e(eo,tp),e(dt,op),k(Jo,dt,null),e(dt,np),k(Mo,dt,null),e(dt,sp),k(qo,dt,null),g(o,rl,_),g(o,to,_),e(to,Co),e(Co,wr),k(as,wr,null),e(to,ap),e(to,br),e(br,rp),g(o,il,_),g(o,Ue,_),k(rs,Ue,null),e(Ue,ip),e(Ue,kr),e(kr,lp),e(Ue,dp),e(Ue,ja),e(ja,xa),e(xa,cp),e(ja,pp),e(Ue,hp),e(Ue,yt),e(yt,up),e(yt,$r),e($r,mp),e(yt,fp),e(yt,Pr),e(Pr,gp),e(yt,_p),e(yt,Fr),e(Fr,Tp),e(yt,yp),e(yt,Er),e(Er,vp),e(yt,wp),e(Ue,bp),e(Ue,is),e(is,kp),e(is,ls),e(ls,$p),e(is,Pp),e(Ue,Fp),e(Ue,Ve),k(ds,Ve,null),e(Ve,Ep),e(Ve,oo),e(oo,jp),e(oo,Ga),e(Ga,xp),e(oo,Gp),e(oo,jr),e(jr,Jp),e(oo,Mp),e(Ve,qp),k(Ao,Ve,null),e(Ve,Cp),k(zo,Ve,null),e(Ve,Ap),k(Io,Ve,null),e(Ve,zp),k(Lo,Ve,null),g(o,ll,_),g(o,no,_),e(no,Oo),e(Oo,xr),k(cs,xr,null),e(no,Ip),e(no,Gr),e(Gr,Lp),g(o,dl,_),g(o,vt,_),k(ps,vt,null),e(vt,Op),e(vt,so),e(so,Np),e(so,Jr),e(Jr,Dp),e(so,Sp),e(so,Mr),e(Mr,Bp),e(so,Up),e(vt,Wp),e(vt,hs),e(hs,Qp),e(hs,us),e(us,Hp),e(hs,Kp),e(vt,Rp),e(vt,ct),k(ms,ct,null),e(ct,Vp),e(ct,ao),e(ao,Xp),e(ao,Ja),e(Ja,Yp),e(ao,Zp),e(ao,qr),e(qr,eh),e(ao,th),e(ct,oh),k(No,ct,null),e(ct,nh),k(Do,ct,null),e(ct,sh),k(So,ct,null),g(o,cl,_),g(o,ro,_),e(ro,Bo),e(Bo,Cr),k(fs,Cr,null),e(ro,ah),e(ro,Ar),e(Ar,rh),g(o,pl,_),g(o,We,_),k(gs,We,null),e(We,ih),e(We,zr),e(zr,lh),e(We,dh),e(We,_s),e(_s,ch),e(_s,Ma),e(Ma,ph),e(_s,hh),e(We,uh),e(We,Ts),e(Ts,mh),e(Ts,ys),e(ys,fh),e(Ts,gh),e(We,_h),k(Uo,We,null),e(We,Th),e(We,$t),k(vs,$t,null),e($t,yh),e($t,io),e(io,vh),e(io,qa),e(qa,wh),e(io,bh),e(io,Ir),e(Ir,kh),e(io,$h),e($t,Ph),k(Wo,$t,null),e($t,Fh),k(Qo,$t,null),g(o,hl,_),g(o,lo,_),e(lo,Ho),e(Ho,Lr),k(ws,Lr,null),e(lo,Eh),e(lo,Or),e(Or,jh),g(o,ul,_),g(o,Qe,_),k(bs,Qe,null),e(Qe,xh),e(Qe,Nr),e(Nr,Gh),e(Qe,Jh),e(Qe,ks),e(ks,Mh),e(ks,Ca),e(Ca,qh),e(ks,Ch),e(Qe,Ah),e(Qe,$s),e($s,zh),e($s,Ps),e(Ps,Ih),e($s,Lh),e(Qe,Oh),k(Ko,Qe,null),e(Qe,Nh),e(Qe,Pt),k(Fs,Pt,null),e(Pt,Dh),e(Pt,co),e(co,Sh),e(co,Aa),e(Aa,Bh),e(co,Uh),e(co,Dr),e(Dr,Wh),e(co,Qh),e(Pt,Hh),k(Ro,Pt,null),e(Pt,Kh),k(Vo,Pt,null),g(o,ml,_),g(o,po,_),e(po,Xo),e(Xo,Sr),k(Es,Sr,null),e(po,Rh),e(po,Br),e(Br,Vh),g(o,fl,_),g(o,_e,_),k(js,_e,null),e(_e,Xh),e(_e,Ur),e(Ur,Yh),e(_e,Zh),e(_e,za),e(za,Ia),e(Ia,eu),e(za,tu),e(_e,ou),e(_e,wt),e(wt,nu),e(wt,Wr),e(Wr,su),e(wt,au),e(wt,Qr),e(Qr,ru),e(wt,iu),e(wt,Hr),e(Hr,lu),e(wt,du),e(wt,Kr),e(Kr,cu),e(wt,pu),e(_e,hu),e(_e,xs),e(xs,uu),e(xs,La),e(La,mu),e(xs,fu),e(_e,gu),e(_e,Gs),e(Gs,_u),e(Gs,Js),e(Js,Tu),e(Gs,yu),e(_e,vu),k(Yo,_e,null),e(_e,wu),e(_e,pt),k(Ms,pt,null),e(pt,bu),e(pt,ho),e(ho,ku),e(ho,Oa),e(Oa,$u),e(ho,Pu),e(ho,Rr),e(Rr,Fu),e(ho,Eu),e(pt,ju),k(Zo,pt,null),e(pt,xu),k(en,pt,null),e(pt,Gu),k(tn,pt,null),g(o,gl,_),g(o,uo,_),e(uo,on),e(on,Vr),k(qs,Vr,null),e(uo,Ju),e(uo,Xr),e(Xr,Mu),g(o,_l,_),g(o,He,_),k(Cs,He,null),e(He,qu),e(He,mo),e(mo,Cu),e(mo,Yr),e(Yr,Au),e(mo,zu),e(mo,Zr),e(Zr,Iu),e(mo,Lu),e(He,Ou),e(He,As),e(As,Nu),e(As,Na),e(Na,Du),e(As,Su),e(He,Bu),e(He,zs),e(zs,Uu),e(zs,Is),e(Is,Wu),e(zs,Qu),e(He,Hu),k(nn,He,null),e(He,Ku),e(He,ht),k(Ls,ht,null),e(ht,Ru),e(ht,fo),e(fo,Vu),e(fo,Da),e(Da,Xu),e(fo,Yu),e(fo,ei),e(ei,Zu),e(fo,em),e(ht,tm),k(sn,ht,null),e(ht,om),k(an,ht,null),e(ht,nm),k(rn,ht,null),g(o,Tl,_),g(o,go,_),e(go,ln),e(ln,ti),k(Os,ti,null),e(go,sm),e(go,oi),e(oi,am),g(o,yl,_),g(o,Oe,_),k(Ns,Oe,null),e(Oe,rm),e(Oe,ni),e(ni,im),e(Oe,lm),e(Oe,Ds),e(Ds,dm),e(Ds,Sa),e(Sa,cm),e(Ds,pm),e(Oe,hm),e(Oe,Ss),e(Ss,um),e(Ss,Bs),e(Bs,mm),e(Ss,fm),e(Oe,gm),e(Oe,si),e(si,_m),e(Oe,Tm),e(Oe,At),e(At,ai),e(ai,Us),e(Us,ym),e(At,vm),e(At,ri),e(ri,Ws),e(Ws,wm),e(At,bm),e(At,ii),e(ii,Qs),e(Qs,km),e(At,$m),e(At,li),e(li,Hs),e(Hs,Pm),e(Oe,Fm),e(Oe,Ft),k(Ks,Ft,null),e(Ft,Em),e(Ft,_o),e(_o,jm),e(_o,di),e(di,xm),e(_o,Gm),e(_o,ci),e(ci,Jm),e(_o,Mm),e(Ft,qm),k(dn,Ft,null),e(Ft,Cm),k(cn,Ft,null),g(o,vl,_),g(o,To,_),e(To,pn),e(pn,pi),k(Rs,pi,null),e(To,Am),e(To,hi),e(hi,zm),g(o,wl,_),g(o,Ne,_),k(Vs,Ne,null),e(Ne,Im),e(Ne,ui),e(ui,Lm),e(Ne,Om),e(Ne,Xs),e(Xs,Nm),e(Xs,Ba),e(Ba,Dm),e(Xs,Sm),e(Ne,Bm),e(Ne,Ys),e(Ys,Um),e(Ys,Zs),e(Zs,Wm),e(Ys,Qm),e(Ne,Hm),e(Ne,mi),e(mi,Km),e(Ne,Rm),e(Ne,zt),e(zt,fi),e(fi,ea),e(ea,Vm),e(zt,Xm),e(zt,gi),e(gi,ta),e(ta,Ym),e(zt,Zm),e(zt,_i),e(_i,oa),e(oa,ef),e(zt,tf),e(zt,Ti),e(Ti,na),e(na,of),e(Ne,nf),e(Ne,Et),k(sa,Et,null),e(Et,sf),e(Et,yo),e(yo,af),e(yo,yi),e(yi,rf),e(yo,lf),e(yo,vi),e(vi,df),e(yo,cf),e(Et,pf),k(hn,Et,null),e(Et,hf),k(un,Et,null),bl=!0},p(o,[_]){const aa={};_&2&&(aa.$$scope={dirty:_,ctx:o}),Po.$set(aa);const wi={};_&2&&(wi.$$scope={dirty:_,ctx:o}),Eo.$set(wi);const bi={};_&2&&(bi.$$scope={dirty:_,ctx:o}),jo.$set(bi);const ki={};_&2&&(ki.$$scope={dirty:_,ctx:o}),xo.$set(ki);const ra={};_&2&&(ra.$$scope={dirty:_,ctx:o}),Jo.$set(ra);const $i={};_&2&&($i.$$scope={dirty:_,ctx:o}),Mo.$set($i);const Pi={};_&2&&(Pi.$$scope={dirty:_,ctx:o}),qo.$set(Pi);const Fi={};_&2&&(Fi.$$scope={dirty:_,ctx:o}),Ao.$set(Fi);const vo={};_&2&&(vo.$$scope={dirty:_,ctx:o}),zo.$set(vo);const Ei={};_&2&&(Ei.$$scope={dirty:_,ctx:o}),Io.$set(Ei);const ji={};_&2&&(ji.$$scope={dirty:_,ctx:o}),Lo.$set(ji);const ia={};_&2&&(ia.$$scope={dirty:_,ctx:o}),No.$set(ia);const xi={};_&2&&(xi.$$scope={dirty:_,ctx:o}),Do.$set(xi);const Gi={};_&2&&(Gi.$$scope={dirty:_,ctx:o}),So.$set(Gi);const Ji={};_&2&&(Ji.$$scope={dirty:_,ctx:o}),Uo.$set(Ji);const bt={};_&2&&(bt.$$scope={dirty:_,ctx:o}),Wo.$set(bt);const Mi={};_&2&&(Mi.$$scope={dirty:_,ctx:o}),Qo.$set(Mi);const qi={};_&2&&(qi.$$scope={dirty:_,ctx:o}),Ko.$set(qi);const Ci={};_&2&&(Ci.$$scope={dirty:_,ctx:o}),Ro.$set(Ci);const Ai={};_&2&&(Ai.$$scope={dirty:_,ctx:o}),Vo.$set(Ai);const la={};_&2&&(la.$$scope={dirty:_,ctx:o}),Yo.$set(la);const zi={};_&2&&(zi.$$scope={dirty:_,ctx:o}),Zo.$set(zi);const Ua={};_&2&&(Ua.$$scope={dirty:_,ctx:o}),en.$set(Ua);const Ii={};_&2&&(Ii.$$scope={dirty:_,ctx:o}),tn.$set(Ii);const Li={};_&2&&(Li.$$scope={dirty:_,ctx:o}),nn.$set(Li);const It={};_&2&&(It.$$scope={dirty:_,ctx:o}),sn.$set(It);const Oi={};_&2&&(Oi.$$scope={dirty:_,ctx:o}),an.$set(Oi);const Ni={};_&2&&(Ni.$$scope={dirty:_,ctx:o}),rn.$set(Ni);const Di={};_&2&&(Di.$$scope={dirty:_,ctx:o}),dn.$set(Di);const da={};_&2&&(da.$$scope={dirty:_,ctx:o}),cn.$set(da);const Si={};_&2&&(Si.$$scope={dirty:_,ctx:o}),hn.$set(Si);const Bi={};_&2&&(Bi.$$scope={dirty:_,ctx:o}),un.$set(Bi)},i(o){bl||($(l.$$.fragment,o),$(j.$$.fragment,o),$(ee.$$.fragment,o),$(ue.$$.fragment,o),$(bn.$$.fragment,o),$(kn.$$.fragment,o),$($n.$$.fragment,o),$(Pn.$$.fragment,o),$(Qn.$$.fragment,o),$(Hn.$$.fragment,o),$(Po.$$.fragment,o),$(Rn.$$.fragment,o),$(Vn.$$.fragment,o),$(Zn.$$.fragment,o),$(Eo.$$.fragment,o),$(jo.$$.fragment,o),$(xo.$$.fragment,o),$(es.$$.fragment,o),$(ts.$$.fragment,o),$(ss.$$.fragment,o),$(Jo.$$.fragment,o),$(Mo.$$.fragment,o),$(qo.$$.fragment,o),$(as.$$.fragment,o),$(rs.$$.fragment,o),$(ds.$$.fragment,o),$(Ao.$$.fragment,o),$(zo.$$.fragment,o),$(Io.$$.fragment,o),$(Lo.$$.fragment,o),$(cs.$$.fragment,o),$(ps.$$.fragment,o),$(ms.$$.fragment,o),$(No.$$.fragment,o),$(Do.$$.fragment,o),$(So.$$.fragment,o),$(fs.$$.fragment,o),$(gs.$$.fragment,o),$(Uo.$$.fragment,o),$(vs.$$.fragment,o),$(Wo.$$.fragment,o),$(Qo.$$.fragment,o),$(ws.$$.fragment,o),$(bs.$$.fragment,o),$(Ko.$$.fragment,o),$(Fs.$$.fragment,o),$(Ro.$$.fragment,o),$(Vo.$$.fragment,o),$(Es.$$.fragment,o),$(js.$$.fragment,o),$(Yo.$$.fragment,o),$(Ms.$$.fragment,o),$(Zo.$$.fragment,o),$(en.$$.fragment,o),$(tn.$$.fragment,o),$(qs.$$.fragment,o),$(Cs.$$.fragment,o),$(nn.$$.fragment,o),$(Ls.$$.fragment,o),$(sn.$$.fragment,o),$(an.$$.fragment,o),$(rn.$$.fragment,o),$(Os.$$.fragment,o),$(Ns.$$.fragment,o),$(Ks.$$.fragment,o),$(dn.$$.fragment,o),$(cn.$$.fragment,o),$(Rs.$$.fragment,o),$(Vs.$$.fragment,o),$(sa.$$.fragment,o),$(hn.$$.fragment,o),$(un.$$.fragment,o),bl=!0)},o(o){P(l.$$.fragment,o),P(j.$$.fragment,o),P(ee.$$.fragment,o),P(ue.$$.fragment,o),P(bn.$$.fragment,o),P(kn.$$.fragment,o),P($n.$$.fragment,o),P(Pn.$$.fragment,o),P(Qn.$$.fragment,o),P(Hn.$$.fragment,o),P(Po.$$.fragment,o),P(Rn.$$.fragment,o),P(Vn.$$.fragment,o),P(Zn.$$.fragment,o),P(Eo.$$.fragment,o),P(jo.$$.fragment,o),P(xo.$$.fragment,o),P(es.$$.fragment,o),P(ts.$$.fragment,o),P(ss.$$.fragment,o),P(Jo.$$.fragment,o),P(Mo.$$.fragment,o),P(qo.$$.fragment,o),P(as.$$.fragment,o),P(rs.$$.fragment,o),P(ds.$$.fragment,o),P(Ao.$$.fragment,o),P(zo.$$.fragment,o),P(Io.$$.fragment,o),P(Lo.$$.fragment,o),P(cs.$$.fragment,o),P(ps.$$.fragment,o),P(ms.$$.fragment,o),P(No.$$.fragment,o),P(Do.$$.fragment,o),P(So.$$.fragment,o),P(fs.$$.fragment,o),P(gs.$$.fragment,o),P(Uo.$$.fragment,o),P(vs.$$.fragment,o),P(Wo.$$.fragment,o),P(Qo.$$.fragment,o),P(ws.$$.fragment,o),P(bs.$$.fragment,o),P(Ko.$$.fragment,o),P(Fs.$$.fragment,o),P(Ro.$$.fragment,o),P(Vo.$$.fragment,o),P(Es.$$.fragment,o),P(js.$$.fragment,o),P(Yo.$$.fragment,o),P(Ms.$$.fragment,o),P(Zo.$$.fragment,o),P(en.$$.fragment,o),P(tn.$$.fragment,o),P(qs.$$.fragment,o),P(Cs.$$.fragment,o),P(nn.$$.fragment,o),P(Ls.$$.fragment,o),P(sn.$$.fragment,o),P(an.$$.fragment,o),P(rn.$$.fragment,o),P(Os.$$.fragment,o),P(Ns.$$.fragment,o),P(Ks.$$.fragment,o),P(dn.$$.fragment,o),P(cn.$$.fragment,o),P(Rs.$$.fragment,o),P(Vs.$$.fragment,o),P(sa.$$.fragment,o),P(hn.$$.fragment,o),P(un.$$.fragment,o),bl=!1},d(o){t(d),o&&t(y),o&&t(u),F(l),o&&t(M),o&&t(C),F(j),o&&t(ye),o&&t(B),o&&t(ve),o&&t(Q),o&&t(z),o&&t(me),o&&t(we),o&&t(fe),o&&t(be),F(ee,o),o&&t(I),o&&t(ae),o&&t(Re),o&&t(W),F(ue),o&&t(Ui),o&&t(bo),o&&t(Wi),F(bn,o),o&&t(Qi),o&&t(ua),o&&t(Hi),F(kn,o),o&&t(Ki),o&&t(Rt),F($n),o&&t(Ri),o&&t(ma),o&&t(Vi),F(Pn,o),o&&t(Xi),o&&t(re),o&&t(Yi),o&&t(ya),o&&t(Zi),o&&t(Nt),o&&t(el),o&&t(Vt),F(Qn),o&&t(tl),o&&t(qt),F(Hn),F(Po),o&&t(ol),o&&t(Xt),F(Rn),o&&t(nl),o&&t(Ct),F(Vn),F(Zn),F(Eo),F(jo),F(xo),o&&t(sl),o&&t(Zt),F(es),o&&t(al),o&&t(Tt),F(ts),F(ss),F(Jo),F(Mo),F(qo),o&&t(rl),o&&t(to),F(as),o&&t(il),o&&t(Ue),F(rs),F(ds),F(Ao),F(zo),F(Io),F(Lo),o&&t(ll),o&&t(no),F(cs),o&&t(dl),o&&t(vt),F(ps),F(ms),F(No),F(Do),F(So),o&&t(cl),o&&t(ro),F(fs),o&&t(pl),o&&t(We),F(gs),F(Uo),F(vs),F(Wo),F(Qo),o&&t(hl),o&&t(lo),F(ws),o&&t(ul),o&&t(Qe),F(bs),F(Ko),F(Fs),F(Ro),F(Vo),o&&t(ml),o&&t(po),F(Es),o&&t(fl),o&&t(_e),F(js),F(Yo),F(Ms),F(Zo),F(en),F(tn),o&&t(gl),o&&t(uo),F(qs),o&&t(_l),o&&t(He),F(Cs),F(nn),F(Ls),F(sn),F(an),F(rn),o&&t(Tl),o&&t(go),F(Os),o&&t(yl),o&&t(Oe),F(Ns),F(Ks),F(dn),F(cn),o&&t(vl),o&&t(To),F(Rs),o&&t(wl),o&&t(Ne),F(Vs),F(sa),F(hn),F(un)}}}const IT={local:"gptj",sections:[{local:"overview",sections:[{local:"generation",title:"Generation"}],title:"Overview"},{local:"resources",title:"Resources"},{local:"transformers.GPTJConfig",title:"GPTJConfig"},{local:"transformers.GPTJModel",title:"GPTJModel"},{local:"transformers.GPTJForCausalLM",title:"GPTJForCausalLM"},{local:"transformers.GPTJForSequenceClassification",title:"GPTJForSequenceClassification"},{local:"transformers.GPTJForQuestionAnswering",title:"GPTJForQuestionAnswering"},{local:"transformers.TFGPTJModel",title:"TFGPTJModel"},{local:"transformers.TFGPTJForCausalLM",title:"TFGPTJForCausalLM"},{local:"transformers.TFGPTJForSequenceClassification",title:"TFGPTJForSequenceClassification"},{local:"transformers.TFGPTJForQuestionAnswering",title:"TFGPTJForQuestionAnswering"},{local:"transformers.FlaxGPTJModel",title:"FlaxGPTJModel"},{local:"transformers.FlaxGPTJForCausalLM",title:"FlaxGPTJForCausalLM"}],title:"GPT-J"};function LT(x){return oT(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class QT extends Y_{constructor(d){super();Z_(this,d,LT,zT,eT,{})}}export{QT as default,IT as metadata};
